Package: MOSClip
Title: Multi Omics Survival Clip
Version: 1.4.0
Depends: R (>= 4.4.0)
Authors@R: c(
   person(given = "Paolo", family = "Martini", role = c("aut", "cre"),
          email = "paolo.martini@unibs.it",
          comment = c(ORCID = "0000-0002-0146-1031")),
   person(given = "Anna", family = "Bortolato", role = c("aut"),
           email = "anna.bortolato@unipd.it",
           comment = c(ORCID = "0009-0009-9327-6084")),
   person(given = "Anna", family = "Tanada", role = c("aut"),
           email = "annacarolinaemi.delimatanada@phd.unipd.it",
           comment = c(ORCID = "0000-0003-3224-0538")),
   person(given = "Enrica", family = "Calura", role = c("aut"),
          email = "enrica.calura@unipd.it",
          comment = c(ORCID = "0000-0001-8463-2432")),
   person(given = "Stefania", family = "Pirrotta", role = c("aut"),
          email = "stefania.pirrotta@phd.unipd.it",
          comment = c(ORCID = "0009-0004-0030-217X")),
   person(given = "Federico", family = "Agostinis", role = c("aut"),
          email = "federico.agostinis@outlook.com")
   )
Description: Topological pathway analysis tool able to integrate multi-omics data. It finds survival-associated modules or significant modules for two-class analysis. This tool have two main methods: pathway tests and module tests. The latter method allows the user to dig inside the pathways itself.
License: AGPL-3
Imports: MultiAssayExperiment, methods, survminer, graph, graphite,
        AnnotationDbi, checkmate, ggplot2, gridExtra, igraph, pheatmap,
        survival, RColorBrewer, SuperExactTest, reshape, NbClust,
        S4Vectors, grDevices, graphics, stats, utils, ComplexHeatmap,
        FactoMineR, circlize, corpcor, coxrobust, elasticnet, gRbase,
        ggplotify, qpgraph, org.Hs.eg.db, Matrix
Suggests: RUnit, BiocGenerics, MASS, BiocStyle, knitr, EDASeq,
        rmarkdown, kableExtra, testthat (>= 3.0.0)
Encoding: UTF-8
LazyData: false
biocViews: Software, StatisticalMethod, GraphAndNetwork, Survival,
        Regression, DimensionReduction, Pathways, Reactome
BugReports: https://github.com/CaluraLab/MOSClip/issues
URL: https://github.com/CaluraLab/MOSClip/
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/MOSClip
git_branch: RELEASE_3_22
git_last_commit: b231f21
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 05:13:43 UTC; biocbuild
Author: Paolo Martini [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-0146-1031>),
  Anna Bortolato [aut] (ORCID: <https://orcid.org/0009-0009-9327-6084>),
  Anna Tanada [aut] (ORCID: <https://orcid.org/0000-0003-3224-0538>),
  Enrica Calura [aut] (ORCID: <https://orcid.org/0000-0001-8463-2432>),
  Stefania Pirrotta [aut] (ORCID:
    <https://orcid.org/0009-0004-0030-217X>),
  Federico Agostinis [aut]
Maintainer: Paolo Martini <paolo.martini@unibs.it>

#' Get available Omics Summarizing Methods
#'
#' Gives a vector of the available methods to summarize omics.
#'
#' @return character vector with the implemented methods.
#'
#' @examples
#' availableOmicMethods()
#'
#' @export
availableOmicMethods <- function() {
    return(c(
        "summarizeToBinaryEvents", "summarizeToNumberOfEvents",
        "summarizeWithPca", "summarizeInCluster",
        "summarizeToBinaryDirectionalEvents",
        "summarizeToNumberOfDirectionalEvents"
    ))
}

#' Summarize To Binary Events
#'
#' Given a matrix it summarize to a 0 or 1
#'
#' @param data a data matrix
#' @param features a vector with the features to analyze
#' @param name prefix of the covariates
#' @param binaryClassMin the minimum number of event to include the covariate
#' @param cliques the features organized in cliques. Only use for topology
#'
#' @return a list with summary of the omic:
#'  \item{x}{summary of the omic for each sample}
#'  \item{usedGenes}{genes list of genes used to calculate the summary}
#'  \item{namesCov}{names of the covariates}
#'  \item{method}{method used for the analysis}
#'  \item{omicName}{name of the omic}
#'  \item{evenThr}{threshold fot event counting}

summarizeToBinaryEvents <- function(
    data, features, name = "bin", binaryClassMin = 10,
    cliques = NULL) {
    if (is.null(data)) {
        return(NULL)
    }

    genes <- intersect(row.names(data), features)
    if (length(genes) == 0) {
        return(NULL)
    }

    dataClique <- t(data[genes, , drop = FALSE])
    if (ncol(dataClique) == 0) {
        return(NULL)
    }

    collapsed <- apply(dataClique > 0, 1, any, na.rm = TRUE)

    if (sum(collapsed) < binaryClassMin |
        sum(collapsed) > NROW(dataClique) - binaryClassMin) {
        return(NULL)
    }

    collapsed <- data.frame(collapsed,
        row.names = names(collapsed),
        stringsAsFactors = FALSE
    )
    colnames(collapsed) <- name
    list(
        x = collapsed, usedGenes = genes, namesCov = name, method = "binary",
        omicName = name,
        eventThr = 1
    )
}

#' Summarize To Number of Binary Events
#'
#' Given a matrix it summarize to a 0 or 1
#'
#' @inheritParams summarizeToBinaryEvents
#' @param min_prop minimal proportion in classes
#'
#' @return a list with summary of the omic:
#'  \item{x}{summary of the omic for each sample}
#'  \item{usedGenes}{genes list of genes used to calculate the summary}
#'  \item{namesCov}{names of the covariates}
#'  \item{method}{method used for the analysis}
#'  \item{omicName}{name of the omic}
#'  \item{evenThr}{threshold fot event counting}
#'  \item{min_prop}{minimum proportion of samples to exclude to check the
#'  variability of values}

summarizeToNumberOfEvents <- function(
    data, features, name = "event", min_prop = 0.1,
    cliques = NULL) {
    if (is.null(data)) {
        return(NULL)
    }

    genes <- intersect(row.names(data), features)
    if (length(genes) == 0) {
        return(NULL)
    }

    dataClique <- t(data[genes, , drop = FALSE])
    if (ncol(dataClique) == 0) {
        return(NULL)
    }

    collapsed <- apply(dataClique > 0, 1, sum, na.rm = TRUE)

    keep <- check_minimal_proportion(collapsed, min_prop = min_prop)
    if (!keep) {
        return(NULL)
    }

    collapsed <- data.frame(collapsed,
        row.names = names(collapsed),
        stringsAsFactors = FALSE
    )
    colnames(collapsed) <- name
    list(
        x = collapsed, usedGenes = genes, namesCov = name, method = "count",
        omicName = name, eventThr = 1, min_prop = min_prop
    )
}

#' Summarize Using Cluster Analysis
#'
#' Given a matrix it summarize in classes
#'
#' The user can define a maximum of classes. The function
#' guess the optimal number of clusters using NbClust methods.
#'
#' @inheritParams summarizeToBinaryEvents
#' @param dictionary translate features (genes) into sets
#' (row.names of the data)
#' @param max_cluster_number the maximum number of cluster to evaluate
#'
#' @return a list with summary of the omic:
#'  \item{x}{summary of the omic for each sample}
#'  \item{usedGenes}{genes list of genes used to calculate the summary}
#'  \item{namesCov}{names of the covariates}
#'  \item{cls}{the genes in clusters}
#'  \item{method}{method used for the analysis}
#'  \item{omicName}{name of the omic}
#'
#' @importFrom stats cutree dist hclust
#' @importFrom NbClust NbClust

summarizeInCluster <- function(
    data, features, name = "clu", dictionary = NULL, max_cluster_number = 3,
    cliques = NULL) {
    if (is.null(data) || (ncol(data) == 0) || !(is.matrix(data))) {
        return(NULL)
    }

    if (is.null(dictionary)) {
        genes <- intersect(rownames(data), features)
        if (length(genes) == 0) {
            return(NULL)
        }
        used <- genes
        names(used) <- genes
        datamatClique <- t(data[genes, , drop = FALSE])
    } else {
        genes <- intersect(names(dictionary), features)
        if (length(genes) == 0) {
            return(NULL)
        }
        used <- dictionary[genes]
        clusters <- unlist(dictionary[genes])
        clusters <- intersect(clusters, row.names(data))
        if (length(clusters) == 0) {
            return(NULL)
        }
        datamatClique <- t(data[clusters, , drop = FALSE])
    }

    if (ncol(datamatClique) == 0) {
        return(NULL)
    }

    ## CREATE CLUSTERS
    covs <- createOptiomalClusterClasses(datamatClique, name,
        max_cluster_number = max_cluster_number
    )

    if (any(table(covs[[1]]) < 2)) {
        warning("Not meaningful class separation\n")
        return(NULL)
    }

    collapse <- covs
    list(
        x = collapse, usedGenes = names(used), namesCov = names(covs),
        cls = used, method = "cluster", omicName = name
    )
}

createOptiomalClusterClasses <- function(
    datamatClique, name, max_cluster_number,
    index_method = "silhouette") {
    nb <- sinkNbClust(
        data = datamatClique, min.nc = 2, max.nc = max_cluster_number,
        method = "ward.D2", index = index_method
    )
    covs <- data.frame(factor(nb$Best.partition), stringsAsFactors = TRUE)
    optimalCLusterNumber <- length(table(nb$Best.partition))
    names(covs) <- paste0(name, optimalCLusterNumber, "k")
    covs
}

#' @importFrom grDevices dev.off pdf
#'
sinkNbClust <- function(data, min.nc = 2, max.nc = 6, method = "ward.D2",
                        index = "silhouette") {
    if (index == "all") {
        sink(file = tempfile())
    }
    pdf(file = NULL)

    nb <- NbClust(
        data = data, min.nc = min.nc, max.nc = max.nc, method = method,
        index = index
    )

    if (index == "all") {
        sink()
    }
    dev.off()

    return(nb)
}


#' Summarize Using PCA
#'
#' Given a matrix it summarize to principal components.
#' The user can specify the number of principal components. Default 3.
#'
#' @inheritParams summarizeToBinaryEvents
#' @param shrink shirnk or not the covariance matrix.
#' @param method either 'regular', 'sparse' or 'topological'
#' @param cliques the features organized in cliques. Only use for topology.
#' @param maxPCs maximum number of pcs to consider
#' @param loadThr loading threshold
#'
#' @return a list with summary of the omic:
#'  \item{x}{summary of the omic for each sample (principal components)}
#'  \item{sdev}{standard deviation of the principal components}
#'  \item{loadings}{loadings of PCA}
#'  \item{usedGenes}{genes list of genes used to calculate the summary}
#'  \item{namesCov}{names of the covariates}
#'  \item{method}{method used for the analysis}
#'  \item{omicName}{name of the omic}
#'
#' @importFrom stats sd

summarizeWithPca <- function(
    data, features, name = "pca", shrink = FALSE, method = "regular",
    cliques = NULL, maxPCs = 3, loadThr = 0.6) {
    if (is.null(data)) {
        return(NULL)
    }

    genes <- intersect(row.names(data), features)
    if (length(genes) == 0) {
        return(NULL)
    }

    dataClique <- t(data[genes, , drop = FALSE])
    if (ncol(dataClique) == 0) {
        return(NULL)
    }

    if (NCOL(dataClique) != 1) {
        pcs <- computePCs(dataClique,
            shrink = shrink, method = method, cliques = cliques,
            maxPCs = maxPCs
        )
        colnames(pcs$x) <- paste0(name, colnames(pcs$x))
        names(pcs$sdev) <- paste0(name, names(pcs$sdev))
        colnames(pcs$loadings) <- paste0(name, colnames(pcs$loadings))
    } else {
        colnames(dataClique) <- paste0(name, "PC1")
        pcs <- list(x = dataClique, sdev = sd(dataClique), loadings = 1)
    }

    pcs$usedGenes <- genes
    pcs$method <- "pca"
    pcs$namesCov <- colnames(pcs$x)
    pcs$omicName <- name
    pcs
}

#' Summarize With Directed Sum
#'
#' Given a matrix it summarize the positive and negative in two vectors,
#' with counts of the events
#'
#' @inheritParams summarizeToNumberOfEvents
#' @param eventThr the absolute value to threshold an event
#'
#' @return a list with summary of the omic:
#'  \item{x}{summary of the omic for each sample}
#'  \item{usedGenes}{genes list of genes used to calculate the summary}
#'  \item{namesCov}{names of the covariates}
#'  \item{method}{method used for the analysis}
#'  \item{omicName}{name of the omic}
#'  \item{evenThr}{threshold fot event counting}
#'  \item{min_prop}{minimum proportion of samples to exclude to check the
#'  variability of values}

summarizeToNumberOfDirectionalEvents <- function(
    data, features, name = "dCount",
    eventThr = 2, min_prop = 0.1, cliques = NULL) {
    if (is.null(data)) {
        return(NULL)
    }

    genes <- intersect(row.names(data), features)
    if (length(genes) == 0) {
        return(NULL)
    }

    dataClique <- t(data[genes, , drop = FALSE])
    if (ncol(dataClique) == 0) {
        return(NULL)
    }

    posDataClique <- extractPositivePortion(dataClique)
    negDataClique <- extractPositivePortion(dataClique, invert = TRUE)

    positive <- apply(posDataClique >= eventThr, 1, sum, na.rm = TRUE)
    negative <- apply(negDataClique >= eventThr, 1, sum, na.rm = TRUE)

    collapsed <- data.frame(
        positive = positive, negative = negative, row.names = names(positive),
        stringsAsFactors = FALSE
    )
    colnames(collapsed) <- paste0(name, c("POS", "NEG"))

    keep <- vapply(collapsed, function(x) {
        check_minimal_proportion(x, min_prop = min_prop)
    }, logical(1))
    collapsed <- collapsed[, keep, drop = FALSE]

    if (NCOL(collapsed) == 0) {
        return(NULL)
    }
    list(
        x = collapsed, usedGenes = genes, namesCov = names(collapsed),
        method = "directedCount",
        omicName = name, eventThr = eventThr, min_prop = min_prop
    )
}

#' @importFrom stats quantile
check_minimal_proportion <- function(x, min_prop = 0.1) {
    min <- quantile(x, probs = c(min_prop))
    max <- quantile(x, probs = c(1 - min_prop))
    if ((min == min(x)) && (max == min(x))) {
        return(FALSE)
    }

    if ((min == max(x)) && (max == max(x))) {
        return(FALSE)
    }

    TRUE
}

#' Summarize To Binary Directional Events
#'
#' Given a matrix it summarize the positive and negative to 0 or 1
#'  in two vectors
#'
#' @inheritParams summarizeToNumberOfDirectionalEvents
#' @inheritParams summarizeToBinaryEvents
#'
#' @return a list with summary of the omic:
#'  \item{x}{summary of the omic for each sample}
#'  \item{usedGenes}{genes list of genes used to calculate the summary}
#'  \item{namesCov}{names of the covariates}
#'  \item{method}{method used for the analysis}
#'  \item{omicName}{name of the omic}
#'  \item{evenThr}{threshold fot event counting}
#'
summarizeToBinaryDirectionalEvents <- function(
    data, features, name = "dirBin", binaryClassMin = 10,
    eventThr = 2, cliques = NULL) {
    if (is.null(data)) {
        return(NULL)
    }

    genes <- intersect(row.names(data), features)
    if (length(genes) == 0) {
        return(NULL)
    }

    dataClique <- t(data[genes, , drop = FALSE])
    if (ncol(dataClique) == 0) {
        return(NULL)
    }

    posDataClique <- extractPositivePortion(dataClique)
    negDataClique <- extractPositivePortion(dataClique, invert = TRUE)

    positive <- apply(posDataClique >= eventThr, 1, any, na.rm = TRUE)
    negative <- apply(negDataClique >= eventThr, 1, any, na.rm = TRUE)

    collapsed <- data.frame(
        positive = positive, negative = negative, row.names = names(positive),
        stringsAsFactors = FALSE
    )
    colnames(collapsed) <- paste0(name, c("POS", "NEG"))


    keep <- vapply(collapsed, sum, as.numeric(1)) >= binaryClassMin | vapply(
        collapsed,
        sum, as.numeric(1)
    ) <= NROW(dataClique) - binaryClassMin
    collapsed <- collapsed[, keep, drop = FALSE]

    if (NCOL(collapsed) == 0) {
        return(NULL)
    }
    list(
        x = collapsed, usedGenes = genes, namesCov = names(collapsed),
        method = "directedBinary",
        omicName = name, eventThr = eventThr
    )
}

test_that(
    "summarizeToBinaryEvents", {
        mat <- dummy_mutation_like_dataset()
        res <- summarizeToBinaryEvents(
            mat, features = c(
                "gene_1", "gene_2",
                "gene_3"
            )
        )
        expect_type(res$x[[1]], "logical")
        res <- summarizeToBinaryEvents(data = NULL)
        expect_null(res)
        res <- summarizeToBinaryEvents(mat, features = c("gene_x"))
        expect_null(res)
    }
)


test_that(
    "summarizeToNumberOfEvents", {
        mat <- dummy_mutation_like_dataset()
        res <- summarizeToNumberOfEvents(
            mat, features = c(
                "gene_1", "gene_2",
                "gene_3"
            )
        )
        expect_type(res$x[[1]], "integer")
        res <- summarizeToNumberOfEvents(data = NULL)
        expect_null(res)
        res <- summarizeToNumberOfEvents(mat, features = c("gene_x"))
        expect_null(res)
    }
)


test_that(
    "summarizeInCluster", {
        mat <- dummy_methylation_like_dataset()
        res <- summarizeInCluster(
            mat, features = c(
                "gene_1", "gene_2",
                "gene_3"
            )
        )
        expect_type(res$x[[1]], "integer")
        res <- summarizeInCluster(data = NULL)
        expect_null(res)
        res <- summarizeInCluster(mat, features = c("gene_x"))
        expect_null(res)
    }
)


test_that(
    "summarizeWithPca", {
        mat <- dummy_expression_like_dataset()
        res <- summarizeWithPca(mat, features = c("gene_1", "gene_2", "gene_3"))
        expect_type(res$x[[1]], "double")
        res <- summarizeInCluster(data = NULL)
        expect_null(res)
        res <- summarizeInCluster(mat, features = c("gene_x"))
        expect_null(res)
    }
)


test_that(
    "summarizeToNumberOfDirectionalEvents",
    {
        mat <- dummy_cnv_like_dataset()
        res <- summarizeToNumberOfDirectionalEvents(
            mat, features = c(
                "gene_1", "gene_2",
                "gene_3"
            )
        )
        expect_type(res$x[[1]], "integer")
        res <- summarizeToNumberOfDirectionalEvents(data = NULL)
        expect_null(res)
        res <- summarizeToNumberOfDirectionalEvents(mat, features = c("gene_x"))
        expect_null(res)
    }
)


test_that(
    "summarizeToBinaryDirectionalEvents",
    {
        mat <- dummy_cnv_like_dataset()
        res <- summarizeToBinaryDirectionalEvents(
            mat, features = c(
                "gene_1", "gene_2",
                "gene_3"
            )
        )
        expect_type(res$x[[1]], "logical")
        res <- summarizeToBinaryDirectionalEvents(data = NULL)
        expect_null(res)
        res <- summarizeToBinaryDirectionalEvents(mat, features = c("gene_x"))
        expect_null(res)
    }
)

test_that(
    "clusterWithDict", {
        fake_data <- dummy_methylation_like_dataset()
        dict <- create_met_cluster_dict(fake_data)
        name = "cls"
        cls <- summarizeInCluster(
            fake_data, features = row.names(fake_data),
            name = name
        )
        clsDict <- summarizeInCluster(
            fake_data, features = row.names(fake_data),
            dictionary = dict, name = name
        )
        expect_equal(cls$namesCov, paste0(name, "3k"))
        expect_identical(cls$x, clsDict$x)
    }
)

test_that(
    "emptyInput", {
        expect_null(
            summarizeInCluster(
                data = NULL,
                features = row.names(fake_data)
            )
        )
    }
)

test_that(
    "singleProfileInput2class", {
        flat_data <- dummy_methylation_like_flat_dataset()
        name = "cls"
        cls <- summarizeInCluster(
            flat_data, features = row.names(flat_data),
            name = name
        )
        expect_equal(cls$namesCov, paste0(name, "2k"))
    }
)

test_that(
    "notIntersectionOfGenes", {
        flat_data <- dummy_methylation_like_flat_dataset()
        expect_null(summarizeInCluster(flat_data, features = "gene_2"))
    }
)

test_that(
    "computePCs", {
        fake_exp <- dummy_expression_like_dataset()
        pcs <- summarizeWithPca(
            fake_exp, features = row.names(fake_exp),
            name = "pca", shrink = FALSE, method = "regular", cliques = NULL,
            maxPCs = 10, loadThr = 0.6
        )
        pcsS <- summarizeWithPca(
            fake_exp, features = row.names(fake_exp),
            name = "pca", shrink = FALSE, method = "sparse", cliques = NULL,
            maxPCs = 10, loadThr = 0.6
        )
        pcsT <- summarizeWithPca(
            fake_exp, features = row.names(fake_exp),
            name = "pca", shrink = FALSE, method = "topological",
            cliques = list(
                row.names(fake_exp),
                row.names(fake_exp)[5]
            ),
            maxPCs = 10, loadThr = 0.6
        )
        expect_equal(
            dim(pcs$x),
            c(200, 2)
        )
        expect_equal(
            dim(pcsS$x),
            c(200, 2)
        )
        expect_equal(
            dim(pcsT$x),
            c(200, 2)
        )
    }
)

test_that(
    "cnv", {
        fake_cnv <- dummy_cnv_like_dataset()
        summary_cnvbin <- summarizeToBinaryDirectionalEvents(
            fake_cnv,
            row.names(fake_cnv)
        )
        summary_cnv <- summarizeToNumberOfDirectionalEvents(
            fake_cnv,
            row.names(fake_cnv)
        )

        expect_identical(
            summary_cnvbin$x$dirBinPOS,
            unname(
                apply(
                  fake_cnv >
                    1,
                  2, any,
                  na.rm = T
              )
            )
        )
        expect_identical(
            summary_cnvbin$x$dirBinNEG,
            unname(
                apply(
                  fake_cnv <
                    -1,
                  2, any,
                  na.rm = T
              )
            )
        )
        expect_identical(
            summary_cnv$x$dCountPOS,
            unname(
                apply(
                  fake_cnv >
                    1,
                  2, sum,
                  na.rm = T
              )
            )
        )
        expect_identical(
            summary_cnv$x$dCountNEG,
            unname(
                apply(
                  fake_cnv <
                    -1,
                  2, sum,
                  na.rm = T
              )
            )
        )
    }
)

test_that(
    "mut", {
        fake_mut <- dummy_mutation_like_dataset()
        summary_mutbin <- summarizeToBinaryEvents(fake_mut, row.names(fake_mut))
        summary_mut <- summarizeToNumberOfEvents(fake_mut, row.names(fake_mut))

        expect_identical(
            summary_mut$x$event, unname(
                apply(
                  fake_mut == 1, 2, sum,
                  na.rm = T
              )
            )
        )
        expect_identical(
            summary_mutbin$x$bin, unname(
                apply(
                  fake_mut == 1, 2, any,
                  na.rm = T
              )
            )
        )
    }
)

#' Extract the maximal cliques
#'
#' For internal use only. Extract the cliques.
#'
#' @param dag a Directed Aciclic Graph
#' @param root a node to use as root
#'
#' @return list of nodes cliques
#'
#' @importFrom methods as
#' @importFrom gRbase is.DAG moralize triangulate rip
#' @importFrom checkmate assertClass
#' @importFrom Matrix diag
#' @rdname graph-processing
extractCliquesFromDag <- function(dag, root = NULL) {
    checkmate::assertClass(dag, "graphNEL")
    idag <- igraph::graph_from_graphnel(dag)
    if (sum(Matrix::diag(igraph::as_adjacency_matrix(idag))) != 0) {
        dag <- removeSelfLoops(dag)
        idag <- igraph::graph_from_graphnel(dag)
    }

    if (gRbase::is.DAG(idag)) {
        moral <- gRbase::moralize(idag)
    } else {
        moral <- mmmoralize(idag)
    }

    tg <- gRbase::triangulate(moral)
    ripped <- gRbase::rip(tg, root = root)
    if (length(ripped) == 0) {
        warning("This graph ", dag@title, "have 0 cliques")
        return(NULL)
    }

    ripped$cliques
}

#' Remove self loops from a graphNEL
#'
#' Remove the self loops that a present in the graph graphNEL object
#'
#' @param graph a graphNEL object
#'
#' @return a graphNEL object
#'
#'#' @rdname  graph-processing
#'
#' @importClassesFrom graph graphNEL
#' @importFrom checkmate assertClass
#'
removeSelfLoops <- function(graph) {
    checkmate::assertClass(graph, "graphNEL")
    edgeL <- graph@edgeL
    for (i in seq_along(edgeL)) {
        pos <- match(i, edgeL[[i]]$edges)
        if (!(is.na(pos)))
            edgeL[[i]]$edges <- edgeL[[i]]$edges[-pos]
    }
    graph@edgeL <- edgeL
    return(graph)
}

#' Moralize
#'
#' For internal use only. Force Moralization
#'
#' @inheritParams removeSelfLoops
#'
#' @importClassesFrom graph graphNEL
#' @importFrom gRbase moralizeMAT coerceGraph
#' @rdname graph-processing
#'
mmmoralize <- function(graph) {
    m <- igraph::as_adjacency_matrix(graph, sparse = FALSE)
    m <- gRbase::moralizeMAT(m)
    g <- igraph::graph_from_adjacency_matrix(m, mode = "directed")
    g
}

#' Plot heatmaps of the pathway by omics
#'
#' Given the pathway, it creates the heatmaps of the mostly involved genes for
#' each omic.
#'
#' @param pathway `MultiOmicsPathway` class object
#' @param sortBy one or more covariates to sort the samples
#' @param paletteNames name of the colors for each omic
#' @param additionalAnnotations optional additional sample annotations
#' (e.g. survival annotation)
#' @param additionalPaletteNames colors for additional annotations. The colors
#' available are the ones in \code{\link{showMOSpalette}}
#' @param discr_prop_pca the minimal proportion to compute the PCA classes
#' @param discr_prop_events the minimal proportion to compute the event classes
#' @param withSampleNames show the sample names in the plot
#' @param nrowsHeatmaps magnification respect to annotation of sample
#' (annotations take 1 row)
#' @param orgDbi a Dbi organism to be used. Default is `org.Hs.eg.db`
#' @param ... additional arguments passed to `guessInvolvementPathway` function
#' (internal use)
#'
#' @return An object of class `ggplot` plotted with ComplexHeatMap package.
#'
#' @examples
#' data(multiOmics)
#' data(reactSmall)
#'
#' genesToUse <- row.names(multiOmics[[1]])
#'
#' survAnnot <- data.frame(
#'     status = multiOmics$status,
#'     days = multiOmics$days,
#'     row.names = colnames(multiOmics[[1]])
#' )
#'
#' # Creating the MultiOmicsPathway object
#' MOP_survival <- multiOmicsSurvivalPathwayTest(multiOmics, reactSmall[[1]],
#'     survFormula = "Surv(days, status) ~", autoCompleteFormula = TRUE,
#'     useTheseGenes = genesToUse
#' )
#'
#' # Plotting
#' plotPathwayHeat(MOP_survival,
#'     sortBy = c("expPC2", "mut", "status", "days"),
#'     paletteNames = c(exp = "red", met = "green", 
#'                      mut = "blue", cnv = "yellow"),
#'     additionalAnnotations = survAnnot,
#'     additionalPaletteNames = list(status = "teal", days = "violet"),
#'     nrowsHeatmaps = 2, withSampleNames = F
#' )
#'
#' @importFrom checkmate assertClass
#' @importFrom grid gpar grid.newpage grid.draw rectGrob
#' @importFrom ComplexHeatmap Heatmap HeatmapAnnotation '%v%' draw
#' @importFrom stats relevel
#' @importFrom ggplotify as.ggplot
#' @importFrom org.Hs.eg.db org.Hs.eg.db
#'
#' @export

plotPathwayHeat <- function(
    pathway, sortBy = NULL, paletteNames = NULL, additionalAnnotations = NULL,
    additionalPaletteNames = NULL, discr_prop_pca = 0.15,
    discr_prop_events = 0.05, withSampleNames = TRUE, nrowsHeatmaps = 3,
    orgDbi = "org.Hs.eg.db", ...) {
    checkmate::assertClass(pathway, "MultiOmicsPathway")

    involved <- guessInvolvementPathway(pathway,
        min_prop_pca = discr_prop_pca,
        min_prop_events = discr_prop_events,
        ...
    )

    if (length(paletteNames) != length(involved)) {
        repTimes <- ceiling(length(involved) / length(paletteNames))
        paletteNames <- rep(paletteNames, repTimes)[seq_along(involved)]
    }

    annotationFull <- formatAnnotations(involved, sortBy = NULL)
    idx <- which(unlist(lapply(annotationFull, class)) == "numeric")
    if (length(idx) > 0) {
        annotationFull[, idx] <- lapply(annotationFull[, idx], function(col) {
            stats::relevel(as.factor(col), ref = "1")
        })
    }

    omics <- guessOmics(colnames(annotationFull))
    if (is.null(paletteNames)) {
        paletteNames <- names(paletteNames)[seq_along(unique(omics))]
        paletteNames <- guessOmicsColors(omics)
    }

    if (length(paletteNames) != length(unique(omics))) {
        stop(paste0(
            "Length of MOcolors differs from the number of omics: ",
            paste(unique(omics), collapse = " ,")
        ))
    }

    if (is.null(names(paletteNames))) {
        names(paletteNames) <- unique(omics)
    }

    annotationPalettes <- paletteNames

    ann_col <- lapply(colnames(annotationFull), function(name) {
        omic <- guessOmic(name)
        if (!omic %in% names(annotationPalettes)) {
            stop("Missing omic in annotationPalettes")
        }
        discreteColor <- annotationPalettes[[omic]]
        values <- sort(unique(annotationFull[, name]))
        if (!is.null(levels(values))) {
            values <- levels(values)
        }
        if (length(values) == 1) {
            annot <- as.character(MOSpaletteSchema[discreteColor, c("smart")])
            names(annot) <- values
        } else if (length(values) == 2) {
            annot <- as.character(MOSpaletteSchema[
                discreteColor,
                c("smart", "light")
            ])
            names(annot) <- values
        } else if (length(table(annotationFull[, name])) == 3) {
            annot <- as.character(MOSpaletteSchema[
                discreteColor,
                c("dark", "smart", "light")
            ])
            names(annot) <- values
        } else {
            stop("I'm puzzled! Too many values to map")
        }
        annot
    })
    names(ann_col) <- colnames(annotationFull)

    if (!is.null(additionalAnnotations)) {
        additionalAnnotations <- matchAnnotations(
            annotationFull,
            additionalAnnotations
        )
        annotationFull <- cbind(annotationFull, additionalAnnotations)

        if (!is.null(additionalPaletteNames)) {
            add_ann_col <- lapply(colnames(additionalAnnotations), 
                                  function(name) {
                values <- sort(unique(additionalAnnotations[[name]]))
                discreteColor <- additionalPaletteNames[[name]]

                if (length(values) == 2) {
                    annot <- as.character(MOSpaletteSchema[
                        discreteColor,
                        c("smart", "light")
                    ])
                    names(annot) <- values
                } else if (length(table(annotationFull[, name])) == 3) {
                    annot <- as.character(MOSpaletteSchema[
                        discreteColor,
                        c("dark", "smart", "light")
                    ])
                    names(annot) <- values
                } else {
                    annot <- colorRamp2(
                        c(min(values), max(values)),
                        getContinousPalette(discreteColor, 2)
                    )
                    names(annot) <- levels(values)
                }
                annot
            })
            names(add_ann_col) <- colnames(additionalAnnotations)
            ann_col <- c(ann_col, add_ann_col)
        }
    }

    annotationFull <- sortAnnotations(annotationFull, sortBy)
    annotationFull <- annotationFull[, rev(colnames(annotationFull))]

    ha <- HeatmapAnnotation(df = annotationFull, col = ann_col)
    ht_list <- ha
    for (n in seq_along(involved)) {
        heatMatrix <- involved[[n]]$sigModule
        heatMatrix <- heatMatrix[, row.names(annotationFull), drop = FALSE]
        row.names(heatMatrix) <- conversionToSymbols(row.names(heatMatrix), 
                                                     orgDbi)
        Ht <- Heatmap(heatMatrix,
            cluster_columns = FALSE, cluster_rows = FALSE,
            show_column_names = FALSE,
            heatmap_legend_param = list(title = NULL),
            col = c("#FFFFFF",
                    rev(as.vector(ann_col[involved[[n]]$covsConsidered][[1]]))
                    )
            )
        ht_list <- ht_list %v% Ht
    }

    gb <- grid::grid.grabExpr(ComplexHeatmap::draw(ht_list,
        legend_grouping = "original"
    ))
    gb <- ggplotify::as.ggplot(gb)
    return(gb)
}

#' Plot Kaplan-Meier survival curves of a specific pathway
#'
#' Given a `MultiOmicsPathway` class object, it plots Kaplan-Meier curves,
#' in which the strata corresponds to the chosen omics
#'
#' @param pathway `MultiOmicsPathway` class object
#' @param formula a formula to compute the plot
#' @param fileName optional filenames to save the plot
#' @param paletteNames a palette containing three colors
#' @param h the height of the plot
#' @param w the width of the plot
#' @param risk.table logical value. If TRUE, shows the `risk.table`. Default
#' is TRUE.
#' @param pval logical value. Shows p-value of the curves
#' @param size line width of the KM curves
#' @param inYears logical value. If TRUE, converts days to years
#' @param discr_prop_pca the minimal proportion to compute the PCA classes
#' @param discr_prop_events the minimal proportion to compute the event classes
#' @param additional_discrete names of the additional discrete variables to
#' include
#' @param additional_continuous names of the additional continuous variables to
#' include
#' @param ... additional arguments passed to `guessInvolvementPathway` and
#' `get` function (internal use)
#'
#' @return a ggsurvplot class object
#'
#' @examples
#' data(multiOmics)
#' data(reactSmall)
#'
#' genesToUse <- row.names(multiOmics[[1]])
#'
#' # Creating the MultiOmicsPathway object
#' MOP_survival <- multiOmicsSurvivalPathwayTest(multiOmics, reactSmall[[1]],
#'     survFormula = "Surv(days, status) ~", autoCompleteFormula = TRUE,
#'     useTheseGenes = genesToUse
#' )
#'
#' plotPathwayKM(MOP_survival,
#'     formula = "Surv(days, status) ~ mut + expPC2",
#'     paletteNames = "Paired", inYears = TRUE
#' )
#'
#' @importFrom checkmate assertClass
#' @importFrom pheatmap pheatmap
#' @importFrom gridExtra arrangeGrob
#' @importFrom survminer ggsurvplot surv_fit
#' @importFrom ggplot2 ggsave
#'
#' @export

plotPathwayKM <- function(
    pathway, formula = "Surv(days, status) ~ PC1", fileName = NULL,
    paletteNames = NULL, h = 9, w = 7, risk.table = TRUE, pval = TRUE, size = 1,
    inYears = FALSE, discr_prop_pca = 0.15, discr_prop_events = 0.05,
    additional_discrete = NULL, additional_continuous = NULL, ...) {
    checkmate::assertClass(pathway, "MultiOmicsPathway")

    involved <- guessInvolvementPathway(pathway,
        min_prop_pca = discr_prop_pca, min_prop_events = discr_prop_events, ...)

    annotationFull <- formatAnnotations(involved, sortBy = NULL)
    multiOmicObj <- get(pathway@multiOmicObj, ...)

    coxObj <- createCoxObj(multiOmicObj@colData, pathway@pathView)
    daysAndStatus <- coxObj[, c("status", "days"), drop = FALSE]

    if (inYears) {
        daysAndStatus$days <- daysAndStatus$days / 365.24
    }

    coxObj <- data.frame(
        daysAndStatus,
        annotationFull[row.names(daysAndStatus), , drop = FALSE]
    )

    fit <- survminer::surv_fit(formula(formula), data = coxObj)

    palette <- NULL
    if (!is.null(paletteNames)) {
        if (length(paletteNames) == 1) {
            palette <- paletteNames
        } else {
            classes <- names(fit$strata)
            if (length(classes) == length(paletteNames)) {
                palette <- paletteNames
            }
        }
    }

    p <- survminer::ggsurvplot(fit,
        data = coxObj, risk.table = risk.table, pval = pval,
        palette = palette, linewidth = size
    )

    if (!is.null(fileName)) {
        ggplot2::ggsave(filename = fileName, p, height = h, width = w)
    } else {
        p
    }
}

#' Plot a Heatmap of a Module by Omics
#'
#' It creates a heatmap of the most involved genes of each omic of a specific
#' module from a `MultiOmicsModule` object.
#'
#' @param moduleobj `MultiOmicsModule` class object
#' @param moduleNumber module number of interest
#' @param sortBy a covariate (omic) to sort by
#' @param paletteNames a palette containing three colors
#' @param additionalAnnotations optional additional sample annotations
#' @param additionalPaletteNames optional additional colors for annotations
#' @param withSampleNames show sample names
#' @param fontsize_row font size for row labels
#' @param fontsize_col font size for column labels
#' @param nrowsHeatmaps magnification respect to annotation of sample
#' (annotations take 1 row)
#' @param orgDbi a Dbi organism to be used. Default is `org.Hs.eg.db`
#' @param discr_prop_pca the minimal proportion to compute the PCA classes
#' @param discr_prop_events the minimal proportion to compute the event classes
#' @param ... additional arguments passed to `guessInvolvement` function
#'
#' @examples
#' data(multiOmics)
#' data(reactSmall)
#'
#' survAnnot <- data.frame(
#'     status = multiOmics$status,
#'     days = multiOmics$days,
#'     row.names = colnames(multiOmics[[1]])
#' )
#'
#' genesToUse <- row.names(multiOmics[[1]])
#'
#' MOM_survival <- multiOmicsSurvivalModuleTest(multiOmics, reactSmall[[1]],
#'     survFormula = "Surv(days, status) ~", autoCompleteFormula = TRUE,
#'     useTheseGenes = genesToUse
#' )
#'
#' plotModuleHeat(MOM_survival, 1,
#'     sortBy = c("mut", "expPC1", "status", "days"),
#'     additionalAnnotations = survAnnot,
#'     additionalPaletteNames = list(status = "teal", days = "violet"),
#'     withSampleNames = F
#' )
#'
#' @return A heatmap of a pathway module (results of the module test)
#'
#' @importFrom checkmate assertClass
#' @importFrom ComplexHeatmap Heatmap HeatmapAnnotation '%v%'
#' @importFrom gridExtra arrangeGrob
#' @importFrom grid gpar grid.newpage grid.draw rectGrob grid.grabExpr
#' @importFrom graphics plot
#' @importFrom stats relevel
#' @importFrom ggplotify as.ggplot
#'
#' @export

plotModuleHeat <- function(
    moduleobj, moduleNumber, sortBy = NULL, paletteNames = NULL,
    additionalAnnotations = NULL, additionalPaletteNames = NULL,
    withSampleNames = TRUE, fontsize_row = 10, fontsize_col = 1,
    nrowsHeatmaps = 3, orgDbi = "org.Hs.eg.db",
    discr_prop_pca = 0.15, discr_prop_events = 0.05, ...) {
    checkmate::assertClass(moduleobj, "MultiOmicsModules")

    moduleGenes <- moduleobj@modules[[moduleNumber]]

    involved <- guessInvolvement(moduleobj,
        moduleNumber = moduleNumber, min_prop_pca = discr_prop_pca,
        min_prop_events = discr_prop_events, ...)

    if (length(paletteNames) != length(involved)) {
        repTimes <- ceiling(length(involved) / length(paletteNames))
        paletteNames <- rep(paletteNames, repTimes)[seq_along(involved)]
    }

    # Create annotation and sort
    annotationFull <- formatAnnotations(involved, sortBy = NULL)
    idx <- which(unlist(lapply(annotationFull, class)) == "numeric")
    if (length(idx) > 0) {
        annotationFull[, idx] <- lapply(annotationFull[, idx], function(col) {
            stats::relevel(as.factor(col), ref = "1")
        })
    }

    omics <- guessOmics(colnames(annotationFull))
    if (is.null(paletteNames)) {
        paletteNames <- names(paletteNames)[seq_along(unique(omics))]
        paletteNames <- guessOmicsColors(omics)
    }

    if (length(paletteNames) != length(unique(omics))) {
        stop(paste0(
            "Length of MOcolors differs from the number of omics: ",
            paste(unique(omics),
                  collapse = ", ")
        ))
    }

    if (is.null(names(paletteNames))) {
        names(paletteNames) <- unique(omics)
    }

    annotationPalettes <- paletteNames

    ann_col <- lapply(colnames(annotationFull), function(name) {
        omic <- guessOmic(name)
        if (!omic %in% names(annotationPalettes)) {
            stop("Missing omic in annotationPalettes")
        }
        discreteColor <- annotationPalettes[[omic]]
        values <- sort(unique(annotationFull[, name]))
        if (length(values) == 1) {
            annot <- as.character(MOSpaletteSchema[discreteColor, c("smart")])
            names(annot) <- values
        } else if (length(values) == 2) {
            annot <- as.character(MOSpaletteSchema[
                discreteColor,
                c("smart", "light")
            ])
            names(annot) <- values
        } else if (length(table(annotationFull[, name])) == 3) {
            annot <- as.character(MOSpaletteSchema[
                discreteColor,
                c("dark", "smart", "light")
            ])
            names(annot) <- values
        } else {
            stop("I'm puzzled! Too many values to map")
        }
        annot
    })
    names(ann_col) <- colnames(annotationFull)

    if (!is.null(additionalAnnotations)) {
        additionalAnnotations <- matchAnnotations(
            annotationFull,
            additionalAnnotations
        )
        annotationFull <- cbind(annotationFull, additionalAnnotations)

        if (!is.null(additionalPaletteNames)) {
            add_ann_col <- lapply(colnames(additionalAnnotations), 
                                  function(name) {
                values <- sort(unique(additionalAnnotations[[name]]))
                discreteColor <- additionalPaletteNames[[name]]

                if (length(values) == 2) {
                    annot <- as.character(MOSpaletteSchema[
                        discreteColor,
                        c("smart", "light")
                    ])
                    names(annot) <- values
                } else if (length(table(annotationFull[, name])) == 3) {
                    annot <- as.character(MOSpaletteSchema[
                        discreteColor,
                        c("dark", "smart", "light")
                    ])
                    names(annot) <- values
                } else {
                    annot <- colorRamp2(
                        c(min(values), max(values)),
                        getContinousPalette(discreteColor, 2)
                    )
                    names(annot) <- levels(values)
                }
                annot
            })
            names(add_ann_col) <- colnames(additionalAnnotations)
            ann_col <- c(ann_col, add_ann_col)
        }
    }

    annotationFull <- sortAnnotations(annotationFull, sortBy)
    annotationFull <- annotationFull[, rev(colnames(annotationFull))]

    ha <- HeatmapAnnotation(df = annotationFull, col = ann_col)
    ht_list <- ha
    for (n in seq_along(involved)) {
        heatMatrix <- involved[[n]]$sigModule
        heatMatrix <- heatMatrix[, row.names(annotationFull), drop = FALSE]
        row.names(heatMatrix) <- conversionToSymbols(row.names(heatMatrix), 
                                                     orgDbi)

        Ht <- Heatmap(heatMatrix,
            cluster_columns = FALSE, cluster_rows = FALSE,
            show_column_names = FALSE, 
            heatmap_legend_param = list(title = NULL),
            col = c("#FFFFFF", 
                    as.vector(ann_col[[involved[[n]]$covsConsidered[1]]]))
        )
        ht_list <- ht_list %v% Ht
    }

    gb <- grid::grid.grabExpr(ComplexHeatmap::draw(ht_list,
        legend_grouping = "original"
    ))
    
    ggplot_obj <- ggplotify::as.ggplot(gb)
    return(ggplot_obj)
}


#' Plot Kaplan-Meier survival curves of a specific module
#'
#' Given a `MultiOmicsModule` class object and a specific module number, it
#' plots Kaplan-Meier curves, in which the strata corresponds to the omics
#'
#' @param MOM a `MultiOmicsModule` class object
#' @param moduleNumber numeric value. The module number of interest
#' @param formula a formula for the survival analysis. It should be written as
#' 'Surv(days, status) ~ omic'. To plot more than one omic, write them
#' separated by a '+' character after the separator (~)
#' @param fileName optional filenames to save the plot
#' @param paletteNames a palette name to be used
#' @param h the height of the plot
#' @param w the width of the plot
#' @param risk.table logical value. If TRUE, shows the `risk.table`. Default
#' is TRUE.
#' @param pval logical value. If TRUE, shows the p-value of the curves. Default
#' is TRUE.
#' @param size line width of the KM curves
#' @param inYears set time in years
#' @param discr_prop_pca the minimal proportion to compute the PCA classes
#' @param discr_prop_events the minimal proportion to compute the event classes
#' @param additional_discrete names of the additional discrete variables to
#' include
#' @param additional_continuous names of the additional continous variables to
#' include
#' @param ... additional arguments passed to `guessInvolvement` and `get`
#' function
#'
#' @return a ggsurvplot class object
#'
#' @examples
#' data(multiOmics)
#' data(reactSmall)
#'
#' genesToUse <- row.names(multiOmics[[1]])
#'
#' MOM_survival <- multiOmicsSurvivalModuleTest(multiOmics, reactSmall[[1]],
#'     survFormula = "Surv(days, status) ~", autoCompleteFormula = TRUE,
#'     useTheseGenes = genesToUse
#' )
#'
#' plotModuleKM(MOM_survival, 1,
#'     formula = "Surv(days, status) ~ mut + expPC2",
#'     paletteNames = "Paired", inYears = TRUE
#' )
#'
#' @importFrom checkmate assertClass
#' @importFrom pheatmap pheatmap
#' @importFrom gridExtra arrangeGrob
#' @importFrom survminer ggsurvplot surv_fit
#' @importFrom ggplot2 ggsave
#'
#' @export

plotModuleKM <- function(
    MOM, moduleNumber, formula = "Surv(days, status) ~ PC1",
    fileName = NULL, paletteNames = NULL, h = 9, w = 7, risk.table = TRUE,
    pval = TRUE, size = 1, inYears = FALSE, discr_prop_pca = 0.15,
    discr_prop_events = 0.05, additional_discrete = NULL,
    additional_continuous = NULL, ...) {
    checkmate::assertClass(MOM, "MultiOmicsModules")

    involved <- guessInvolvement(MOM,
        moduleNumber = moduleNumber, min_prop_pca = discr_prop_pca,
        min_prop_events = discr_prop_events, ...)

    multiOmicObj <- get(MOM@multiOmicObj, ...)
    coxObj <- createCoxObj(multiOmicObj@colData, 
                           MOM@modulesView[[moduleNumber]])

    annotationFull <- formatAnnotations(involved, sortBy = NULL)

    days_status_names <- c("status", "days")

    daysAndStatus <- coxObj[, days_status_names, drop = FALSE]
    if (inYears) {
        daysAndStatus$days <- daysAndStatus$days / 365.24
    }

    additional_clinic <- NULL
    if (!is.null(additional_discrete)) {
        not_found <- setdiff(additional_discrete, colnames(coxObj))
        if (length(not_found) > 0) {
            stop(paste0("Some discrete variables were not found: ", 
                        paste(not_found, collapse = ", ", "\n"), 
                        "We found the following variables: ", 
                        paste(colnames(coxObj), collapse = ", ")))
        }

        fixed_covs <- setdiff(additional_discrete, colnames(annotationFull))
        additional_clinic <- coxObj[row.names(daysAndStatus), 
                                    fixed_covs, drop = FALSE]
    }

    if (!is.null(additional_continuous)) {
        not_found <- setdiff(additional_continuous, colnames(coxObj))
        if (length(not_found) > 0) {
            stop(paste0("Some continuous variables were not found: ", 
                        paste(not_found, collapse = ", ", "\n"), 
                        "We found the following variables: ", 
                        paste(colnames(coxObj), collapse = ", ")))
        }

        fixed_covs <- setdiff(additional_continuous, colnames(annotationFull))
        df <- cbind(daysAndStatus, coxObj[row.names(daysAndStatus), 
                                          fixed_covs, drop = FALSE])
        discretized_covs <- createDiscreteClasses(df, fixed_covs)

        if (!is.null(additional_clinic)) {
            additional_clinic <- cbind(additional_clinic, 
                                       discretized_covs[, fixed_covs,
                                                        drop = FALSE])
        } else {
            additional_clinic <- discretized_covs[, fixed_covs, drop = FALSE]
        }
    }

    if (is.null(additional_clinic)) {
        coxObj <- data.frame(daysAndStatus, 
                             annotationFull[row.names(daysAndStatus), ,
                                            drop = FALSE])
    } else {
        coxObj <- data.frame(daysAndStatus, 
                             annotationFull[row.names(daysAndStatus), ,
                                            drop = FALSE], 
                             additional_clinic)
    }

    fit <- survminer::surv_fit(formula(formula), data = coxObj)

    palette <- NULL
    if (!is.null(paletteNames)) {
        if (length(paletteNames) == 1) {
            palette <- paletteNames
        } else {
            classes <- names(fit$strata)
            if (length(classes) == length(paletteNames)) {
                palette <- paletteNames
            }
            if (!is.null(names(paletteNames))) {
                diff <- setdiff(names(paletteNames), classes)
                if (length(diff) != 0) {
                    stop("Names of paletteNames must be equal to classes")
                }
            }
        }
    }

    p <- survminer::ggsurvplot(fit,
        data = coxObj, risk.table = risk.table, pval = pval,
        palette = unname(palette), linewidth = size
    )

    if (!is.null(fileName)) {
        ggplot2::ggsave(filename = fileName, p, height = h, width = w)
    } else {
        p
    }
}

#' Plot a Directed Graph of the MultiOmicsModules Object
#'
#' From a `MultiOmicsModules` object, it plots the position of a given module
#' in the pathway. The omics are also represented in the graph.
#'
#' @param modulesobj a `MultiOmicsModule` class object
#' @param pathList a `PathwayList` from `graphite` package that contains the
#' pathways to be used
#' @param moduleNumber a module number
#' @param orgDbi if needed, indicates an organism Dbi to translate the vectors
#' @param legendLabels set up your favourite names for the omics
#' @param paletteNames named vector of MOSpalettes, names replace makeLegend
#' arguments
#' @param fileName optional filenames to save the plot
#' @param discr_prop_pca the minimal proportion to compute the PCA classes
#' @param discr_prop_events the minimal proportion to compute the event classes
#' @param pathTitle title of the graph, to be searched in `pathList`
#' @param ... additional arguments passed to `guessInvolvement` function
#'
#' @return a MOSClip plot in form of a list class object
#'
#' @examples
#' data(multiOmics)
#' data(reactSmall)
#'
#' genesToUse <- row.names(multiOmics[[1]])
#'
#' MOM_survival <- multiOmicsSurvivalModuleTest(multiOmics, reactSmall[[1]],
#'     survFormula = "Surv(days, status) ~", autoCompleteFormula = TRUE,
#'     useTheseGenes = genesToUse
#' )
#'
#' plotModuleInGraph(MOM_survival, reactSmall,
#'     moduleNumber = 1,
#'     paletteNames = c(exp = "red", met = "green", 
#'                      mut = "blue", cnv = "yellow")
#' )
#'
#' @importFrom checkmate assertClass
#' @importFrom igraph V V<- simplify graph_from_graphnel
#' @importFrom AnnotationDbi select
#' @importFrom graphics plot legend par
#' @importFrom grDevices dev.off pdf rainbow
#'
#' @export
plotModuleInGraph <- function(
    modulesobj, pathList, moduleNumber, orgDbi = "org.Hs.eg.db",
    paletteNames = NULL, legendLabels = NULL, fileName = NULL, 
    discr_prop_pca = 0.15,
    discr_prop_events = 0.05, pathTitle = NULL, ...) {
    checkmate::assertClass(modulesobj, "MultiOmicsModules")

    if (!is(pathList[[1]], "graphNEL")) {
        net <- igraph::graph_from_graphnel(convertPathway(
            pathList[[modulesobj@title]], NULL))
    } else {
        net <- igraph::graph_from_graphnel(pathList[[pathTitle]])
    }

    moduleGenes <- modulesobj@modules[[moduleNumber]]
    net <- igraph::simplify(net, remove.multiple = TRUE, remove.loops = TRUE)
    color <- rep("grey", length(V(net)))
    color[names(V(net)) %in% moduleGenes] <- "tomato"

    involved <- guessInvolvement(modulesobj,
        moduleNumber = moduleNumber, min_prop_pca = discr_prop_events,
        min_prop_events = discr_prop_events, ...)
    mark.groups <- lapply(involved, function(x) {
        row.names(x$subset)
    })

    group.names <- vapply(involved, function(x) {
        guessOmic(x$covsConsidered)}, character(1))

    colLength <- length(mark.groups)
    if (colLength < 3) {
        mark.col <- rainbow(3, alpha = 0.33)[seq_len(colLength)]
    } else {
        mark.col <- rainbow(colLength, alpha = 0.33)
    }

    mark.border <- NA

    if (!is.null(paletteNames)) {
        if (is.null(names(paletteNames))) {
            stop("paletteNames must be named vector")
        }

        if (!is.null(names(paletteNames))) {
            mismatch <- setdiff(group.names, names(paletteNames))
            if (length(mismatch) > 0) {
                stop("Missing palette for one or more omics")
            }
            paletteNames <- paletteNames[group.names]
        }

        err <- setdiff(paletteNames, row.names(MOSpaletteSchema))
        if (length(err) != 0) {
            stop("paletteNames value not allowed.")
        }

        mark.col <- MOSpaletteSchema[paletteNames, ]$transparent
    }

    if (is.null(legendLabels)) {
        legendLabels <- group.names
    } else {
        if (length(legendLabels) != length(group.names)) {
            warning("Some legendLabels were not found in data")
        }
        legendLabels <- legendLabels[seq_along(group.names)]
    }

    labels <- conversionToSymbols(names(V(net)), orgDbi)

    par(mar = c(1.5, 1, 1, 0.5))

    if (!is.null(fileName)) {
        pdf(fileName)
    }
    plot(net,
        edge.arrow.size = 0.5, edge.curved = 0.2, vertex.label = labels, 
        vertex.label.cex = 0.6, vertex.label.family = "sans", 
        vertex.label.font = 2, vertex.color = color, 
        vertex.frame.color = "gray", vertex.label.color = "black", 
        vertex.size = 15, mark.groups = mark.groups, mark.col = mark.col, 
        mark.border = NA
    )
    legend(
        x = -1, y = -1, legendLabels, pch = 21, horiz = TRUE, col = "#777777",
        pt.bg = mark.col, pt.cex = 2, cex = 0.8, bty = "n", ncol = 1
    )
}

#' Summarize and plot pathways' info from a list of `MultiOmicsPathway` (MOP)
#'
#' Given the list of MOPs, it plots a table of its results.
#'
#' @param multiPathwayList a `list` of `MultiOmicsPathway` class objects
#' @param top numeric value. Plot only the top number of pathways
#' @param MOcolors character vector with the omic colors.
#' The colors should be among the colors in \code{\link{showMOSpalette}}
#' @param priority_to a vector with the covariates (omic names) that should go
#' first
#' @param fontsize the font size to be used. Default is 12.
#' @param \dots additional argument to be passed to pheatmap
#'
#' @return a Heatmap list object from ComplexHeatmap package of the results
#' contained in the `MultiOmicsPathway` object provided
#'
#' @examples
#' data(multiOmics)
#' data(reactSmall)
#'
#' genesToUse <- row.names(multiOmics[[1]])
#'
#' MOP_list <- lapply(reactSmall, function(g) {
#'     fcl <- multiOmicsSurvivalPathwayTest(multiOmics, g,
#'         survFormula = "Surv(days, status) ~",
#'         autoCompleteFormula = TRUE,
#'         useTheseGenes = genesToUse
#'     )
#'     fcl
#' })
#'
#' plotMultiPathwayReport(MOP_list,
#'     MOcolors = c(
#'         exp = "red", met = "green", mut = "blue",
#'         cnv = "yellow"
#'     ),
#'     fontsize = 12
#' )
#'
#' @importFrom pheatmap pheatmap
#'
#' @export

plotMultiPathwayReport <- function(
    multiPathwayList, top = 25, MOcolors = NULL, priority_to = NULL,
    fontsize = 6, ...) {
    if (!is.list(multiPathwayList)) {
        stop("multiPathwayList must be a list.")
    }

    summary <- multiPathwayReport(multiPathwayList)
    top <- min(top, NROW(summary))

    annCol <- guessOmics(colnames(summary))
    omics <- annCol[2:length(annCol)]

    if (is.null(priority_to) & (!is.null(MOcolors))) {
        if (!is.null(names(MOcolors))) {
            priority_to <- names(MOcolors)
        }
    }

    if (is.null(MOcolors)) {
        MOcolors <- guessOmicsColors(omics)
    }

    if (length(MOcolors) != length(unique(omics))) {
        stop(paste0("Length of MOcolors differs from the number of omics: ", 
                    paste(unique(omics), collapse = ", ")))
    }

    if (is.null(names(MOcolors))) {
        names(MOcolors) <- unique(omics)
    }

    omics <- omics[order(match(omics, priority_to))]
    colors <- createColors(omics, MOcolors)
    names(colors) <- unique(omics)

    msummary <- as.matrix(summary[seq_len(top), 2:(ncol(summary))])

    msummary <- order_by_covariates(msummary, 0, priority_to)

    cell_text <- function(j, i, x, y, width, height, fill) {
        grid.text(sprintf("%.2f", msummary[i, j]), x, y, 
                  gp = gpar(fontsize = fontsize))
    }

    ta <- HeatmapAnnotation(Omics = omics, col = list(Omics = colors))

    ht1 <- Heatmap(
        matrix = summary$pvalue[seq_len(top)], 
        col = pvalueShades[seq_len(round((summary$pvalue[top] *100) + 1))], 
        cluster_rows = FALSE, show_heatmap_legend = FALSE, name = "Pvalue",
        column_names_gp = gpar(fontsize = fontsize), 
        cell_fun = function(j, i, x, y, width, height, fill) {
            grid.text(sprintf("%.2f", summary$pvalue[i]), x, y, 
                      gp = gpar(fontsize = fontsize))}
    )
    dots <- list(...)
    defargs <- list(
        matrix = msummary, name = "p-Value", col = pvalueShades, 
        cluster_rows = FALSE, cluster_columns = FALSE, cell_fun = cell_text, 
        top_annotation = ta, row_names_gp = gpar(fontsize = fontsize),
        column_names_gp = gpar(fontsize = fontsize)
    )
    args <- matchArguments(dots, defargs)

    ht2 <- do.call(Heatmap, args)
    ht1 + ht2
}

#' Plot a table of a `MultiOmicsModules` (MOM) object
#'
#' Given a `MultiOmicsModules` object, it plots its results in a
#' tabular fashion
#'
#' @inheritParams plotMultiPathwayReport
#' @param modulesObj `MultiOmicsModules` class object
#' @param fontsize Size of the font to be used in the plot
#'
#' @return a Heatmap list object from ComplexHeatmap package of the results
#' contained in the `MultiOmicsModules` object provided
#'
#' @examples
#' data(multiOmics)
#' data(reactSmall)
#'
#' genesToUse <- row.names(multiOmics[[1]])
#'
#' MOM_survival <- multiOmicsSurvivalModuleTest(multiOmics, reactSmall[[1]],
#'     survFormula = "Surv(days, status) ~", autoCompleteFormula = TRUE,
#'     useTheseGenes = genesToUse
#' )
#'
#' plotModuleReport(MOM_survival,
#'     MOcolors = c(
#'         exp = "red", met = "green", mut = "blue",
#'         cnv = "yellow"
#'     )
#' )
#'
#' @importFrom checkmate assertClass
#' @importFrom pheatmap pheatmap
#' @importFrom ComplexHeatmap Heatmap HeatmapAnnotation rowAnnotation
#' @importFrom grid grid.text
#' @importFrom circlize colorRamp2
#' @importFrom grDevices colorRampPalette
#' @importFrom RColorBrewer brewer.pal
#' @export

plotModuleReport <- function(
    modulesObj, MOcolors = NULL, priority_to = NULL, fontsize = 12,
    ...) {
    checkmate::assertClass(modulesObj, "MultiOmicsModules")

    summary <- formatModuleReport(modulesObj)
    rownames(summary) <- paste0(rownames(summary), "\u00B0 module")

    annCol <- guessOmics(colnames(summary))
    omics <- annCol[2:length(annCol)]

    if (is.null(priority_to) & (!is.null(MOcolors))) {
        if (!is.null(names(MOcolors))) {
            priority_to <- names(MOcolors)
        }
    }
    if (is.null(MOcolors)) {
        MOcolors <- guessOmicsColors(omics)
    }
    if (length(MOcolors) != length(unique(omics))) {
        stop(paste0("Length of MOcolors differs from the number of omics: ", 
                    paste(unique(omics), collapse = ", ")))
    }
    if (is.null(names(MOcolors))) {
        names(MOcolors) <- unique(omics)
    }

    omics <- omics[order(match(omics, priority_to))]
    colors <- createColors(omics, MOcolors)
    names(colors) <- unique(omics)
    pvalcol <- colorRamp2(c(0, 1), c("#edf7f5", "#2796bd"))

    msummary <- as.matrix(summary[, 2:ncol(summary)])
    msummary <- order_by_covariates(msummary, 0, priority_to)

    cell_text <- function(j, i, x, y, width, height, fill) {
        grid.text(sprintf("%.2f", msummary[i, j]), x, y, 
                  gp = gpar(fontsize = fontsize))
    }

    ta <- HeatmapAnnotation(Omics = omics, col = list(Omics = colors))

    ht1 <- Heatmap(
        matrix = summary$pvalue, col = pvalueShades, cluster_rows = FALSE,
        show_heatmap_legend = FALSE, name = "Pvalue", 
        column_names_gp = gpar(fontsize = fontsize),
        cell_fun = function(j, i, x, y, width, height, fill) {
            grid.text(sprintf("%.2f", summary$pvalue[i]), x, y, 
                      gp = gpar(fontsize = fontsize))}
    )
    dots <- list(...)
    defargs <- list(
        matrix = msummary, name = "p-Value", col = pvalueShades, 
        cluster_rows = FALSE, cluster_columns = FALSE, cell_fun = cell_text, 
        top_annotation = ta, row_names_gp = gpar(fontsize = fontsize),
        column_names_gp = gpar(fontsize = fontsize)
    )
    args <- matchArguments(dots, defargs)

    ht2 <- do.call(Heatmap, args)
    (ht1 + ht2)
}

test_that(
    "Plots with two class object work", {
        dummy_react <- readRDS(test_path("fixtures", "reactBiggerDummy.rds"))
        genes <- paste0(
            "ENTREZID:", c(
                10000, 90427, 5366, 23368, 637,
                3002, 79792, 38840, 5414, 5599,
                8655, 140735, 708, 2254, 3957761,
                5140, 5289, 10714, 7318, 1642,
                121504
            )
        )
        dummy_omics <- fake_mo(genes = genes, type = "two-classes")
        dummy_annot <- dummy_colData(type = "two-classes")

        env <- environment()
        assign("dummy_omics", dummy_omics, envir = env)

        twoCPathwayObj <- multiOmicsTwoClassPathwayTest(
            dummy_omics, dummy_react[[1]], dummy_annot,
            baseFormula = "classes ~", nullModel = "classes ~ 1"
        )
        res.pathwayHeat <- plotPathwayHeat(
            twoCPathwayObj, sortBy = c("expPC2", "mut", "classes"),
            paletteNames = c(
                exp = "red", met = "green", mut = "blue",
                cnv = "yellow"
            ),
            additionalAnnotations = dummy_annot,
            additionalPaletteNames = list(classes = "teal"),
            nrowsHeatmaps = 2, withSampleNames = F,
            envir = env
        )

        expect_false(is.null(res.pathwayHeat))
        expect_s3_class(res.pathwayHeat, "ggplot")

        res.pathwayHeat_nopalette <- plotPathwayHeat(
            twoCPathwayObj, sortBy = c("expPC2", "mut", "classes"),
            additionalAnnotations = dummy_annot,
            additionalPaletteNames = list(classes = "teal"),
            nrowsHeatmaps = 2, withSampleNames = F,
            envir = env
        )

        expect_false(is.null(res.pathwayHeat_nopalette))
        expect_s3_class(res.pathwayHeat_nopalette, "ggplot")

        expect_error(
            plotPathwayHeat(
                twoCPathwayObj, sortBy = c("expPC2", "mut", "classes"),
                paletteNames = c(exp = "red", met = "green"),
                additionalAnnotations = dummy_annot,
                additionalPaletteNames = list(classes = "teal"),
                nrowsHeatmaps = 2, withSampleNames = FALSE,
                envir = env
            ),
            "Missing omic"
        )

        res.pathwayReport <- plotMultiPathwayReport(
            list(twoCPathwayObj),
            MOcolors = c(
                exp = "red", met = "green", mut = "blue",
                cnv = "yellow"
            ),
            top = 40, fontsize = 10
        )

        expect_false(is.null(res.pathwayReport))
        expect_s4_class(res.pathwayReport, "HeatmapList")

        expect_error(
            plotMultiPathwayReport(
                list(twoCPathwayObj),
                MOcolors = c(
                  exp = "red", met = "green",
                  mut = "blue"
              ),
                top = 40, fontsize = 10
            ),
            "Length of MOcolors differs"
        )

        twoCModuleObj <- multiOmicsTwoClassModuleTest(
            dummy_omics, dummy_react[[1]], dummy_annot,
            baseFormula = "classes ~", nullModel = "classes ~ 1"
        )
        res.moduleHeat <- plotModuleHeat(
            twoCModuleObj, 2, paletteNames = c(
                exp = "red", met = "green", mut = "blue",
                cnv = "yellow"
            ),
            additionalAnnotations = dummy_annot,
            additionalPaletteNames = list(classes = "teal"),
            sortBy = c("met2k", "expPC1", "classes"),
            withSampleNames = F, envir = env
        )

        expect_false(is.null(res.moduleHeat))
        expect_s3_class(res.moduleHeat, "ggplot")

        expect_error(
            plotModuleHeat(
                twoCModuleObj, 2, sortBy = c("expPC2", "mut", "classes"),
                paletteNames = c(exp = "red", met = "green"),
                additionalAnnotations = dummy_annot,
                additionalPaletteNames = list(classes = "teal"),
                nrowsHeatmaps = 2, withSampleNames = FALSE,
                envir = env
            ),
            "Missing omic"
        )

        res.ModuleInGraph <- plotModuleInGraph(
            twoCModuleObj, dummy_react, moduleNumber = 2,
            legendLabels = c(
                "expr", "methylation", "cnv",
                "mut"
            ),
            paletteNames = c(
                exp = "red", met = "green", mut = "blue",
                cnv = "yellow"
            ),
            envir = env
        )

        expect_false(is.null(res.ModuleInGraph))
        expect_true(is.list(res.ModuleInGraph))
        expect_true(
            all(
                vapply(
                  res.ModuleInGraph, function(x) !is.null(x),
                  logical(1)
              )
            )
        )

        expect_error(
            plotModuleInGraph(
                twoCModuleObj, dummy_react, moduleNumber = 3,
                legendLabels = c(
                  "expr", "methylation", "cnv",
                  "mut"
              ),
                paletteNames = c(
                  exp = "orange", met = "green",
                  mut = "blue", cnv = "yellow"
              ),
                envir = env
            ),
            "paletteNames value not allowed"
        )
        expect_error(
            plotModuleInGraph(
                twoCModuleObj, dummy_react, moduleNumber = 3,
                legendLabels = c("expr", "methylation", "cnv"),
                paletteNames = c(exp = "red"),
                envir = env
            ),
            "Missing palette"
        )

        res.moduleReport <- plotModuleReport(
            twoCModuleObj, MOcolors = c(
                exp = "red", met = "green", mut = "blue",
                cnv = "yellow"
            )
        )
        expect_false(is.null(res.moduleReport))
        expect_s4_class(res.moduleReport, "HeatmapList")
        expect_error(
            plotModuleReport(
                twoCModuleObj, MOcolors = c(
                  exp = "red", met = "green",
                  mut = "blue"
              )
            ),
            "Length of MOcolors differs"
        )
    }
)


test_that(
    "Kaplan Meier plots work", {
        dummy_react <- readRDS(test_path("fixtures", "reactBiggerDummy.rds"))
        genes <- paste0(
            "ENTREZID:", c(
                10000, 90427, 5366,
                23368, 637, 3002, 79792,
                840, 5414, 5599, 8655,
                140735, 708
            )
        )
        dummy_omicsSurv <- fake_mo(genes = genes, type = "survival")

        env <- environment()
        assign(
            "dummy_omicsSurv", dummy_omicsSurv,
            envir = env
        )

        res.survPathway <- multiOmicsSurvivalPathwayTest(
            dummy_omicsSurv, dummy_react[[1]],
            survFormula = "Surv(days, status) ~",
            autoCompleteFormula = T
        )

        res.PathwayKM <- plotPathwayKM(
            res.survPathway, formula = "Surv(days, status) ~ met3k + expPC2",
            paletteNames = "Paired",
            envir = env
        )

        expect_false(is.null(res.PathwayKM))
        expect_identical(
            class(res.PathwayKM),
            c("ggsurvplot", "ggsurv", "list")
        )

        res.survModules <- multiOmicsSurvivalModuleTest(
            dummy_omicsSurv, dummy_react[[1]],
            survFormula = "Surv(days, status) ~",
            autoCompleteFormula = TRUE
        )

        res.ModuleKM <- plotModuleKM(
            res.survModules, 2, formula = "Surv(days, status) ~ met2k + expPC1",
            paletteNames = "Paired",
            risk.table = TRUE, size = 2,
            inYears = TRUE, envir = env
        )

        expect_false(is.null(res.ModuleKM))
        expect_identical(
            class(res.ModuleKM),
            c(
                "ggsurvplot", "ggsurv",
                "list"
            )
        )

        expect_error(
            plotModuleKM(
                res.survModules, 2,
                formula = "Surv(days, status) ~ met2k + expPC1",
                paletteNames = "Paired",
                risk.table = TRUE, size = 2,
                inYears = TRUE, additional_discrete = "recurrence_status",
                envir = env
            ),
            "discrete variables were not found"
        )

        expect_error(
            plotModuleKM(
                res.survModules, 2,
                formula = "Surv(days, status) ~ met2k + expPC1",
                paletteNames = "Paired",
                risk.table = TRUE, size = 2,
                inYears = TRUE, additional_continuous = "recurrence_days",
                envir = env
            ),
            "continuous variables were not found"
        )

    }
)

#' Cox Model Analysis
#'
#' Cox Analysis
#'
#' For internal use only
#'
#' @param coxObj data.frame: patients x covariates
#' @param formula formula to use
#'
#' @return A list with
#' \item{pvalue}{pvalue of the model}
#' \item{zlist}{pvalues of single covariates}
#' \item{coxObj}{the original coxObj passed to the function}
#'
#' @importFrom stats as.formula na.omit
#' @importFrom survival coxph Surv
#'
survivalcox <- function(coxObj, formula) {
    originalCoxObj <- coxObj
    coxObj <- na.omit(coxObj)
    coxRes <- survival::coxph(
        as.formula(formula),
        na.omit(coxObj)
    )
    coxSummary <- summary(coxRes)
    zlist <- coxSummary$coefficients[, "Pr(>|z|)"]
    names(zlist) <- row.names(coxSummary$coefficients)
    pvalue <- coxSummary$logtest["pvalue"]
    return(list(pvalue = pvalue, zlist = zlist, coxObj = originalCoxObj))
}

#' Cox Robust Model Analysis
#'
#' Cox Robust Analysis
#'
#' For internal use only
#'
#' @param coxObj data.frame: patients x covariates
#' @param formula formula to use
#'
#' @return A list with
#' \item{pvalue}{pvalue of the model}
#' \item{zlist}{pvalues of single covariates}
#' \item{coxObj}{the original coxObj passed to the function}
#'
#' @importFrom stats as.formula na.omit
#' @importFrom survival Surv
#' @importFrom coxrobust coxr
#'
survivalcoxr <- function(coxObj, formula) {
    originalCoxObj <- coxObj
    coxObj <- na.omit(coxObj)
    coxRes <- coxrobust::coxr(
        as.formula(formula),
        na.omit(coxObj)
    )
    coxSummary <- coxrsummary(coxRes)
    zlist <- coxSummary$robust[, "p"]
    names(zlist) <- row.names(coxSummary$robust)
    pvalue <- coxSummary$extWakd
    return(list(pvalue = pvalue, zlist = zlist, coxObj = originalCoxObj))
}

#' Summarize Cox Robust
#'
#' @param x a coxr.obj
#'
#' @return a list with wald test and robust and partial coefficients
#'
#' @rdname survivalcoxr
#'
#' @importFrom stats pchisq pnorm
#'
coxrsummary <- function(x) {
    sd.ple <- sqrt(diag(x$var.ple))
    sd <- sqrt(diag(x$var))
    df <- sum(!is.na(x$coef))

    tmp <- cbind(
        x$ple.coefficients, exp(x$ple.coefficients),
        sd.ple, 2 * (1 - pnorm(abs(x$ple.coefficients/sd.ple)))
    )

    dimnames(tmp)[[1]] <- names(x$coef)
    dimnames(tmp)[[2]] <- c("coef", "exp(coef)", "se(coef)", "p")

    partialLikelihood <- tmp
    wald <- 1 - pchisq(x$wald.test, df)

    tmp <- cbind(
        x$coef, exp(x$coef),
        sd, 2 * (1 - pnorm(abs(x$coef/sd)))
    )
    dimnames(tmp)[[1]] <- names(x$coef)
    dimnames(tmp)[[2]] <- c("coef", "exp(coef)", "se(coef)", "p")

    robustEstimator <- tmp
    extWald <- 1 - pchisq(x$ewald.test, df)

    list(
        wald = wald, partial = partialLikelihood, extWakd = extWald,
        robust = robustEstimator
    )
}

#' Summarize pathways' info from a list of MultiOmicsPathway objects (MOP)
#'
#' Given the list of MOPs, it creates the table.
#'
#' @param multiPathwayList a list of `MultiOmicsPathway` objects resulting from
#' a multi-omics pathway test.
#' @param priority_to a vector with the covariates (omic name) that should go
#' first.
#'
#' @return a data.frame, pathways in rows, overall pvalue of the coxph,
#' followed by covariates pvalues, in columns.
#'
#' @examples
#' data(multiOmics)
#' data(reactSmall)
#'
#' genesToUse <- row.names(multiOmics[[1]])
#'
#' MOP_list <- lapply(reactSmall, function(g) {
#'     fcl <- multiOmicsSurvivalPathwayTest(multiOmics, g,
#'         survFormula = "Surv(days, status) ~",
#'         autoCompleteFormula = TRUE,
#'         useTheseGenes = genesToUse
#'     )
#'     fcl
#' })
#'
#' pathwaysSummary <- multiPathwayReport(MOP_list)
#'
#' @export
multiPathwayReport <- function(multiPathwayList, priority_to = NULL) {
    if (!is(multiPathwayList, "list") || 
        any(vapply(multiPathwayList, 
                   class, character(1)) != "MultiOmicsPathway")) {
        stop("A list of pathway results are expected.")
    }

    pvalues <- vapply(multiPathwayList, function(p) {
        as.numeric(p@pvalue)
    }, numeric(1))

    zs <- sort(unique(unlist(lapply(multiPathwayList, function(p) {
        names(p@zlist)
    }))))

    zMat <- do.call(rbind, lapply(multiPathwayList, function(p) {
        fixedCols <- rep(NA, length(zs))
        names(fixedCols) <- zs
        fixedCols[names(p@zlist)] <- p@zlist
        fixedCols
    }))

    ord <- order(pvalues)
    df <- cbind(row.names = names(pvalues)[ord], pvalue = pvalues[ord], 
                data.frame(zMat[ord, , drop = FALSE]))
    order_by_covariates(df, 1, priority_to)
}


#' Provides a Table of the Modules Test Results
#'
#' Summarizes the results of a multi omics module test given a list of
#' MultiOmicsModules objects
#'
#' @param multiPathwayModuleList a list of `MultiOmicsModules` objects
#' resulting from a multi-omics module test.
#' @param priority_to a vector with the covariates (the omics names)
#' that should appear first in the dataframe columns
#'
#' @return a data.frame class object. Rows correspond to the modules, and the
#' columns to the overall and covariates pvalues of the test.
#'
#' @examples
#' data(multiOmics)
#' data(reactSmall)
#'
#' genesToUse <- row.names(multiOmics[[1]])
#'
#' MOM_list <- lapply(reactSmall[1:2], function(g) {
#'     fcl <- multiOmicsSurvivalModuleTest(multiOmics, g,
#'         survFormula = "Surv(days, status) ~",
#'         autoCompleteFormula = TRUE,
#'         useTheseGenes = genesToUse
#'     )
#'     fcl
#' })
#'
#' moduleSummary <- multiPathwayModuleReport(MOM_list)
#'
#' @export

multiPathwayModuleReport <- function(multiPathwayModuleList, 
                                     priority_to = NULL) {
    if (!is(multiPathwayModuleList, "list") || 
        any(vapply(multiPathwayModuleList, 
                   class, character(1)) != "MultiOmicsModules")) {
        stop("A list of pathway modules results are expected.")
    }

    n_temp <- names(multiPathwayModuleList)

    multiMatrixRes <- lapply(n_temp, function(name, list) {
        summary <- formatModuleReport(list[[name]])
        data.frame(
            pathway = name, module = row.names(summary), 
            summary, row.names = NULL, stringsAsFactors = FALSE)}, 
        multiPathwayModuleList)
    resDF <- mergeAll(multiMatrixRes)
    resDF <- resDF[order(resDF$pvalue), ]
    rownames(resDF) <- apply(resDF, 1, function(r) {
        paste(r["pathway"], r["module"], sep = ".")
    })

    resDF <- order_by_covariates(resDF, 3, priority_to)

    return(resDF)
}



formatModuleReport <- function(smObj) {
    alphas <- smObj@alphas
    z <- smObj@zlists
    idxs <- order(alphas)

    zcols <- sort(unique(unlist(lapply(z, function(x) {
        names(x)
    }))))

    colDescription <- do.call(rbind, lapply(idxs, function(i) {
        additionalCols <- rep(NA, length(zcols))
        names(additionalCols) <- zcols
        additionalCols[names(z[[i]])] <- z[[i]]
        additionalCols
    }))

    cbind(row.names = idxs, pvalue = alphas[idxs], data.frame(colDescription))
}

mergeAll <- function(list) {
    allColumnsNames <- sort(unique(unlist(lapply(list, function(o) {
        colnames(o)
    }))))

    matrix <- do.call(rbind, lapply(list, function(o) {
        fixedCols <- matrix(NA, NROW(o), length(allColumnsNames))
        colnames(fixedCols) <- allColumnsNames
        for (col in colnames(o)) {
            fixedCols[, col] <- o[, col]
        }
        fixedCols
    }))
    removeCols <- match(c("pathway", "module", "pvalue"), colnames(matrix))
    numericMat <- matrix[, -removeCols, drop = FALSE]
    data.frame(pathway = matrix[, "pathway"], module = matrix[, "module"], 
               pvalue = as.numeric(matrix[ , "pvalue"]), 
               apply(numericMat, 2, as.numeric), stringsAsFactors = FALSE)
}

order_by_covariates <- function(dataF, skip_first_cols, priority_to = NULL) {
    if (is.null(priority_to)) {
        return(dataF)
    }

    covariates <- dataF[, seq_len(ncol(dataF) - skip_first_cols) 
                        + skip_first_cols, drop = FALSE]
    fixed <- dataF[, seq_len(skip_first_cols), drop = FALSE]
    omics_cov <- guessOmics(colnames(covariates))
    to_sort <- unique(omics_cov) %in% priority_to
    priority_to <- c(priority_to, unique(omics_cov)[!to_sort])
    cov_factor <- factor(omics_cov, levels = priority_to)
    cov_factor <- droplevels(cov_factor)
    covariates <- covariates[, order(cov_factor), drop = FALSE]
    cbind(fixed, covariates)
}

test_that(
    "multiPathwayReport", {
        graphs <- readRDS(test_path("fixtures", "reactBiggerDummy.rds"))
        genes <- unique(unlist(unname(lapply(graphs, nodes))))
        mo <- fake_mo(genes = genes, type = "survival")
        res <- lapply(
            graphs, function(x) {
                multiOmicsSurvivalPathwayTest(mo, x)
            }
        )
        priority_to <- c("mut", "exp")
        report <- multiPathwayReport(res, priority_to = priority_to)
        expect_false(is.null(report))
        covs <- unique(
            sapply(
                colnames(report),
                substr, 1, 3
            )
        )[-1]
        expect_identical(
            covs[1:length(priority_to)],
            priority_to
        )
        expect_equal(
            nrow(report),
            5
        )
        expect_error(
            multiPathwayReport(res[[1]]),
            "A list of pathway results are expected."
        )
        res[[1]] <- list(1)
        expect_error(
            multiPathwayReport(res),
            "A list of pathway results are expected."
        )
    }
)


test_that(
    "multiPathwayModuleReport", {
        graphs <- readRDS(test_path("fixtures", "reactBiggerDummy.rds"))
        genes <- unique(unlist(unname(lapply(graphs, nodes))))
        mo <- fake_mo(genes = genes, type = "two-classes")
        res <- lapply(
            graphs, function(x) {
                multiOmicsTwoClassModuleTest(mo, x, mo@colData)
            }
        )
        priority_to <- c("met", "cnv")
        report <- multiPathwayModuleReport(res, priority_to = priority_to)
        expect_false(is.null(report))
        covs <- unique(
            sapply(
                colnames(report),
                substr, 1, 3
            )
        )[-(1:3)]
        expect_identical(
            covs[1:length(priority_to)],
            priority_to
        )
        expect_s3_class(report, "data.frame")
        expect_error(
            multiPathwayModuleReport(res[[1]]),
            "A list of pathway modules results are expected."
        )
        res[[1]] <- list(1)
        expect_error(
            multiPathwayModuleReport(res),
            "A list of pathway modules results are expected."
        )
    }
)

#' Extract Summary Binary from MultiOmics Objects
#'
#' Given an omic summarized by 'summarizeToBinaryEvents' extract the most
#' important features.
#'
#' @param omic a summarized omic
#' @param multiOmicObj `Omics` object
#' @param n maximum number of features to retrieve
#'
#' @return Meant for internal use only. The summary for omic summarized
#' using binary events.
#' \item{sigModule}{the original data for significant features}
#' \item{discrete}{the discrete version of the significant covariates converted
#' (when needed) into the discrete version}
#' \item{subset}{data.frame(row.names=names(topGenes), cov=sum binary events)}
#' \item{covsConsidered}{the name of the considered omic}
extractSummaryFromBinary <- function(omic, multiOmicObj, n = 3) {
    moduleMat <- createDataModule(omic, multiOmicObj)
    covs <- omic$namesCov

    impact <- lapply(covs, mostlyMutated,
        moduleMat = t(moduleMat), name = omic$omicName,
        eventThr = omic$eventThr
    )
    mostlyImpacted <- lapply(impact, head, n = n)
    involved <- unique(unlist(lapply(mostlyImpacted, row.names)))
    sigModule <- moduleMat[involved, , drop = FALSE]

    discrete <- data.frame(lapply(omic$x, as.numeric), 
                           row.names = row.names(omic$x))
    list(sigModule = sigModule, discrete = discrete, 
         subset = mostlyImpacted, covsConsidered = omic$namesCov)
}


#' Extract Summary Cluster from MultiOmics Objects
#'
#' Given an omic summarized by 'summarizeInCluster' extract the most
#' important features.
#'
#' @inheritParams extractSummaryFromBinary
#'
#' @return summary for omic summarized using clusters
#' \item{sigModule}{the original data for significant features}
#' \item{discrete}{the discrete version of the significant covariates converted
#' (when needed) into the discrete version}
#' \item{subset}{data.frame(row.names=names(topGenes), metClust=topGenes)}
#' \item{pvalues}{Kruskal Wallis pvalues of the selected features}
#' \item{covsConsidered}{the name of the considered omic}
#' @importFrom utils head
extractSummaryFromCluster <- function(omic, multiOmicObj, n = 3) {
    moduleMat <- createDataModule(omic, multiOmicObj)
    classes <- omic$x[, 1]
    KMsigMat <- KWtest(t(moduleMat), classes)

    if (is.null(names(omic$cls))) {
        stop("cls in omic needs to be a list or a named vector")
    }

    g <- lapply(names(omic$cls), function(gene) {
        cbind(gene, omic$cls[[gene]])
    })
    g <- do.call(rbind, g)
    genes <- g[, 1]
    names(genes) <- g[, 2]

    involved <- head(KMsigMat, n)
    sigModule <- moduleMat[row.names(involved), , drop = FALSE]
    topGenes <- genes[row.names(involved)]
    topGenes <- tapply(names(topGenes), topGenes, paste, collapse = ";")

    list(sigModule = sigModule, discrete = omic$x, subset = data.frame(
        row.names = names(topGenes),
        metClust = topGenes), 
        pvalues = involved, covsConsidered = omic$namesCov)
}

#' @importFrom stats kruskal.test
KWtest <- function(moduleMat, classes) {
    kwTest <- apply(moduleMat, 2, function(gene) {
        kruskal.test(x = gene, g = classes)[c("p.value", "statistic")]
    })
    res <- do.call(rbind, kwTest)
    res[order(as.numeric(res[, "p.value"])), , drop = FALSE]
}

#' Extract Summary PCA from MultiOmics Objects
#'
#' Given an omic summarized by 'summarizeWithPca' extract the most important
#' features.
#'
#' @inheritParams extractSummaryFromBinary
#' @param moduleCox the coxObj of the interesting module
#' @param analysis type of analysis: survival or twoClass
#' @param loadThr the thr value to select the most influent features according
#' to the loading
#' @param atleast the minimum number of gene to retrieve
#' @param minprop the minimal proportion of cutp
#' @param analysis two-class or survival type
#'
#' @return summary for omic summarized using pca
#' \item{sigModule}{the original data for significant features}
#' \item{discrete}{the discrete version of the significant covariates converted
#' (when needed) into the discrete version}
#' \item{subset}{data.frame(row.names=names(topGenes), covariate)}
#' \item{covsConsidered}{the name of the considered omic}
extractSummaryFromPCA <- function(
    omic, multiOmicObj, moduleCox, analysis, loadThr = 0.6,
    atleast = 1, minprop = 0.1) {
    covs <- omic$namesCov
    lds <- omic$loadings
    discretePC <- createDiscreteClasses(coxObj = moduleCox, covs, analysis, 
                                        minprop = minprop)
    topLoad <- extractHighLoadingsGenes(lds, thr = loadThr, atleast = atleast)
    moduleMat <- createDataModule(omic, multiOmicObj)
    sigModule <- moduleMat[row.names(topLoad), , drop = FALSE]

    list(sigModule = sigModule, discrete = discretePC, 
         subset = topLoad, covsConsidered = covs)
}

#' @importFrom survminer surv_cutpoint surv_categorize
#' @importFrom stats median
createDiscreteClasses <- function(
    coxObj, covs, analysis, labels = c("low", "high"),
    minprop = 0.1) {
    diff <- setdiff(covs, colnames(coxObj))
    if (length(diff) != 0) {
        stop(paste0(paste(diff, collapse = ", "), " not in coxObj."))
    }

    check <- vapply(
        coxObj[, covs, drop = FALSE], check_minimal_proportion, 
        c(min_prop = minprop),
        logical(1)
    )
    if (any(!check)) {
        stop("minprop ", minprop, " is too high. Try a smaller one")
    }

    if (analysis == "survival") {
        sc <- surv_cutpoint(coxObj,
            time = "days", event = "status", variables = covs, 
            minprop = minprop
        )
        surv_categorize(sc, labels = labels)
    } else if (analysis == "twoClass") {
        covs_classified <- lapply(covs, function(cov) {
            median_value <- median(as.numeric(coxObj[[cov]]), na.rm = TRUE)
            ifelse(coxObj[[cov]] >= median_value, "high", "low")
        })
        sc <- coxObj
        sc[covs] <- covs_classified
        return(sc)
    } else {
        stop("Invalid type of analysis: ", analysis, " Check results object")
    }
}

#' @importFrom survminer surv_cutpoint surv_categorize
retrieveNumericClasses <- function(coxObj, covs, analysis) {
    diff <- setdiff(covs, colnames(coxObj))
    if (length(diff) != 0) {
        stop(paste0(paste(diff, collapse = ", "), " not in coxObj."))
    }

    if (analysis == "survival") {
        coxObj[, c("days", "status", covs), drop = FALSE]
    } else if (analysis == "twoClass") {
        coxObj[, covs, drop = FALSE]
    } else {
        stop("Invalid type of analysis ", analysis, " Check results object")
    }
}

extractHighLoadingsGenes <- function(loadings, thr, atleast = 1) {
    l <- lapply(colnames(loadings), function(pc) {
        ld <- loadings[, pc]
        genes <- names(which(abs(ld) >= thr))

        if (length(genes) == 0) {
            genes <- names(ld[order(abs(ld), 
                                    decreasing = TRUE)][seq_len(atleast)])
        }

        data.frame(row.names = genes, component = rep(pc, length(genes)), 
                   stringsAsFactors = FALSE)
    })
    l <- collapse(l)
    do.call(rbind, l)
}

collapse <- function(list) {
    df <- data.frame(genes = unlist(lapply(list, function(x) row.names(x))), 
                     components = unlist(lapply(list, function(x) x$component)),
                     stringsAsFactors = FALSE)
    tapply(seq_len(NROW(df)), df$genes, function(idx) {
        paste(df$components[idx], collapse = ";")
    }, simplify = FALSE)
}

#' Extract Summary Binary from MultiOmics Objects
#'
#' Given an omic summarized by 'summarizeToNumberOfEvents' extract the most
#' important features.
#'
#' @inheritParams extractSummaryFromBinary
#' @inheritParams extractSummaryFromPCA
#' @param labels the category labels
#'
#'
#' @return Meant for internal use only. The summary for omic summarized using
#' counting of events.
#' \item{sigModule}{the original data for significant features}
#' \item{discrete}{the discrete version of the significant covariates converted
#' (when needed) into the discrete version}
#' \item{subset}{data.frame(row.names=names(topGenes), covariates=covariate)}
#' \item{covsConsidered}{the name of the considered omic}
extractSummaryFromNumberOfEvents <- function(
    omic, multiOmicObj, moduleCox, analysis,
    n = 3, minprop = 0.1, labels = c("few", "many")) {
    covs <- omic$namesCov
    moduleMat <- createDataModule(omic, multiOmicObj)
    discreteClass <- createDiscreteClasses(
        coxObj = moduleCox, covs, analysis, labels = labels,
        minprop = minprop
    )
    numericClass <- retrieveNumericClasses(coxObj = moduleCox, covs, analysis)

    impact <- lapply(covs, mostlyMutated,
        moduleMat = t(moduleMat), name = omic$omicName,
        eventThr = omic$eventThr
    )

    mostlyImpacted <- lapply(impact, head, n = n)
    names(mostlyImpacted) <- covs

    covNames <- lapply(covs, function(cov) {
        rep(cov, length(row.names(mostlyImpacted[[cov]])))
    })
    covNames <- do.call(c, covNames)
    mostlyImpactedGenes <- unlist(lapply(mostlyImpacted, row.names))
    sigModule <- moduleMat[mostlyImpactedGenes, , drop = FALSE]

    covariates <- tapply(covNames, mostlyImpactedGenes, function(x) x)
    involved <- data.frame(covariates, stringsAsFactors = FALSE)

    list(
        sigModule = sigModule, discrete = discreteClass, subset = involved, 
        covsConsidered = omic$namesCov, numericClass = numericClass
    )
}

mostlyMutated <- function(cov, moduleMat, name, eventThr = 2) {
    direction <- gsub(name, "", cov)
    if (direction == "NEG") {
        invert <- TRUE
    } else {
        invert <- FALSE
    }
    priority <- extractPositivePortion(moduleMat, invert = invert)
    priority <- colSums(priority >= eventThr, na.rm = TRUE)
    priority <- data.frame(row.names = names(priority), priority)
    names(priority) <- cov
    priority[order(priority[[cov]], decreasing = TRUE), , drop = FALSE]
}

test_that(
    "extractyInfo_binary", {
        mut <- dummy_mutation_like_dataset()
        expect_null(summarizeToNumberOfDirectionalEvents(mut, row.names(mut)))
        x = data.frame(
            mut = apply(mut > 0, 2, any),
            stringsAsFactors = F
        )
        omic <- list(
            x = x, usedGenes = row.names(mut),
            namesCov = "mut", method = "binary", omicName = "mut", eventThr = 1
        )

        summ <- summarizeToBinaryEvents(
            mut, features = row.names(mut),
            name = "mut"
        )
        expect_identical(summ$x, x)
        discrete <- x
        discrete$mut <- as.numeric(x$mut)
        mutationCount <- rowSums(mut)
        ordMutCount <- mutationCount[order(mutationCount, decreasing = T)]
        mo <- fake_mo(omics = "mut")
        binInfo <- extractSummaryFromBinary(omic, mo, n = 3)
        expect_identical(
            row.names(binInfo$sigModule),
            head(
                names(ordMutCount),
                3
            )
        )
        expect_identical(binInfo$discrete, discrete)
    }
)


test_that(
    "extractyInfo_dirBinary", {
        fake_cnv <- dummy_cnv_like_dataset()
        omic <- summarizeToBinaryDirectionalEvents(
            fake_cnv, row.names(fake_cnv),
            name = "cnv"
        )
        mo <- fake_mo(omics = "cnv")
        dataModule <- createDataModule(omic, mo)
        cnvCountPos <- rowSums(dataModule >= 2)
        cnvCountNeg <- rowSums(dataModule <= -2)
        ordCnvCountPos <- cnvCountPos[order(cnvCountPos, decreasing = T)]
        ordCnvCountNeg <- cnvCountNeg[order(cnvCountNeg, decreasing = T)]
        ordCnvGene <- unique(
            c(
                head(
                  names(ordCnvCountPos),
                  3
              ),
                head(
                  names(ordCnvCountNeg),
                  3
              )
            )
        )

        discrete2class <- data.frame(lapply(omic$x, as.numeric))
        row.names(discrete2class) <- row.names(omic$x)
        duobleBinInfo <- extractSummaryFromBinary(omic, mo, n = 3)
        expect_identical(
            row.names(duobleBinInfo$sigModule),
            ordCnvGene
        )
        expect_identical(duobleBinInfo$discrete, discrete2class)
    }
)


test_that(
    "extractyInfo_Cluster", {
        fake_met <- dummy_methylation_like_dataset()
        omic <- summarizeInCluster(
            fake_met, row.names(fake_met),
            name = "met"
        )
        mo <- fake_mo(omics = "met")
        clsInfo <- extractSummaryFromCluster(omic, mo, n = 3)
        dataModule <- createDataModule(omic, mo)
        KMsigMat <- KWtest(
            t(dataModule),
            omic$x[, 1]
        )
        involved <- head(KMsigMat, 3)
        expect_setequal(
            row.names(clsInfo$subset),
            row.names(involved)
        )
    }
)


test_that(
    "extractyInfo_Pca", {
        fake_exp <- dummy_expression_like_dataset()
        omic <- summarizeWithPca(
            fake_exp, row.names(fake_exp),
            name = "exp", maxPCs = 1
        )
        mo <- fake_mo(omics = "exp", type = "survival")
        moview <- createMOMView(mo, row.names(fake_exp))
        cox <- createCoxObj(mo@colData, moview)
        pcaInfo <- extractSummaryFromPCA(
            omic, mo, cox, "survival", loadThr = 0.6,
            atleast = 1
        )
        lds <- omic$loadings[order(
            abs(omic$loadings),
            decreasing = T
        ),
            ]
        topgenes <- names(
            lds[abs(lds) >=
                0.6]
        )
        if (length(topgenes) ==
            0) {
            topgenes <- names(lds)[1]
        }
        expect_setequal(topgenes, row.names(pcaInfo$subset))
        expect_true(
            length(row.names(pcaInfo$subset)) >=
                1
        )
        pcaInfo <- extractSummaryFromPCA(
            omic, mo, cox, "survival", loadThr = 1,
            atleast = 0
        )
        expect_null(pcaInfo$subset)
    }
)


test_that(
    "createDiscreteClasses", {
        mo <- fake_mo(omics = "exp", type = "survival")
        moview <- createMOMView(mo, row.names(assay(mo, "exp")))
        cox <- createCoxObj(mo@colData, moview)
        expect_error(
            createDiscreteClasses(cox, covs = "mut", analysis = "survival"),
            regexp = " not in coxObj"
        )
        covs <- colnames(cox)[-c(1, 2)]
        expect_error(
            createDiscreteClasses(cox, covs = covs, analysis = "class"),
            regexp = "Invalid type of analysis: .* Check results object"
        )
        sc <- createDiscreteClasses(cox, covs, analysis = "survival")
        expect_setequal(
            colnames(sc),
            colnames(cox)
        )
        expect_setequal(
            unique(unlist(apply(sc[, covs], 2, unique, simplify = FALSE))),
            c("low", "high")
        )
        expect_s3_class(sc, "surv_categorize")
        sc <- createDiscreteClasses(cox, covs, analysis = "twoClass")
        expect_s3_class(sc, "data.frame")
        cox[, "expPC2"] <- rep(0, 200)
        expect_error(
            createDiscreteClasses(cox, covs = covs, analysis = "twoClass"),
            regexp = "minprop 0.1 is too high. Try a smaller one"
        )
    }
)


test_that(
    "retrieveNumericClasses", {
        mo <- fake_mo(omics = "cnv", type = "two-classes")
        moview <- createMOMView(mo, row.names(assay(mo, "cnv")))
        cox <- createCoxObj(mo@colData, moview)
        expect_error(
            retrieveNumericClasses(cox, covs = "mut", analysis = "twoClass"),
            regexp = " not in coxObj"
        )
        covs <- colnames(cox)[-c(1)]
        expect_error(
            retrieveNumericClasses(cox, covs = covs, analysis = "surv"),
            regexp = "Invalid type of analysis .* Check results object"
        )
    }
)


test_that(
    "extractyInfo_NumberOfEvents",
    {
        fake_mut <- dummy_mutation_like_dataset()
        omic <- summarizeToNumberOfEvents(
            fake_mut, row.names(fake_mut),
            name = "mut"
        )
        mo <- fake_mo(
            omics = "mut",
            type = "survival"
        )
        moview <- createMOMView(mo, row.names(fake_mut))
        cox <- createCoxObj(mo@colData, moview)
        countInfo <- extractSummaryFromNumberOfEvents(
            omic, mo, cox,
            analysis = "survival"
        )
        mut_sum <- rowSums(fake_mut)
        mut_sum <- mut_sum[order(mut_sum, decreasing = TRUE)]
        expect_setequal(
            names(mut_sum)[1:3],
            row.names(countInfo$subset)
        )
    }
)

conversionToSymbols <- function(idsGraphiteStyle, orgDbi = "org.Hs.eg.db") {
    if (!requireNamespace(orgDbi)) {
        return(idsGraphiteStyle)
    }

    if (is.null(idsGraphiteStyle)) {
        return(NULL)
    }

    if (!(length(grep(":", idsGraphiteStyle)) == length(idsGraphiteStyle) &
        length(unique(do.call(
            rbind, (strsplit(idsGraphiteStyle, ":"))
        )[, 1])) == 1)) {
        return(idsGraphiteStyle)
    }

    typeId <- unique(do.call(rbind, (strsplit(idsGraphiteStyle, ":")))[, 1])
    originals <- gsub(paste0(typeId, ":"), "", idsGraphiteStyle)
    symbols <- select(get(orgDbi),
        keys = originals, columns = c("SYMBOL"),
        keytype = typeId
    )$SYMBOL
    symbols[is.na(symbols)] <- originals[is.na(symbols)]
    as.character(symbols)
}


formatAnnotations <- function(listOfMostlyInvolvedGenesInOmics, sortBy) {
    involved <- listOfMostlyInvolvedGenesInOmics
    samplesList <- row.names(involved[[1]]$discrete)
    annotationFull <- lapply(seq_along(involved), function(i) {
        covNames <- involved[[i]]$covsConsidered
        annotations <- involved[[i]]$discrete[samplesList, covNames,
            drop = FALSE
        ]
        annotations
    })
    annotationFull <- do.call(cbind, annotationFull)
    if (is.null(sortBy)) {
        annotationFull <- annotationFull[
            order(
                annotationFull[, 1], annotationFull[, ncol(annotationFull)]
            ), ,
            drop = FALSE
        ]
    } else {
        ord <- getMultiColOrder(annotationFull, sortBy)
        annotationFull <- annotationFull[ord, , drop = FALSE]
    }
    annotationFull
}

sortAnnotations <- function(annotations, sortBy) {
    if (is.null(sortBy)) {
        return(annotations)
    }

    missing <- setdiff(sortBy, colnames(annotations))
    if (length(missing) != 0) {
        stop(paste0(paste(missing, collapse = ", "), ": covariates not found"))
    }

    ord <- getMultiColOrder(annotations, sortBy)
    annotations[ord, , drop = FALSE]
}

getMultiColOrder <- function(df, sortBy) {
    if (!is.data.frame(df)) {
        stop("df must be a data frame.")
    }

    columns <- paste0("df$", sortBy)
    columns <- paste(columns, collapse = ", ")
    exp <- paste0("order(", columns, ")")
    eval(parse(text = exp))
}

extractPvalues <- function(x) {
    p <- x$pvalue
    if (is.null(p)) {
        return(NA)
    } else {
        return(p)
    }
}

matchArguments <- function(dots, defaults) {
    if (length(defaults) == 0) {
        return(dots)
    }

    defaults[names(defaults) %in% names(dots)] <- NULL
    c(defaults, dots)
}

guessOmic <- function(covs) {
    unique(sub(omicsRegexp, "", covs, perl = TRUE, ignore.case = FALSE))
}

guessOmics <- function(covs) {
    sub(omicsRegexp, "", covs, perl = TRUE, ignore.case = FALSE)
}

guessOmicsColors <- function(omics) {
    uomics <- unique(omics)
    if (length(uomics) < 7) {
        MOcols <- names(MOSpalette)[seq_along(uomics)]
    } else {
        MOcols <- RColorBrewer::brewer.pal(length(uomics), "Set3")
    }
    names(MOcols) <- uomics
    MOcols
}

mapColor <- function(omic, MOcolors) {
    color <- MOSpalette[MOcolors[omic]]
    if (is.na(color)) {
        color <- MOcolors[omic]
    }
    unname(color)
}

createColors <- function(omics, MOcolors) {
    vapply(unique(omics), function(o) mapColor(o, MOcolors), character(1))
}

matchAnnotations <- function(d1, d2) {
    if (nrow(d1) != nrow(d2)) {
        stop("Annotations have different row numbers")
    }

    diff <- setdiff(row.names(d2), row.names(d1))
    if (length(diff) != 0) {
        stop(paste0(
            "We found samples", paste(diff, collapse = ", "),
            "that do not match MOM annotation"
        ))
    }

    d2 <- d2[row.names(d1), , drop = FALSE]
    d2
}

getContinousPalette <- function(palette, n) {
    switch(palette,
        red = redShades(n),
        green = greenShades(n),
        blue = blueShades(n),
        yellow = yellowShades(n),
        violet = violetShades(n),
        teal = tealShades(n)
    )
}

extractPositivePortion <- function(data, invert = FALSE) {
    .data <- data
    if (invert) {
        .data[data > 0] <- 0
        .data <- abs(.data)
    } else {
        .data[data < 0] <- 0
    }
    .data
}


#' Create the list of covariates that are going to be tested
#'
#' @param omicsObj `Omics` class object
#' @param genes genes of the clique
#'
#' @importFrom methods new
#' @importFrom survival Surv
#' @return list with
#'   1 reduced representation of the omics
#'   2 sdev
#'   3 loadings or eigenvector
#'   4 usedGenes
#'   5 method
#'   6 namesCov
#'   7 omicName
#'
createMOMView <- function(omicsObj, genes) {
    listCovariates <- lapply(
        seq_along(omicsObj@ExperimentList@listData),
        function(i) {
            test <- get(omicsObj@modelInfo[i])
            specificArgs <- omicsObj@specificArgs[[i]]
            args <- list(
                data = omicsObj@ExperimentList@listData[[i]],
                features = genes
            )
            if (!is.null(specificArgs)) {
                args <- c(args, specificArgs)
            }
            do.call(test, args)
        }
    )

    listCovariates[!vapply(listCovariates, is.null, logical(1))]
}


#' Create Cox Object
#'
#' Create the coxObj from the covariates used in the test
#'
#' @param colData colData from multiOmic object
#' @param moView modulesView or pathView from multiOmicsModules or
#' multiOmicsPathway object
#'
#' @return data.frame, samples in the rows, covariates in the columns
createCoxObj <- function(colData, moView) {
    additionalCovariates <- lapply(moView, function(mo) {
        mo$x
    })
    additionalCovariates <- do.call(cbind, additionalCovariates)

    if (is.null(additionalCovariates)) {
        return(NULL)
    }

    if (!identical(row.names(colData), row.names(additionalCovariates))) {
        stop("Mismatch in covariates and daysStatus annotations rownames.")
    }

    coxObj <- data.frame(colData, additionalCovariates)
    return(coxObj)
}


#' Create Data Module
#'
#' Extract sub-matrix for the genes of a module or pathway from data matrix of
#' a specific omic
#'
#' @param omic modulesView or pathView object
#' @param multiOmicObj object of class 'Omics'
#'
#' @return matrix, genes in the rows, samples in the columns
createDataModule <- function(omic, multiOmicObj) {
    if (omic$omicName == "met") {
        genes <- unname(unlist(omic$cls))
    } else {
        genes <- omic$usedGenes
    }

    if (isFALSE(omic$omicName %in% names(multiOmicObj@ExperimentList))) {
        stop(
            "omicName not found in ExperimentList.\n",
            "Names of experiments in ExperimentList should match",
            "the name arguments given in specificArgs"
        )
    }
    assay <- assay(multiOmicObj, omic$omicName)
    dataModule <- assay[rownames(assay) %in% genes, , drop = FALSE]
    return(dataModule)
}


#' Shows the MOSClip palette.
#'
#' This function shows the MOSClip palette.
#' Each omic should be coupled to a color panel, this match will be preserved
#' in plots.
#'
#' @return NULL. No value is returned
#'
#' @examples
#' showMOSpalette()
#'
#' @importFrom graphics axis title
#'
#' @export
showMOSpalette <- function() {
    plot(c(rep(seq_len(6), 4)), c(rep(1, 6), rep(2, 6), rep(3, 6), rep(4, 6)),
        col = apply(
            MOSpaletteSchema,
            2, c
        ), pch = 19, cex = 13, xlim = c(0.5, 6.5), ylim = c(0, 4.8), xlab = "",
        ylab = "", axes = FALSE
    )
    axis(3,
        at = seq_len(6), labels = rownames(MOSpaletteSchema), las = 1,
        cex.axis = 0.8, lwd = 0, pos = 4.5, font = 4
    )
    title("MOSClip palette")
}

test_that(
    "extractPvalues", {
        fakePvalues <- lapply(
            1:10, function(x) return(
                list(
                  pvalue = runif(
                    1, 0,
                    1
                )
              )
            )
        )
        naPvalue <- list(pvalue = NA)
        nullPvalue <- list(pvalue = NULL)

        res = sapply(fakePvalues, extractPvalues)
        expect_true(is.na(extractPvalues(naPvalue)))
        expect_true(is.na(extractPvalues(nullPvalue)))
        expect_equal(
            fakePvalues[[1]]$pvalue,
            extractPvalues(fakePvalues[[1]])
        )
        expect_equal(res, unname(unlist(fakePvalues)))
    }
)


test_that(
    "conversionToSymbols", {
        vec <- "SYMBOL:MMP15"
        vec1 <- c("SYMBOL:MMP15", "ENTREZID:10", "SYMBOL:CMA1")  #mixed ids
        vec2 <- c("SYMBOL:MMP15", "SYMBOL:MMP24", "SYMBOL:CMA1")
        vec3 <- c("ENTREZID:1", "ENTREZID:10", "ENTREZID:100")
        vec4 <- c("A1BG", "NAT2", "SYMBOL:ADA")  #not all are graphite style
        vec5 <- c(
            "UNIPROT:Q86VV6", "UNIPROT:Q9Y5R2", "UNIPROT:P23946",
            "UNIPROT:Q4FEB3"
        )  #many2one
        vec6 <- c(
            "SYMBOL:MMP15", "SYMBOL:ENRICA", "SYMBOL:CMA1",
            "SYMBOL:PAOLO"
        )  #symbols not in dictionary
        vec7 <- c(
            "ENTREZID:1", "ENTREZID:ENRICA", "ENTREZID:100",
            "ENTREZID:PAOLO"
        )  #entrez not in dictionary
        vec8 <- NULL

        expect_identical(
            conversionToSymbols(vec, "org.Hs.eg.db"),
            "MMP15"
        )
        expect_identical(
            conversionToSymbols(vec1, "org.Hs.eg.db"),
            c("SYMBOL:MMP15", "ENTREZID:10", "SYMBOL:CMA1")
        )
        expect_identical(
            conversionToSymbols(vec2, "org.Hs.eg.db"),
            c("MMP15", "MMP24", "CMA1")
        )
        expect_identical(
            conversionToSymbols(vec3, "org.Hs.eg.db"),
            c("A1BG", "NAT2", "ADA")
        )
        expect_identical(
            conversionToSymbols(vec4, "org.Hs.eg.db"),
            c("A1BG", "NAT2", "SYMBOL:ADA")
        )
        expect_identical(
            conversionToSymbols(vec5, "org.Hs.eg.db"),
            c("MMP24", "MMP24", "CMA1", "CMA1")
        )
        expect_identical(
            conversionToSymbols(vec6, "org.Hs.eg.db"),
            c("MMP15", "ENRICA", "CMA1", "PAOLO")
        )
        expect_identical(
            conversionToSymbols(vec7, "org.Hs.eg.db"),
            c("A1BG", "ENRICA", "ADA", "PAOLO")
        )
        expect_true(is.null(conversionToSymbols(vec8, "org.Hs.eg.db")))
    }
)

test_that(
    "extractPositivePortion", {
        expect_identical(
            extractPositivePortion(
                matrix(
                  c(1, 1, -1, 2),
                  2
              )
            ),
            matrix(
                c(1, 1, 0, 2),
                2
            )
        )
        expect_identical(
            extractPositivePortion(
                matrix(
                  c(1, 1, -1, 1),
                  2
              ),
                invert = T
            ),
            matrix(
                c(0, 0, 1, 0),
                2
            )
        )
    }
)

test_that(
    "check_minimal_proportion", {
        cls <- c(
            rep(0, 10),
            rep(1, 90)
        )
        expect_true(check_minimal_proportion(cls, min_prop = 0.1))
        cls[1] <- 1
        expect_false(check_minimal_proportion(cls, min_prop = 0.1))
        cls <- c(
            rep(0, 90),
            rep(20, 10)
        )
        expect_true(check_minimal_proportion(cls, min_prop = 0.1))
        cls[100] <- 0
        expect_false(check_minimal_proportion(cls, min_prop = 0.1))
    }
)




test_that(
    "filterMultiOmicsForSamples",
    {
        ex <- matrix(
            1:100, 10, 10, dimnames = list(
                letters[1:10],
                LETTERS[1:10]
            )
        )



        MO <- makeOmics(
            experiments = ExperimentList(e = ex, df = ex),
            modelInfo = c(
                "summarizeWithPca",
                "summarizeWithPca"
            ),
            specificArgs = list("a", "b")
        )

        smallMO <- filterMultiOmicsForSamples(MO, c("A"))

        expect_identical(
            smallMO@ExperimentList[[1]],
            as.matrix(smallMO@ExperimentList[[2]])
        )
        expect_error(filterMultiOmicsForSamples(MO, c("Z")))
    }
)


test_that(
    "createDataModule work", {
        mo <- fake_mo(type = "survival")
        mov <- createMOMView(mo, paste0("gene_", seq_len(200)))
        expect_length(mov, 4)
        mov[[1]]$omicName = "test"
        expect_error(
            createDataModule(mov[[1]], mo),
            paste0(
                "omicName not found in ExperimentList.\n",
                "Names of experiments in ExperimentList should match",
                "the name arguments given in specificArgs"
            )
        )
    }
)


test_that(
    "showMOSpalette work", {
        expect_no_error(showMOSpalette())
    }
)

test_that(
    "Survival Results object for pathways works",
    {
        genes <- paste0(
            "ENTREZID:", c(
                10000, 90427, 5366, 23368, 637,
                3002, 79792, 840, 5414, 5599, 8655,
                140735, 708
            )
        )
        dummy_react <- readRDS(test_path("fixtures", "reactBiggerDummy.rds"))
        dummy_Omics <- fake_mo(genes = genes, type = "survival")
        dummy_survcolData <- dummy_colData(type = "survival")

        res.survPathway <- multiOmicsSurvivalPathwayTest(
            dummy_Omics, dummy_react[[1]], survFormula = "Surv(days, status) ~",
            autoCompleteFormula = TRUE, include_from_annot = TRUE
        )

        expect_s4_class(res.survPathway, "MultiOmicsPathway")
        expect_true(
            !is.null(res.survPathway@pvalue) &
                is.numeric(res.survPathway@pvalue)
        )
        expect_true(
            !is.null(res.survPathway@zlist) &
                is.numeric(res.survPathway@zlist)
        )
        expect_true(is.list(res.survPathway@pathView))
        expect_true(
            all(
                vapply(
                  res.survPathway@pathView, function(x) !is.null(x),
                  logical(1)
              )
            )
        )

        expect_error(
            multiOmicsSurvivalPathwayTest(
                dummy_Omics, dummy_react[[1]],
                survFormula = "Surv(days, status) ~",
                autoCompleteFormula = TRUE, include_from_annot = TRUE,
                useTheseGenes = c("test1", "test2")
            ),
            "There is no nodes on the graph."
        )

    }
)


test_that(
    "Survival Results object for modules works",
    {
        genes <- paste0(
            "ENTREZID:", c(
                10000, 90427, 5366, 23368, 637,
                3002, 79792, 840, 5414, 5599, 8655,
                140735, 708
            )
        )
        dummy_react <- readRDS(test_path("fixtures", "reactBiggerDummy.rds"))
        dummy_Omics <- fake_mo(genes = genes, type = "survival")
        dummy_survcolData <- dummy_colData(type = "survival")

        res.survModule <- multiOmicsSurvivalModuleTest(
            dummy_Omics, dummy_react[[1]], survFormula = "Surv(days, status) ~",
            autoCompleteFormula = T
        )

        expect_s4_class(res.survModule, "MultiOmicsModules")
        expect_true(
            !is.null(res.survModule@alphas) &
                is.numeric(res.survModule@alphas)
        )
        expect_true(
            !is.null(res.survModule@zlists) &
                is.list(res.survModule@zlists)
        )

        graph <- convertPathway(dummy_react[[1]], NULL)
        cliques <- extractCliquesFromDag(graph)

        expect_true(is.list(res.survModule@modulesView))
        expect_identical(
            length(cliques),
            length(res.survModule@modulesView)
        )
        expect_true(
            all(
                vapply(
                  res.survModule@modulesView, function(x) !is.null(x),
                  logical(1)
              )
            )
        )

        res.survModule <- suppressWarnings(
            multiOmicsSurvivalModuleTest(
                dummy_Omics, dummy_react[[1]],
                survFormula = "Surv(days, status) ~",
                autoCompleteFormula = T, robust = TRUE
            )
        )

        expect_s4_class(res.survModule, "MultiOmicsModules")
        expect_true(
            !is.null(res.survModule@alphas) &
                is.numeric(res.survModule@alphas)
        )
        expect_true(
            !is.null(res.survModule@zlists) &
                is.list(res.survModule@zlists)
        )

        graph <- convertPathway(dummy_react[[1]], NULL)
        cliques <- extractCliquesFromDag(graph)

        expect_true(is.list(res.survModule@modulesView))
        expect_identical(
            length(cliques),
            length(res.survModule@modulesView)
        )
        expect_true(
            all(
                vapply(
                  res.survModule@modulesView, function(x) !is.null(x),
                  logical(1)
              )
            )
        )

        expect_error(
            multiOmicsSurvivalModuleTest(
                dummy_Omics, genes, survFormula = "Surv(days, status) ~",
                autoCompleteFormula = T
            ),
            "Module test cannot handle gene list"
        )

        expect_error(
            multiOmicsSurvivalModuleTest(
                dummy_Omics, dummy_react[[1]],
                survFormula = "Surv(days, status) ~",
                autoCompleteFormula = T, useTheseGenes = c("test1", "test2")
            ),
            paste0(
                "There is no intersection between expression feature ",
                "names and the node names in the graph"
            )
        )

        dummy_Omics@specificArgs$exp$method = "topological"
        expect_error(
            res.survModule <- multiOmicsSurvivalModuleTest(
                dummy_Omics, dummy_react[[1]],
                survFormula = "Surv(days, status) ~",
                autoCompleteFormula = T
            ),
            "Invalid method for module analysis: topological"
        )
    }
)


test_that(
    "Survival Test works with additional covariates",
    {
        genes <- paste0(
            "ENTREZID:", c(
                10000, 90427,
                5366, 23368,
                637, 3002, 79792,
                840, 5414, 5599,
                8655, 140735,
                708
            )
        )
        dummy_react <- readRDS(test_path("fixtures", "reactBiggerDummy.rds"))
        dummy_omics <- fake_mo(genes = genes, type = "survival")
        moview <- createMOMView(dummy_omics, genes)
        values <- seq(-1, 1, length.out = 21)
        fake_column <- data.frame(
            fake = sample(
                values, size = 200,
                replace = TRUE
            ),
            row.names = row.names(dummy_omics@colData)
        )
        dummy_omics@colData <- DataFrame(
            cbind(
                fake_column,
                dummy_omics@colData
            )
        )
        createCoxObj(
            dummy_omics@colData,
            moview
        )
        res.survModule <- multiOmicsSurvivalModuleTest(
            dummy_omics, dummy_react[[1]],
            survFormula = "Surv(days, status) ~",
            autoCompleteFormula = T,
            include_from_annot = TRUE
        )
        expect_s4_class(res.survModule, "MultiOmicsModules")
        expect_true(
            !is.null(res.survModule@alphas) &
                is.numeric(res.survModule@alphas)
        )
        expect_true(
            !is.null(res.survModule@zlists) &
                is.list(res.survModule@zlists)
        )
    }
)

#' Map Pathways ID from Graphite
#'
#' For internal use only. Retrieve pathway id and names from Pathways object.
#'
#' @param pathways a PathwayList object
#' @param pathwayNames in not NULL, a subset of pathway to extract
#'
#' @return a data frame, id and pathway name
#' 
#' @importFrom checkmate assertClass
#'
mapPathwaysIDfromGraphite <- function(pathways, pathwayNames = NULL) {
    assertClass(pathways, "PathwayList")
    if (is.null(pathwayNames)) {
        pathwayNames <- names(pathways)
    }
    l <- lapply(
        pathwayNames, function(p) {
            if (!(p %in% names(pathways))) {
                warning("No id found for ", p)
                return(NULL)
            }
            data.frame(
                id = pathways[[p]]@id, pname = p,
                stringsAsFactors = FALSE
            )
        }
    )
    do.call(rbind, l)
}

#' Estimate Single Covariance Matrix
#'
#' For internal use only. Estimate Covariance from one matrix
#'
#' @param expr a numeric matrix
#' @param shrink logical wheter to shrink the matrix
#'
#' @return a covariance matrix
#' @importFrom stats cov
#' @importFrom corpcor cov.shrink
#'
estimateExprCov <- function(expr, shrink) {
    if (shrink) {
        unclass(corpcor::cov.shrink(expr, verbose = FALSE))
    } else {
        cov(expr)
    }
}


#' Make positive and definite covariance matrix
#'
#' @param m1 matrix 1
#' @param m2 matrix 2
#' @param m3 matrix 3
#' @param threshold threshold of difference
#'
#' @return list with
#'   \item{m1}{the matrix m1 positive and definite}
#'   \item{m2}{the matrix m2 positive and definite}
#'   \item{m3}{the matrix m3 positive and definite}
#'   \item{correction}{the magneturde of the correction}
#'   \item{value}{the value}

makePositiveDefinite <- function(m1, m2 = NULL, m3 = NULL, threshold = 0.1) {
    if (is.null(m2) & is.null(m3)) {
        eig <- min(round(eigen(m1)$values, 2))
    } else {
        if (any(is.null(c(m2, m3)))) {
            stop("Both m2 and m3 are needed")
        }

        if (!(ncol(m1) == nrow(m1)) |
                !(ncol(m2) == nrow(m2)) |
                (!(ncol(m3) == nrow(m3)))) {
            stop("the matrices are not square")
        }

        if (!all(rownames(m1) == colnames(m1)) |
                !all(rownames(m2) == colnames(m2)) |
                !all(rownames(m3) == colnames(m3))) {
            stop("column and row elements must be identical")
        }

        if (!all(dim(m1) == dim(m2)) | !all(dim(m1) == dim(m3))) {
            stop("Matrices have different sizes")
        }

        if (!all(colnames(m1) == colnames(m2)) |
                !all(colnames(m1) == colnames(m3))) {
            stop("Matrices have different names")
        }

        eig <- min(round(c(
            eigen(m1)$values,
            eigen(m2)$values, eigen(m3)$values
        ), 2))
    }

    if (!(eig > 0)) {
        n <- ncol(m1)

        m1n <- m1 + (threshold - eig) * diag(n)

        m2n <- if (!is.null(m2)) {
            m2 + (threshold - eig) * diag(n)
        } else {
            NULL
        }
        m3n <- if (!is.null(m3)) {
            m3 + (threshold - eig) * diag(n)
        } else {
            NULL
        }

        correction <- TRUE
        value <- threshold - eig
    } else {
        m1n <- m1
        m2n <- m2
        m3n <- m3
        correction <- FALSE
        value <- NULL
    }

    return(list(
        m1 = m1n, m2 = m2n, m3 = m3n, correction = correction,
        value = value
    ))
}

#' Two-classes glm test.
#'
#' @param data data
#' @param fullModelFormula complete model
#' @param nullModelFormula null model formula
#' @return Two-classes glm test results
#' @importFrom stats glm poisson pchisq deviance df.residual na.omit

glmTest <- function(data, fullModelFormula, nullModelFormula) {
    glmRes <- glm(as.formula(fullModelFormula),
        family = "binomial", data = na.omit(data)
    )
    glmSummary <- summary(glmRes)
    zlist <- glmSummary$coefficients[, "Pr(>|z|)"][-1]
    names(zlist) <- row.names(glmSummary$coefficients)[-1]

    fullModel <- glm(as.formula(fullModelFormula),
        family = "binomial", data = data
    )
    nullModel <- glm(as.formula(nullModelFormula),
        family = "binomial", data = data
    )

    pvalue <- pchisq(deviance(nullModel) - deviance(fullModel),
        df.residual(nullModel) - df.residual(fullModel),
        lower.tail = FALSE
    )

    return(list(pvalue = pvalue, zlist = zlist))
}

#' @importFrom methods new
MOMglmTest <- function(
    genes, omicsObj, classAnnot, baseFormula = "classes ~ ",
    autoCompleteFormula = TRUE,
    nullModel = "classes ~ 1") {
    # check if topological method has been used
    for (i in seq_along(omicsObj@ExperimentList@listData)) {
        if (omicsObj@modelInfo[i] == "summarizeWithPca") {
            if (!is.null(omicsObj@specificArgs[[i]]$method)) {
                if (omicsObj@specificArgs[[i]]$method == "topological") {
                    stop("Invalid method for module analysis: topological")
                }
            }
        }
    }

    moView <- createMOMView(omicsObj, genes)

    additionalCovariates <- lapply(moView, function(mo) {
        mo$x
    })

    additionalCovariates <- do.call(cbind, additionalCovariates)

    if (is.null(additionalCovariates)) {
        return(NULL)
    }

    if (!identical(row.names(classAnnot), row.names(additionalCovariates))) {
        if (all(row.names(classAnnot) %in% row.names(additionalCovariates))) {
            res <- resolveAndOrder(list(
                classAnnot = classAnnot,
                additionalCovariates = additionalCovariates
            ))
            classAnnot <- res$classAnnot
            additionalCovariates <- res$additionalCovariates
        } else {
            stop("Mismatch in covariates and annotations row names.")
        }
    }

    dataTest <- data.frame(classAnnot, additionalCovariates)

    nullModelFormula <- nullModel

    dependentVar <- all.vars(as.formula(nullModelFormula))[1]

    if (!(dependentVar %in% colnames(dataTest))) {
        stop("Data does not contain one of the model dependent variables")
    }

    twoClasses <- unique(dataTest[, dependentVar])
    if (length(twoClasses) != 2) {
        stop(
            "Classes should be only two. ",
            "Check your dependent variables columns"
        )
    }

    dataTestOut <- dataTest

    if (!all(twoClasses == c(0, 1))) {
        dataTest[dataTest[, dependentVar] == twoClasses[1], dependentVar] <- 0
        dataTest[dataTest[, dependentVar] == twoClasses[2], dependentVar] <- 1
        dataTest[, dependentVar] <- as.numeric(dataTest[, dependentVar])
    }

    fullModelFormula <- baseFormula
    if (autoCompleteFormula) {
        fullModelFormula <- paste0(
            baseFormula,
            paste(colnames(additionalCovariates),
                collapse = "+"
            )
        )
    }

    res <- glmTest(dataTest, fullModelFormula, nullModelFormula)

    res$moView <- moView
    res
}

setClassUnion("characterOrNULL", c("character", "NULL"))


#' Multi Omics Modules.
#'
#' This class organizes the results of the Multi Omics Module Test analysis, in
#' which corresponds to one pathway decomposed into modules.
#'
#' @slot alphas a numeric vector of the pvalues of all the modules.
#' @slot zlists a list of numeric vectors with the zs of the covariates
#' for each module.
#' @slot modulesView a list of module information: for each omic,
#' the name of the omic, the genes used, the method, the name of the
#' covariates analyzed and other specific information based on the omic.
#' @slot modules a list with the genes that belong to the module.
#' @slot title the name of the pathway.
#' @slot analysis the type of analysis done: survival or two-class.
#' @name MultiOmicsModules-class
#' @rdname MultiOmicsModules-class
#'
setClass(
    Class = "MultiOmicsModules", slots = c(
        alphas = "numeric", zlists = "list", modulesView = "list",
        modules = "list", analysis = "characterOrNULL",
        multiOmicObj = "characterOrNULL", title = "characterOrNULL"
    )
)

#' Multi Omics Pathway.
#'
#' This class organize the results of the Multi-Omics Pathway Survival Test
#' analysis.
#'
#' @slot pvalue a numeric vector of the pvalues of the pathways.
#' @slot zlist a numeric vector with the zs of all the covariates.
#' @slot pathView a list of pathway information: for each omic,
#' the name of the omic, the genes used, the method, the name of the
#' covariates analyzed and other specific information based on the omic.
#' @slot title the name of the pathway.
#' @slot analysis the type of analysis done: survival or two-class.
#' @name MultiOmicsPathway-class
#' @rdname MultiOmicsPathway-class
#'
setClass(
    Class = "MultiOmicsPathway", slots = c(
        pvalue = "numeric", zlist = "numeric", pathView = "list",
        analysis = "characterOrNULL", multiOmicObj = "characterOrNULL",
        title = "characterOrNULL"
    )
)


#' Omics.
#'
#' This class is the storage for the different omic datasets that we need to
#' analyze. It is based on `MultiAssayExperiment`.
#'
#' @slot modelInfo a list with length equal to length(data) that are modelInfo
#' to process each dataset.
#' @slot specificArgs a list with length equal to length(data) to set
#' additional parameters specific of the modelInfo.
#'
#' @name Omics-class
#' @rdname Omics-class
#'
#' @import MultiAssayExperiment
Omics <- setClass(
    Class = "Omics", package = "MOSClip",
    slots = c(modelInfo = "character", specificArgs = "list"),
    contains = "MultiAssayExperiment"
)

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----eval = FALSE-------------------------------------------------------------
# if (!require("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("MOSClip")

## ----message=FALSE------------------------------------------------------------
library(MOSClip)
library(MultiAssayExperiment)
library(kableExtra)

data("reactSmall")
data("multiOmics")

## -----------------------------------------------------------------------------
availableOmicMethods()

## ----warning = FALSE----------------------------------------------------------
genesToConsider <- row.names(experiments(multiOmics)$exp)

moduleSurv <- lapply(reactSmall, function(g) {
  set.seed(1234)
  fcl = multiOmicsSurvivalModuleTest(multiOmics, g, 
                                     useTheseGenes = genesToConsider)
  fcl
 })

## -----------------------------------------------------------------------------
moduleSummary <- multiPathwayModuleReport(moduleSurv)

## ----echo=FALSE---------------------------------------------------------------
kable(moduleSummary[1:10,-1]) %>%
  kable_styling() %>%
  scroll_box(width = "80%", height = "400px")

## ----fig.height=6, fig.weight=6-----------------------------------------------
plotModuleReport(moduleSurv[["Activation of Matrix Metalloproteinases"]], 
                 MOcolors = c(exp = "red", met = "green", 
                              cnv = "yellow", mut = "blue"))

## ----message=FALSE------------------------------------------------------------
plotModuleInGraph(moduleSurv[["Activation of Matrix Metalloproteinases"]], 
                  pathList = reactSmall, 
                  moduleNumber = 4)

## ----fig.height=6, fig.width=7------------------------------------------------
plotModuleKM(moduleSurv[["Activation of Matrix Metalloproteinases"]], 
             moduleNumber = 4, 
             formula = "Surv(days, status) ~ expPC2 + met2k", 
             paletteNames = "Paired", risk.table = TRUE, inYears = TRUE)

## ----message=FALSE, results='hide', fig.keep='all', fig.height=7, fig.width=7----
additionalA <- colData(multiOmics)
additionalA$status[additionalA$status == 1] <- "event"
additionalA$status[additionalA$status == 0] <- "no_event"
additionalA$PFS <- as.factor(additionalA$status)
additionalA$status <- NULL
additionalA$years <- round(additionalA$days/365.24, 0)
additionalA$days <- NULL

plotModuleHeat(moduleSurv[["Activation of Matrix Metalloproteinases"]], 
               moduleNumber = 4, 
               paletteNames = c(exp = "red", met = "green", 
                                cnv = "yellow", mut = "blue"),
               additionalAnnotations = additionalA, 
               additionalPaletteNames = list(PFS = "violet", years = "teal"), 
               sortBy = c("expPC2", "met2k", "PFS", "years"), 
               withSampleNames = FALSE)

## ----fig.height=9, fig.width=10-----------------------------------------------
runSupertest(moduleSummary, pvalueThr = 0.05, zscoreThr = 0.05, 
             excludeColumns = c("pathway", "module"))

## ----warning=FALSE------------------------------------------------------------
data("multiOmicsTopo")

pathwaySurv <- lapply(reactSmall, function(g) {
  set.seed(1234)
  fcl = multiOmicsSurvivalPathwayTest(multiOmicsTopo, g, 
                                      useTheseGenes = genesToConsider)
  })

## ----fig.width=6, fig.height=4------------------------------------------------
plotMultiPathwayReport(pathwaySurv, 
                       MOcolors = c(exp = "red", mut = "blue", 
                                    cnv = "yellow", met = "green"))

## ----message=FALSE, results='hide', fig.keep='all', fig.height=7, fig.width=7----
plotPathwayHeat(pathwaySurv[["Activation of Matrix Metalloproteinases"]], 
                sortBy = c("expPC1", "cnvPOS", "PFS"), 
                paletteNames = c(exp = "red", met = "green",
                                 mut = "blue", cnv = "yellow"), 
                additionalAnnotations = additionalA, 
                additionalPaletteNames = list(PFS = "violet", years = "teal"), 
                withSampleNames = FALSE)

## ----fig.height=9, fig.width=10-----------------------------------------------
plotPathwayKM(pathwaySurv[["Activation of Matrix Metalloproteinases"]], 
              formula = "Surv(days, status) ~ expPC1 + cnvPOS", 
              paletteNames = "Paired")

## -----------------------------------------------------------------------------
sessionInfo()

#' Performs a Exact test - analysis of omics intersection
#'
#' This function performs a exact test implementing a theorical framework using
#' the SuperExactTest package. It calculates the statistical distributions of
#' multi omics set intersections. It can be used with both a MultiOmicsModules
#' or MultiOmicsPathway class objects.
#'
#' @param multiPathwayReportData data.frame, the output of the
#' \code{\link{multiPathwayReport}} or \code{\link{multiPathwayModuleReport}}
#' functions.
#' @param pvalueThr numeric value. Overall pvalue cut-off to be used
#' @param zscoreThr numeric value. Covariates coefficient cut-off to be used.
#' @param resampligThr numeric value. Filters the modules according to the
#' number of success in the resampling procedure, takes only the modules above
#' this threshold.
#' @param plot character indicating the layout for plotting. It is one of
#' \code{circular}, \code{landscape} or \code{noplot}. By default,
#' plot='circular', if plot='noplot' no plot will be provided.
#' @param sort.by character indicating how to sort the
#' intersections in the plot. It is one of 'set' (by omics), 'size'
#' (by intersection size), 'degree' (by number of intersected omics),
#' and 'p-value'.
#' @param excludeColumns a vector of characters listing the columns of
#' \code{multiPathwayReportData} object to be excluded by the analysis.
#' In the case \code{multiPathwayReportData} derives from
#' \code{\link{multiPathwayModuleReport}}
#' you should set \code{excludeColumns = c('pathway','module')}.
#' @param color.on color that represent the active omics in the sector
#' @param color.off color that represent the omics mnot considered in the
#' sector
#'
#' @details This function calculates intersection sizes between multiple set of
#' pathways or modules and performs statistical test of the intersections using
#' the total amout of analyzed pathways or modules as background. The super
#' exact test of this function was described in Wang et al 2015.
#'
#' @return a data.frame containing all the numeric information of the plot
#' included the pathways shared by different omics.
#'
#' @references
#' Minghui Wang, Yongzhong Zhao, and Bin Zhang (2015).
#' Efficient Test and Visualization of Multi-Set Intersections.
#' Scientific Reports 5: 16923.
#'
#' @examples
#' df <- data.frame(
#'     pvalue = c(0.06, 0.04, 0.04, 0.03, 0.02),
#'     cnv = c(0.07, 0.03, 0.02, 0.04, 0.01),
#'     mut = c(0.08, 0.02, 0.01, 0.04, 0.04),
#'     row.names = c(
#'         "PathwayA", "PathwayB", "PathwayC",
#'         "PathwayD", "PathwayE"
#'     )
#' )
#'
#' runSupertest(df, pvalueThr = 0.05, zscoreThr = 0.05)
#'
#' @importFrom SuperExactTest supertest
#' @importFrom grDevices colorRampPalette
#' @importFrom RColorBrewer brewer.pal
#'
#' @export

runSupertest <- function(
    multiPathwayReportData, pvalueThr = 0.05, zscoreThr = 0.05,
    resampligThr = NULL, plot = c("circular", "landscape", "noplot"),
    sort.by = c("set", "size", "degree", "p-value"),
    excludeColumns = NULL, color.on = "#f6bb42", color.off = "#D3D3D3") {
    checkReportFormat(multiPathwayReportData)
    checkColumnsExclusion(multiPathwayReportData, excludeColumns)

    checkPvalueThresholdFormat(pvalueThr, "pvalueThr")
    checkPvalueThresholdFormat(zscoreThr, "zscoreThr")

    plot <- plot[1]
    if (!(plot %in% c("circular", "landscape", "noplot"))) {
        stop("Plot argument should be either circular, landscape or noplot.")
    }

    sort.by <- sort.by[1]
    if (plot != "noplot" & (!(sort.by %in% c(
        "set", "size",
        "degree", "p-value"
    )))) {
        stop("sort.by argument should be either set, size, degree or p-value.")
    }

    universeSize <- NROW(multiPathwayReportData)
    multiPathwayReportDataSig <- multiPathwayReportData[
        multiPathwayReportData[, "pvalue"] <= pvalueThr,
    ]

    if (!is.null(resampligThr)) {
        if (is.null(multiPathwayReportDataSig$resamplingCount)) {
            stop("resamplingCount column not found. Try addResamplingCounts")
        }
        multiPathwayReportDataSig <- multiPathwayReportDataSig[
            multiPathwayReportDataSig[, "resamplingCount"] >= resampligThr,
        ]
    }

    MOlistPval <- pvalueSummary(multiPathwayReportDataSig,
        excludeColumns = excludeColumns,
        as.list = TRUE
    )

    MOlistPathSig <- lapply(MOlistPval, function(pp) {
        names(which(pp <= zscoreThr))
    })

    msetSupertest <- SuperExactTest::supertest(MOlistPathSig, n = universeSize)

    if (plot != "noplot") {
        plot(msetSupertest,
            color.on = color.on, color.off = color.off,
            heatmapColor = rev(pvalueShades),
            sort.by = sort.by, Layout = plot
        )
    }

    invisible(summary(msetSupertest)$Table)
}

#' Find Pathway Fathers
#'
#' Given the hierarchy of the pathways, this formula finds the fathers of the
#' respective pathway (e.g. pathway: 'PI3K Cascade'; father:
#' 'Signaling Pathways'). This function is necessary for calculating the
#' contribution of different omics to survival prediction in different
#' biological processes, grouping the pathways by hierarchy.
#'
#' @param pathways vector of pathway names
#' @param graphiteDB graphite DB object (e.g. an object containing all reactome
#' pathways)
#' @param hierarchy a graph object with the pathway hierarchy
#'
#' @return a vector of the pathway fathers' names
#'
#' @examples
#' data(multiOmics)
#' data(reactSmall)
#'
#' genesToUse <- row.names(multiOmics[[1]])
#'
#' MOM_list <- lapply(reactSmall[1:2], function(g) {
#'     fcl <- multiOmicsSurvivalModuleTest(multiOmics, g,
#'         survFormula = "Surv(days, status) ~",
#'         autoCompleteFormula = TRUE,
#'         useTheseGenes = genesToUse
#'     )
#'     fcl
#' })
#'
#' moduleSummary <- multiPathwayModuleReport(MOM_list)
#'
#' pathHierarchy <- downloadPathwayRelationFromReactome()
#' pathHierarchyGraph <- igraph::graph.data.frame(
#'     d = pathHierarchy,
#'     directed = TRUE
#' )
#'
#' omicsClasses2pathways <- computeOmicsIntersections(
#'     moduleSummary,
#'     pvalueThr = 1, zscoreThr = 1,
#'     excludeColumns = c("pathway", "module")
#' )
#'
#' omicsClasses2pathways <- lapply(
#'     omicsClasses2pathways,
#'     stripModulesFromPathways
#' )
#'
#' # This step requires to download the whole reactome graph, which usually
#' # takes a lot of time.
#' # reactome <- graphite::pathways('hsapiens', 'reactome')
#' # reactome <- graphite::convertIdentifiers(reactome, 'entrez')
#' # omicsClasses2fathers <- lapply(omicsClasses2pathways, 
#' #                                annotePathwayToFather, 
#' #                                graphiteDB = reactome,
#' #                                hierarchy = pathHierarchyGraph)
#'
#' @importFrom igraph V
#
#' @export

annotePathwayToFather <- function(pathways, graphiteDB, hierarchy) {
    ord <- length(igraph::V(hierarchy)) * 2
    pathway2id <- mapPathwaysIDfromGraphite(graphiteDB) # codici
    pathwayDict <- pathway2id$pname
    names(pathwayDict) <- pathway2id$id

    ids <- mapPathwaysIDfromGraphite(graphiteDB, pathways)$id
    path2fathers <- lapply(ids, getPathFathers, hierarchy, ord = ord)
    names(path2fathers) <- ids
    ids2father <- id2name(path2fathers, pathwayDict)
    unlist(ids2father)
}

#' Compute Omics Intersections
#'
#' Finds the modules that have any intersection among the available omics
#'
#' @inheritParams runSupertest
#'
#' @return a list of pathway modules present for every intersection of omics
#' present
#'
#' @examples
#' df <- data.frame(
#'     pvalue = c(0.06, 0.04, 0.04, 0.03, 0.02),
#'     cnv = c(0.07, 0.03, 0.02, 0.04, 0.01),
#'     mut = c(0.08, 0.02, 0.01, 0.04, 0.04),
#'     row.names = c(
#'         "PathwayA", "PathwayB", "PathwayC",
#'         "PathwayD", "PathwayE"
#'     )
#' )
#'
#' omicsClasses2Pathways <- computeOmicsIntersections(df,
#'     pvalueThr = 0.1,
#'     zscoreThr = 0.1
#' )
#'
#' @importFrom reshape melt
#' @export

computeOmicsIntersections <- function(
    multiPathwayReportData, pvalueThr = 0.05, zscoreThr = 0.05,
    resampligThr = NULL, excludeColumns = NULL) {
    checkReportFormat(multiPathwayReportData)
    checkColumnsExclusion(multiPathwayReportData, excludeColumns)

    checkPvalueThresholdFormat(pvalueThr, "pvalueThr")
    checkPvalueThresholdFormat(zscoreThr, "zscoreThr")

    universeSize <- NROW(multiPathwayReportData)
    multiPathwayReportDataSig <- multiPathwayReportData[
        multiPathwayReportData[, "pvalue"] <= pvalueThr,
    ]

    if (nrow(multiPathwayReportDataSig) == 0) {
        stop(
            "There is no significant modules. ",
            "Try changing the pvalue threshold"
        )
    }

    if (!is.null(resampligThr)) {
        if (is.null(multiPathwayReportDataSig$resamplingCount)) {
            stop("resamplingCount column not found. Try addResamplingCounts")
        }
        multiPathwayReportDataSig <- multiPathwayReportDataSig[
            multiPathwayReportDataSig[, "resamplingCount"] >= resampligThr,
        ]
    }

    MOlistPval <- pvalueSummary(multiPathwayReportDataSig,
        excludeColumns = excludeColumns,
        as.list = TRUE
    )

    MOlistPathSig <- lapply(MOlistPval, function(pp) {
        names(which(pp <= zscoreThr))
    })

    if (0 %in% lengths(MOlistPathSig)) {
        stop(
            "One or more omics do not have a significant z score for any of ",
            "their modules. Try increasing the z score threshold."
        )
    }

    df <- reshape::melt(MOlistPathSig)
    p2o <- tapply(seq_len(NROW(df)), df[, 1], function(idx) {
        paste(df[idx, 2], collapse = ";")
    })
    tapply(seq_along(p2o), p2o, function(idx) {
        names(p2o[idx])
    })
}

#' Remove Module Number From Pathway Name
#'
#' Function to remove the suffix corresponding to the module number of the
#' pathway name. Necessary step for \code{\link{annotePathwayToFather}} and
#' \code{\link{plotFrequencies}}
#'
#' @inheritParams annotePathwayToFather
#'
#' @return list of pathway names without the module number
#'
#' @examples
#' pathwaysModules <- list(
#'     "Intrinsic Pathway for Apoptosis.1",
#'     "Intrinsic Pathway for Apoptosis.2",
#'     "Opioid Signalling.1", "Opioid Signalling.2"
#' )
#'
#' resPathwayNames <- stripModulesFromPathways(pathwaysModules)
#'
#' @export

stripModulesFromPathways <- function(pathways) {
    sub("\\.[0-9]+", "", pathways, perl = TRUE)
}

#' Compute pvalue Summary
#'
#' @inheritParams runSupertest
#' @param as.list return a list rather than a data.frame
#'
#' @return a list
#'
#' @importFrom stats na.omit

pvalueSummary <- function(multiPathwayReportData, excludeColumns = NULL,
                          as.list = FALSE) {
    checkReportFormat(multiPathwayReportData)
    checkColumnsExclusion(multiPathwayReportData, excludeColumns)

    columnsNotExcluded <- colnames(multiPathwayReportData)[!(
        colnames(multiPathwayReportData) %in% excludeColumns)]
    multiPathwayReportData <- multiPathwayReportData[,
        columnsNotExcluded,
        drop = FALSE
    ]


    colClasses <- vapply(multiPathwayReportData, class, character(1))
    if (any(unique(colClasses) != "numeric")) {
        notNumericColumns <- colnames(multiPathwayReportData)[
            colClasses != "numeric"
        ]
        stop(paste0(
            "Data malformed. ", "The following columns are not numeric.
                Consider using excludeColumns argument: ",
            paste(notNumericColumns, collapse = ", ")
        ))
    }

    covarColumns <- colnames(multiPathwayReportData) != "pvalue"
    multiPathwayReportDataSig <- multiPathwayReportData[, covarColumns,
        drop = FALSE
    ]

    malformedColumns <- apply(multiPathwayReportDataSig, 2, function(col) {
        any(na.omit(col) > 1 | na.omit(col) < 0)
    })

    if (any(malformedColumns)) {
        stop(paste0(
            "Data malformed. The following columns are not pvalues
                (values greater than 1 or lower than 0).
                Consider using excludeColumns argument: ",
            paste(colnames(multiPathwayReportDataSig)[malformedColumns],
                collapse = ", "
            )
        ))
    }

    covars <- colnames(multiPathwayReportDataSig)
    covars2omics <- guessOmics(covars)

    MOlistPval <- tapply(colnames(multiPathwayReportDataSig),
        covars2omics, summarizeOmicsResByMinPvalue,
        mat = multiPathwayReportDataSig, simplify = FALSE
    )
    if (as.list) {
        return(MOlistPval)
    }
    do.call(cbind, MOlistPval)
}


checkReportFormat <- function(multiPathwayReportData) {
    if (!(any("pvalue" %in% colnames(multiPathwayReportData)))) {
        stop("Data malformed. There is not a overall pvalue column.")
    }

    if (is.null(grep(omicsRegexp, colnames(multiPathwayReportData)))) {
        stop("Data malformed. Covariates names not in colnames")
    }
}

checkColumnsExclusion <- function(multiPathwayReportData, excludeColumns) {
    if (is.null(excludeColumns)) {
        return()
    }

    if (any(!(excludeColumns %in% colnames(multiPathwayReportData)))) {
        stop("Data malformed. excludeColumns not present in data")
    }

    if ("pvalue" %in% excludeColumns) {
        stop("You cannot exclude the overall pvalue column.")
    }
}

checkPvalueThresholdFormat <- function(thr, name = "thr") {
    if (!is.numeric(thr)) {
        stop("pValue threshold should be numeric")
    } else if ((thr > 1) | (thr < 0)) {
        stop("pValue threshold should be a number between 0 and 1")
    }
}

#' Summarize Omics Covaraites By Min Pvalue
#'
#' For internal use only. for each line extrac 'col' and get the minimum.
#'
#' @param col columns to extract from the line
#' @param mat the matrix to be summarized (were to extract lines and 'col')
#'
#' @return a summarized version of the matrix.
#'
#' @examples
#' # summarizeOmicsResByMinPvalue(2:3, mat=matrix(c(1,2,4,1,2,5), nrow=2))
summarizeOmicsResByMinPvalue <- function(col, mat) {
    apply(as.matrix(mat[, col, drop = FALSE]), 1, minOrNA)
}

#' Minimum or NA
#'
#' For internal use only. Get back minimum or NA.
#'
#' @param x a numeric
#'
#' @return a numeric. The minimum or NA
#'
#' @examples
#' # minOrNA(c(1,5,0.1,NA))
#' # minOrNA(c(NA,NA,NA))
#'
minOrNA <- function(x) {
    if (all(is.na(x))) {
        return(NA)
    }
    min(x, na.rm = TRUE)
}

#' Compute Frequencies in a Named List
#'
#' Compute frequencies in a named list. This function is necessary for
#' \code{\link{plotFrequencies}}, in which it will calculate the frequency of
#' each pathway father for every omics intersection.
#'
#' @param elementsIntersections a named list
#'
#' @return a data.frame of the frequencies
#'
#' @examples
#' omicsIntersection <- list(
#'     "exp;met" = c("PathwayA", "PathwayB", "PathwayC"),
#'     "exp;mut" = c("PathwayA", "PathwayC"),
#'     "cnv;mut" = c("PathwayB")
#' )
#' freqDf <- computeFreqs(omicsIntersection)
#'
#' @export

computeFreqs <- function(elementsIntersections) {
    freques <- lapply(names(elementsIntersections), function(x) {
        counts <- table(elementsIntersections[[x]])
        data.frame(
            category = names(counts), frequencies = as.numeric(counts),
            class = x,
            stringsAsFactors = FALSE
        )
    })
    do.call(rbind, freques)
}


#' Plot Frequencies of Pathway Fathers for Omics intersection
#'
#' Plots the frequencies of the pathway fathers by every omics intersection
#' from a data.frame of the frequencies returned with the function
#' \code{\link{computeFreqs}}.
#'
#' @param frequencies a data.frame created from 'computeFreqs'
#' @param manualColors optional vector of colors to be used
#' @param minSize the minimal font size. Maximal frequencies will be added for
#' each class
#' @param maxSize the maximal font size dimension, all values above are clipped
#' @param width the number of character to wrap the labels
#' @param relMagnificationOfLegend the relative magnification of the text of the
#'  legend
#' @param lineSize the thickness of the lines
#'
#' @return a circular plot of the frequencies of pathway fathers
#' @examples
#' df <- data.frame(
#'     category = c("PathwayA", "PathwayB", "PathwayC", "PathwayD"),
#'     frequencies = c(1, 2, 1, 3),
#'     class = rep("Mut", 4), stringsAsFactors = FALSE
#' )
#' plotFrequencies(df)
#'
#' @importFrom ggplot2 ggplot aes element_text coord_polar geom_point
#'   geom_polygon geom_path theme theme_bw labs element_blank
#'   ggplot_gtable ggplot_build rel element_line
#' @importFrom grid grid.draw grid.newpage
#' @importFrom stats reorder
#'
#' @export

plotFrequencies <- function(
    frequencies, manualColors = NULL, minSize = 4, maxSize = 20,
    width = 20, relMagnificationOfLegend = 0.5, lineSize = 1) {
    category <- NULL
    if (!all(colnames(frequencies) %in% c("category", "frequencies", "class"))) 
      {
        stop(
            "Frequences dataframe must contain columns category, frequencies ",
            "and class"
        )
    }
    if (!is.null(manualColors)) {
        g <- ggplot2::ggplot(frequencies, aes(
            y = frequencies, x = factor(category),
            group = class, colour = class
        ))
        g <- g + ggplot2::scale_colour_manual(values = manualColors)
    } else {
        g <- ggplot2::ggplot(frequencies, aes(
            y = frequencies, x = factor(category),
            group = class, colour = class
        ))
    }
    size <- tapply(
        seq_along(frequencies$frequencies), factor(frequencies$category),
        function(idx) max(frequencies$frequencies[idx])
    )
    size <- as.numeric(size) + minSize
    size[size > maxSize] <- maxSize
    g <- suppressWarnings(g +
        ggplot2::coord_polar() +
        ggplot2::geom_point(stat = "identity") +
        ggplot2::geom_polygon(fill = NA) +
        ggplot2::geom_path(linewidth = lineSize) +
        ggplot2::labs(x = NULL) +
        ggplot2::theme_bw() +
        ggplot2::theme(
            panel.border = element_blank(),
            axis.line.x = element_blank(), axis.line.y = element_blank()
        ) + ggplot2::theme(
            panel.grid = ggplot2::element_line(linewidth = lineSize * 0.5),
            axis.text.x = element_text(size = size, colour = "black"),
            axis.text = element_text(colour = "black")
        ) +
        ggplot2::scale_x_discrete(labels = function(x) {
            lapply(strwrap(x,
                width = width,
                simplify = FALSE
            ), paste, collapse = "\n")
        }))
    g <- g + theme(
        legend.position.inside = c(1, 1),
        legend.justification = c(0, 1),
        legend.text = element_text(
            size = ggplot2::rel(relMagnificationOfLegend)
        )
    )
    grid::grid.newpage()
    gt <- ggplot2::ggplot_gtable(ggplot2::ggplot_build(g))
    gt$layout$clip <- "off"
    grid::grid.draw(gt)
}

test_that(
    "superTest works", {
        dummy_react_bigger <- readRDS(
            test_path(
                "fixtures",
                "reactBiggerDummy.rds"
            )
        )
        genes <- paste0(
            "ENTREZID:", c(
                10000, 90427,
                5366, 23368,
                637, 3002,
                79792, 840,
                5414, 5599,
                8655, 140735,
                708, 2254,
                57761, 5140,
                5289, 10714,
                7318, 1642,
                121504
            )
        )

        dummy_omics <- fake_mo(
            genes = genes,
            type = "two-classes"
        )
        dummy_annot <- dummy_colData(type = "two-classes")

        twoCModuleObj <- lapply(
            dummy_react_bigger,
            function(g) {
                fcl = multiOmicsTwoClassModuleTest(
                  dummy_omics,
                  g, dummy_annot,
                  baseFormula = "classes ~",
                  nullModel = "classes ~ 1"
              )
                fcl
            }
        )

        moduleSummary <- multiPathwayModuleReport(twoCModuleObj)

        moduleSum_notnum <- moduleSummary
        moduleSum_notnum$mut <- rep("abc", nrow(moduleSum_notnum))
        expect_error(
            computeOmicsIntersections(
                moduleSum_notnum,
                pvalueThr = 0.05,
                zscoreThr = 1,
                excludeColumns = c(
                  "pathway",
                  "module"
              )
            ),
            "columns are not numeric"
        )
        pvalSum <- pvalueSummary(
            moduleSummary,
            excludeColumns = c(
                "pathway",
                "module"
            ),
            as.list = FALSE
        )
        expect_identical(
            class(pvalSum),
            c("matrix", "array")
        )
        expect_false(
            all(
                vapply(
                  pvalSum,
                  is.null,
                  logical(1)
              )
            )
        )
        moduleSum_notpval <- moduleSummary
        moduleSum_notpval$mut <- sample(
            2:5, size = nrow(moduleSum_notpval),
            replace = TRUE
        )
        moduleSum_notpval$mut <- as.numeric(moduleSum_notpval$mut)
        expect_error(
            computeOmicsIntersections(
                moduleSum_notpval,
                pvalueThr = 0.05,
                zscoreThr = 1,
                excludeColumns = c(
                  "pathway",
                  "module"
              )
            ),
            "columns are not pvalues"
        )

        mi <- runSupertest(
            moduleSummary,
            pvalueThr = 0.05,
            zscoreThr = 1,
            excludeColumns = c(
                "pathway",
                "module"
            ),
            plot = "noplot"
        )
        expect_identical(
            class(mi),
            "data.frame"
        )
        expect_false(
            all(
                vapply(
                  mi, is.null,
                  logical(1)
              )
            )
        )

        expect_error(
            runSupertest(
                moduleSummary,
                pvalueThr = 0.05,
                zscoreThr = 1,
                excludeColumns = c(
                  "pathway",
                  "module"
              )
            ),
            NA
        )
        expect_error(
            runSupertest(
                moduleSummary,
                pvalueThr = 0.05,
                zscoreThr = 1,
                excludeColumns = c(
                  "pathway",
                  "module"
              ),
                plot = "landscape"
            ),
            NA
        )
        expect_error(
            runSupertest(
                moduleSummary,
                pvalueThr = 0.05,
                zscoreThr = 1,
                resampligThr = 60,
                excludeColumns = c(
                  "pathway",
                  "module"
              ),
                plot = "noplot"
            ),
            "resamplingCount column not found"
        )

        fake_resamplingCount <- sample(
            0:100, size = nrow(moduleSummary),
            replace = TRUE
        )
        names(fake_resamplingCount) <- row.names(moduleSummary)

        moduleSummary_resampled <- addResamplingCounts(
            moduleSummary,
            fake_resamplingCount
        )

        mi_resampled <- runSupertest(
            moduleSummary_resampled,
            pvalueThr = 0.05,
            zscoreThr = 1,
            resampligThr = 60,
            excludeColumns = c(
                "pathway",
                "module", "resamplingCount"
            ),
            plot = "noplot"
        )
        expect_identical(
            class(mi_resampled),
            "data.frame"
        )
        expect_false(
            all(
                vapply(
                  mi_resampled,
                  is.null,
                  logical(1)
              )
            )
        )

        expect_error(
            runSupertest(
                moduleSummary_resampled,
                pvalueThr = 0.05,
                zscoreThr = 1,
                resampligThr = 60,
                excludeColumns = c(
                  "pathway",
                  "module",
                  "resamplingCount"
              )
            ),
            NA
        )
        expect_error(
            runSupertest(
                moduleSummary_resampled,
                pvalueThr = 0.05,
                zscoreThr = 1,
                resampligThr = 60,
                excludeColumns = c(
                  "pathway",
                  "module",
                  "resamplingCount"
              ),
                plot = "landscape"
            ),
            NA
        )
    }
)

if (file.exists("tests/testthat/fixtures/reactBiggerDummy.rds")) {
    graph <- readRDS("tests/testthat/fixtures/reactBiggerDummy.rds")
} else {
    reactome <- pathways("hsapiens", "reactome")
    reactome <- convertIdentifiers(reactome, "entrez")
    graphs <- c(
        "Intrinsic Pathway for Apoptosis", "PI3K Cascade", "Translesion synthesis by Y family DNA polymerases bypasses lesions on DNA template",
        "Recognition of DNA damage by PCNA-containing replication complex", "Recognition and association of DNA glycosylase with site containing an affected pyrimidine"
    )
    dummy_reactome <- reactome[graphs]
    saveRDS(dummy_reactome, file = "tests/testthat/fixtures/reactBiggerDummy.rds")
}

#' Check if all the list object have the same order of pathway module
#'
#' For internal use only
#'
#' @param li a list of summaries
#'
#' @rdname resampling
#'
checkOrder <- function(li) {
    ref <- rownames(li[[1]])
    all(vapply(li, function(o) all(rownames(o) == ref), logical(1)))
}

#' Resolve disorder and difference of pathway module on the list
#'
#' For internal use only
#' @param li a list of summaries
#'
#' @rdname resampling
#'
resolveAndOrder <- function(li) {
    ref <- row.names(li[[1]])
    for (i in seq_along(li)) {
        ref <- intersect(row.names(li[[i]]), ref)
    }
    lapply(li, function(o) o[match(ref, row.names(o)), , drop = FALSE])
}

#' Merge given column from a list of summaries
#'
#' For internal use only
#'
#' @param li a list of summaries
#' @param col the column to merge
#' @param resolve weather to resolve the issues
#'
#' @return a matrix
#'
#' @rdname resampling

mergeCol <- function(li, col = "PC1", resolve = FALSE) {
    if (resolve) {
        li <- resolveAndOrder(li)
    } else {
        stopifnot(checkOrder(li))
    }
    mat <- do.call(cbind, lapply(li, function(o) o[, col]))
    apply(mat, 2, as.numeric)
}

checkStrenth <- function(boleanMatrix) {
    apply(boleanMatrix, 1, function(x) {
        length(unique(x))
    })
}

#' Filter a matrix by columns/samples
#'
#' For internal use only
#'
#' @param exp a matrix
#' @param samples the vector of samples to select
#'
#' @return a filtered matrix
#'
#' @rdname resampling
#'
filterExpr <- function(exp, samples) {
    if (length(setdiff(samples, colnames(exp))) != 0) {
        stop("Some samples are not present in the MultiOmic Object")
    }
    exp[, samples, drop = FALSE]
}

#' Filter a multiOmics object by columns/samples
#'
#' For internal use only
#'
#' @param MO a multiOmic object
#' @param samples the vector of samples to select
#'
#' @return a filtered MultiOmics objects
#' @importFrom methods as
#' @rdname resampling
#'
filterMultiOmicsForSamples <- function(MO, samples) {
    filterData <- lapply(MO@ExperimentList, function(expr) {
        if (is.matrix(expr) || is.data.frame(expr)) {
            filterExpr(expr, samples)
        } else if (is.list(expr)) {
            out <- expr
            exp <- filterExpr(expr[[1]], samples)
            out[[1]] <- exp
            out
        } else {
            stop("Something wrong 5923")
        }
    })
    MO@ExperimentList <- as(filterData, "ExperimentList")
    MO
}

#' Prepare permutations
#'
#' Prepare subset of patients for permutations
#'
#' @param fullMultiOmics a multiOmic object
#' @param nperm number of permutations
#' @param nPatients number of patients to remove for resampling
#'
#' @return list of sampled patients for each permutation
#'
#' @rdname resampling
preparePerms <- function(fullMultiOmics, nperm = 100, nPatients = 3) {
    nPatients <- as.numeric(nPatients)
    patients <- row.names(fullMultiOmics@colData)
    patientsPerms <- lapply(seq_len(nperm), function(x) {
        sample(patients, length(patients) - nPatients)
    })
    return(patientsPerms)
}


#' Resampling function for survival analysis on modules
#'
#' @param pathdb pathway database
#' @param pathwaySubset a list of pathways to resample
#' @param genesToConsider vector of genes used to filter pathways; if NULL,
#' genes found in the first experiment of the multiOmic object are used
#'
#' @inheritParams preparePerms
#'
#' @return list of the resampling tables of results
#'
#' @rdname resampling-Survival
#'
#' @examples
#' data(multiOmics)
#' data(reactSmall)
#'
#' perms <- resamplingModulesSurvival(
#'     fullMultiOmics = multiOmics, reactSmall,
#'     nperm = 10,
#'     pathwaySubset =
#'         "FGFR1 mutant receptor activation"
#' )
#'
#' @export
#'
resamplingModulesSurvival <- function(
    fullMultiOmics, pathdb, nperm = 100, pathwaySubset = NULL,
    nPatients = 3, genesToConsider = NULL) {
    patientsPerms <- preparePerms(fullMultiOmics, nperm, nPatients)

    if (is.null(genesToConsider)) {
        genesToConsider <- row.names(experiments(fullMultiOmics)[[1]])
    }

    rePathSmall <- pathdb
    if (!is.null(pathwaySubset)) {
        rePathSmall <- pathdb[pathwaySubset]
    }

    perms <- lapply(seq_len(nperm), function(boot) {
        message("boot", boot, "\n")
        pts <- patientsPerms[[boot]]
        multiOmics <- fullMultiOmics[, pts]

        multiOmicsReactome <- lapply(rePathSmall, function(g) {
            fcl <- multiOmicsSurvivalModuleTest(multiOmics, g,
                useTheseGenes = genesToConsider
            )
            fcl
        })

        multiPathwayModuleReport(multiOmicsReactome)
    })
    perms
}

#' Resampling function for two-class analysis on modules
#'
#' @inheritParams resamplingModulesSurvival
#' @param classAnnot patients class annotations
#'
#' @return list of the resampling tables of results
#'
#' @rdname resampling-TwoClass
#'
#' @examples
#' data(multiOmics)
#' data(reactSmall)
#'
#' classAnnot <- data.frame(
#'     "treatment" = c(rep("A", 25), rep("B", 25)),
#'     row.names = colnames(multiOmics[[1]])
#' )
#'
#' perms <- resamplingModulesTwoClass(
#'     fullMultiOmics = multiOmics,
#'     classAnnot, reactSmall,
#'     nperm = 10,
#'     pathwaySubset =
#'         "FGFR1 mutant receptor activation"
#' )
#'
#' @export
#'
resamplingModulesTwoClass <- function(
    fullMultiOmics, classAnnot, pathdb, nperm = 100,
    pathwaySubset = NULL, nPatients = 3, genesToConsider = NULL) {
    patientsPerms <- preparePerms(fullMultiOmics, nperm, nPatients)

    if (is.null(genesToConsider)) {
        genesToConsider <- row.names(experiments(fullMultiOmics)[[1]])
    }
    rePathSmall <- pathdb
    if (!is.null(pathwaySubset)) {
        rePathSmall <- pathdb[pathwaySubset]
    }

    perms <- lapply(seq_len(nperm), function(boot) {
        message("boot", boot, "\n")
        pts <- patientsPerms[[boot]]
        multiOmics <- fullMultiOmics[, pts]
        classes <- classAnnot[pts, , drop = FALSE]

        multiOmicsReactome <- lapply(rePathSmall, function(g) {
            fcl <- multiOmicsTwoClassModuleTest(multiOmics, g,
                classAnnot = classes, useTheseGenes = genesToConsider,
                baseFormula = paste0(
                    colnames(classes)[1],
                    " ~"
                ),
                autoCompleteFormula = TRUE, nullModel = paste0(
                    colnames(classes)[1],
                    " ~ 1"
                )
            )
            fcl
        })

        multiPathwayModuleReport(multiOmicsReactome)
    })
    perms
}

#' Resampling function for pathways (survival analysis)
#'
#' @inheritParams resamplingModulesSurvival
#'
#' @return list of the resampling tables of results
#'
#' @rdname resampling-Survival
#'
#' @export
#'
resamplingPathwaySurvival <- function(
    fullMultiOmics, pathdb, nperm = 100, pathwaySubset = NULL,
    nPatients = 3, genesToConsider = NULL) {
    patientsPerms <- preparePerms(fullMultiOmics, nperm, nPatients)

    if (is.null(genesToConsider)) {
        genesToConsider <- row.names(experiments(fullMultiOmics)[[1]])
    }
    rePathSmall <- pathdb
    if (!is.null(pathwaySubset)) {
        rePathSmall <- pathdb[pathwaySubset]
    }

    perms <- lapply(seq_len(nperm), function(boot) {
        message("boot", boot, "\n")
        pts <- patientsPerms[[boot]]
        multiOmics <- fullMultiOmics[, pts]

        multiOmicsReactome <- lapply(rePathSmall, function(g) {
            fcl <- multiOmicsSurvivalPathwayTest(multiOmics, g,
                useTheseGenes = genesToConsider
            )
            fcl
        })
        multiPathwayReport(multiOmicsReactome)
    })
    perms
}

#' Resampling function for pathways (two-class analysis)
#'
#' @inheritParams resamplingModulesTwoClass
#'
#' @return list of the resampling tables of results
#'
#' @rdname resampling-TwoClass
#'
#' @export
#'
resamplingPathwayTwoClass <- function(
    fullMultiOmics, classAnnot, pathdb, nperm = 100,
    pathwaySubset = NULL, nPatients = 3, genesToConsider = NULL) {
    patientsPerms <- preparePerms(fullMultiOmics, nperm, nPatients)

    if (is.null(genesToConsider)) {
        genesToConsider <- row.names(experiments(fullMultiOmics)[[1]])
    }
    rePathSmall <- pathdb
    if (!is.null(pathwaySubset)) {
        rePathSmall <- pathdb[pathwaySubset]
    }

    perms <- lapply(seq_len(nperm), function(boot) {
        message("boot", boot, "\n")
        pts <- patientsPerms[[boot]]
        multiOmics <- fullMultiOmics[, pts]
        classes <- classAnnot[pts, , drop = FALSE]

        multiOmicsReactome <- lapply(rePathSmall, function(g) {
            fcl <- multiOmicsTwoClassPathwayTest(multiOmics, g, classes,
                useTheseGenes = genesToConsider
            )
            fcl
        })
        multiPathwayReport(multiOmicsReactome)
    })
    perms
}

#' Select stable pathway modules
#'
#' @param success number of success to consider the pathway or module stable
#'
#' @return the subset of stable modules
#'
#' @rdname evaluateResampling
#'
#' @importFrom graphics abline
#' @export
#'
selectStablePathwaysModules <- function(perms, moduleSummary, success = 90,
                                        col = "pvalue") {
    sortedPerms <- lapply(perms, function(x) {
        x[order(row.names(x)), ]
    })

    pathwayModuleName <- moduleSummary[order(row.names(moduleSummary)), ]

    pvalue <- mergeCol(sortedPerms, col = col)
    row.names(pvalue) <- row.names(pathwayModuleName)

    allPvalues <- data.frame(
        pathwayModule = row.names(moduleSummary), pvalue = moduleSummary$pvalue,
        pvalue[row.names(moduleSummary), ], stringsAsFactors = FALSE
    )
    sortedAllPvalues <- allPvalues[order(allPvalues$pvalue), ]
    sortedPerms <- as.matrix(sortedAllPvalues[, -c(seq_len(2))])
    resampligSuccess <- apply(sortedPerms <= 0.05, 1, sum)

    plot(-log10(sortedAllPvalues$pvalue), resampligSuccess,
        xlab = "-log10(pvalue)",
        ylab = "resampling success"
    )
    abline(v = -log10(0.05), col = 2)
    abline(h = success, col = 4)
    sigModuleNames <- names(which(resampligSuccess >= success))
    ms <- moduleSummary[row.names(moduleSummary) %in% sigModuleNames, ]
    ms$pathwayModule <- NULL
    ms
}

#' Count the resampling success
#'
#' @param perms a list. Result of resampling function
#' @param moduleSummary summary of modules or pathways obtained from
#' `multiPathwayModuleReport` or `multiPathwayReport`
#' @param col the name of the column in the summary to be used to evaluate
#' resampling success
#' @param thr the threshold for significance
#'
#' @return the counts of success for each pathway or module
#'
#' @examples
#' data("multiOmics")
#' data("reactSmall")
#'
#' perms <- resamplingPathwaySurvival(multiOmics, reactSmall, nperm = 5)
#' res <- lapply(reactSmall, function(g) {
#'     multiOmicsSurvivalPathwayTest(multiOmics, g,
#'         useTheseGenes = row.names(multiOmics[[1]])
#'     )
#' })
#' pathSummary <- multiPathwayReport(res)
#' getPathwaysModulesSuccess(perms, pathSummary)
#'
#' @rdname evaluateResampling
#'
#' @export

getPathwaysModulesSuccess <- function(perms, moduleSummary, col = "pvalue",
                                      thr = 0.05) {
    sortedPerms <- lapply(perms, function(x) {
        x[order(row.names(x)), ]
    })

    ref <- row.names(sortedPerms[[1]])
    lapply(sortedPerms, function(x) {
        if (!(identical(ref, row.names(x)))) {
            stop("Perms row.names are different")
        }
    })

    pathwayModuleName <- moduleSummary[order(row.names(moduleSummary)), ]

    if (!identical(ref, row.names(pathwayModuleName))) {
        stop("moduleSummary row.names differes from perms")
    }

    pvalue <- mergeCol(sortedPerms, col = col)
    row.names(pvalue) <- row.names(pathwayModuleName)

    allPvalues <- data.frame(
        pathwayModule = row.names(moduleSummary), pvalue = moduleSummary$pvalue,
        pvalue[row.names(moduleSummary), ], stringsAsFactors = FALSE
    )

    sortedAllPvalues <- allPvalues[order(allPvalues$pvalue), ]
    sortedPerms <- as.matrix(sortedAllPvalues[, -c(seq_len(2))])
    resamplingSuccess <- apply(sortedPerms <= thr, 1, sum)
    pvalueSuccess <- sortedAllPvalues$pvalue <= thr
    resamplingSuccess[!pvalueSuccess] <- 0
    resamplingSuccess
}

#' Add resampling counts to module summary
#'
#' @param resamplingCounts the counts of success obtained with
#' `getPathwaysModulesSuccess`
#'
#' @return a module or pathway summary with resampling counts column appended
#'
#' @rdname evaluateResampling
#' @export
#'
addResamplingCounts <- function(moduleSummary, resamplingCounts) {
    moduleSummary$resamplingCount <- 0
    notFound <- setdiff(names(resamplingCounts), row.names(moduleSummary))
    if (length(notFound) > 0) {
        stop(paste0("Modules ", paste(notFound,
            collapse = ", ",
            " were not found in the module Summary"
        )))
    }

    moduleSummary[
        names(resamplingCounts),
        "resamplingCount"
    ] <- as.numeric(resamplingCounts)
    moduleSummary
}

test_that(
    "resamplingModulesTwoClass works", {
        graphs <- readRDS(test_path("fixtures", "reactBiggerDummy.rds"))
        gSubset <- graphs[c(2, 4, 5)]
        nodes <- sapply(gSubset, nodes)
        genes <- unlist(unname(lapply(nodes, function(x) sample(x, 5))))
        genes <- genes[!duplicated(genes)]
        mo <- fake_mo(genes = genes, type = "two-classes")
        res <- resamplingModulesTwoClass(
            mo, classAnnot = mo@colData, pathdb = graphs,
            pathwaySubset = names(gSubset),
            nperm = 5
        )
        expect_length(res, 5)
        expect_true(all(sapply(res, is.data.frame)))
        dims <- lapply(res, dim)
        expect_true(all(sapply(dims, function(x) all(x == dims[[1]]))))
    }
)


test_that(
    "resamplingPathwayTwoClass works", {
        graphs <- readRDS(test_path("fixtures", "reactBiggerDummy.rds"))
        gSubset <- graphs[c(1, 3, 5)]
        nodes <- sapply(gSubset, nodes)
        genes <- unlist(unname(lapply(nodes, function(x) sample(x, 5))))
        genes <- genes[!duplicated(genes)]
        mo <- fake_mo(genes = genes, type = "two-classes")
        res <- resamplingPathwayTwoClass(
            mo, classAnnot = mo@colData, pathdb = graphs,
            pathwaySubset = names(gSubset),
            nperm = 5
        )
        expect_length(res, 5)
        expect_true(all(sapply(res, is.data.frame)))
        dims <- lapply(res, dim)
        expect_true(all(sapply(dims, function(x) all(x == dims[[1]]))))
    }
)


test_that(
    "resamplingModulesSurvival works", {
        graphs <- readRDS(test_path("fixtures", "reactBiggerDummy.rds"))
        gSubset <- graphs[c(1, 2, 4)]
        nodes <- sapply(gSubset, nodes)
        genes <- unlist(unname(lapply(nodes, function(x) sample(x, 5))))
        genes <- genes[!duplicated(genes)]
        mo <- fake_mo(genes = genes, type = "survival")
        res <- resamplingModulesSurvival(
            mo, pathdb = graphs, pathwaySubset = names(gSubset),
            nperm = 5
        )
        expect_length(res, 5)
        expect_true(all(sapply(res, is.data.frame)))
        dims <- lapply(res, dim)
        expect_true(all(sapply(dims, function(x) all(x == dims[[1]]))))
    }
)


test_that(
    "resamplingPathwaySurvival works", {
        graphs <- readRDS(test_path("fixtures", "reactBiggerDummy.rds"))
        gSubset <- graphs[c(1, 3, 4)]
        nodes <- sapply(gSubset, nodes)
        genes <- unlist(unname(lapply(nodes, function(x) sample(x, 5))))
        genes <- genes[!duplicated(genes)]
        mo <- fake_mo(genes = genes, type = "survival")
        res <- resamplingPathwaySurvival(
            mo, pathdb = graphs, pathwaySubset = names(gSubset),
            nperm = 5
        )
        expect_length(res, 5)
        expect_true(all(sapply(res, is.data.frame)))
        dims <- lapply(res, dim)
        expect_true(all(sapply(dims, function(x) all(x == dims[[1]]))))
    }
)


test_that(
    "selectStablePathwaysModules works",
    {
        graphs <- readRDS(
            test_path(
                "fixtures",
                "reactBiggerDummy.rds"
            )
        )
        gSubset <- graphs[c(3, 4, 5)]
        nodes <- sapply(gSubset, nodes)
        genes <- unlist(
            unname(
                lapply(
                  nodes,
                  function(x) sample(x, 5)
              )
            )
        )
        genes <- genes[!duplicated(genes)]
        mo <- fake_mo(
            genes = genes,
            type = "survival"
        )
        modules <- lapply(
            gSubset, function(g) {
                multiOmicsSurvivalModuleTest(
                  mo, g,
                  useTheseGenes = row.names(mo@ExperimentList$exp)
              )
            }
        )
        summ <- multiPathwayModuleReport(modules)
        res <- resamplingModulesSurvival(
            mo, pathdb = graphs,
            pathwaySubset = names(gSubset),
            nperm = 5
        )
        stableModulesSummary <- selectStablePathwaysModules(
            perms = res,
            moduleSummary = summ,
            success = 2
        )
        resampligSuccessCount <- getPathwaysModulesSuccess(
            perms = res,
            moduleSummary = summ,
            thr = 0.5
        )
        moduleSummary <- addResamplingCounts(summ, resampligSuccessCount)
        expect_identical(
            colnames(moduleSummary)[NCOL(moduleSummary)],
            "resamplingCount"
        )
    }
)

## Colors
MOSpalette <- c(
    "#E33402", "#04B880", "#3871CC",
    "#E5C002", "#8C04B6", "#01B7BF"
)
names(MOSpalette) <- c("red", "green", "blue", "yellow", "violet", "teal")

MOSpaletteSchema <- data.frame(
    dark = grDevices::adjustcolor(MOSpalette,
        offset = c(
            -0.4, -0.4, -0.4, 0
        )
    ),
    smart = MOSpalette,
    light = grDevices::adjustcolor(MOSpalette,
        offset = c(0.5, 0.5, 0.5, 0)
    ),
    transparent = grDevices::adjustcolor(MOSpalette, alpha.f = 0.6),
    white = grDevices::adjustcolor(MOSpalette,
        offset = c(0.96, 0.96, 0.96, 0)
    ),
    stringsAsFactors = FALSE, check.names = FALSE
)
rownames(MOSpaletteSchema) <- c(
    "red", "green", "blue",
    "yellow", "violet", "teal"
)

# The followings are functions, use it like redShades(100) where 100 is the
# number of shades. In the case of binary map we can use redShades(2).
redShades <- grDevices::colorRampPalette(
    colors = c(
        MOSpaletteSchema["red", "white"],
        MOSpaletteSchema["red", "smart"]
    ),
    bias = 1, space = "rgb", interpolate = "linear", alpha = FALSE
)

greenShades <- grDevices::colorRampPalette(
    colors = c(
        MOSpaletteSchema["green", "white"],
        MOSpaletteSchema["green", "smart"]
    ), bias = 1, space = "rgb", interpolate = "linear", alpha = FALSE
)

blueShades <- grDevices::colorRampPalette(
    colors = c(
        MOSpaletteSchema["blue", "white"],
        MOSpaletteSchema["blue", "smart"]
    ), bias = 1, space = "rgb", interpolate = "linear", alpha = FALSE
)

yellowShades <- grDevices::colorRampPalette(
    colors = c(
        MOSpaletteSchema["yellow", "white"],
        MOSpaletteSchema["yellow", "smart"]
    ),
    bias = 1, space = "rgb",
    interpolate = "linear", alpha = FALSE
)

violetShades <- grDevices::colorRampPalette(
    colors = c(
        MOSpaletteSchema["violet", "white"],
        MOSpaletteSchema["violet", "smart"]
    ),
    bias = 1, space = "rgb", interpolate = "linear", alpha = FALSE
)

tealShades <- grDevices::colorRampPalette(
    colors = c(
        MOSpaletteSchema["teal", "white"],
        MOSpaletteSchema["teal", "smart"]
    ),
    bias = 1, space = "rgb", interpolate = "linear", alpha = FALSE
)

pvalueShades <- (grDevices::colorRampPalette(
    colors = c("#edf7f5", "#2796bd"), bias = 20,
    space = "rgb", interpolate = "linear", alpha = FALSE
))(100)

omicsRegexp <- "(PC[0-9]+|[1-9]k[1-9]?|TRUE|FALSE|POS|NEG|POSTRUE|NEGTRUE)$"

#' Omics class object with TCGA ovarian data
#'
#' An `Omics` class object containing data from TCGA ovarian cancer. The TCGA
#' data was manually selected and preprocessed. It contains 4 omics: expression,
#' methylation, mutation, and copy number variation. Additionally, it contains
#' specific arguments to perform the dimensionality reduction.
#' The datasets were downloaded from TCGA using `TCGABiolink` R package,
#' selecting only patients with primary solid tumors.
#' Expression matrix was processed first, converting gene identifiers into
#' Entrez IDs. The profiles of genes present more than once were averaged.
#' Genes with at least 100 counts in at least one patients were selected,
#' to avoid data sparsity.
#' Mutation matrix was filtered, keeping only genes with expression data
#' available. We chose to consider only missense and nonsense mutations and
#' mutation impact was also considered following Mutect2 pipeline.
#' CNV values were transformed into numeric values.
#' Methylation data were processed with Methyl Mix R package. Patients that had
#' both normal and primary tumors samples were selected. With the help of a
#' dictionary array probes were connected to CpG clusters, and finally CpG
#' clusters were mapped to genes (Entrez ID).
#' Survival annotation curated by Liu et al. (2018) was used to extract PFS
#' information.
#' Only patients with matched data across the four omics were considered.
#' After the selection of patients and genes, we performed expression
#' normalization and log2 of the counts+1 transformation. This will ensure us
#' to work with expression data approximately close to a normal distribution,
#' the most suitable distribution for the subsequent `MOSClip` tests.
#' Genes and samples were manually selected to create this small example
#' dataset for demonstration purposes.
#'
#' @format ## `multiOmics`
#' An Omics with 4 omics:
#' \describe{
#'   \item{exp}{Matrix with 151 rows and 50 columns of RNA expression values}
#'   \item{met}{A matrix with 178 rows and 50 columns of methylation data with
#'   probes clustered}
#'   \item{mut}{A matrix with 107 rows and 50 columns of mutation counts}
#'   \item{cnv}{A matrix with matrix with 145 rows and 50 columns of copy
#'   number}
#'   ...
#' }
#'
#' @usage data('multiOmics')

"multiOmics"

#' Omics class object with TCGA ovarian data for topological analysis
#'
#' An `Omics` class object containing data from TCGA ovarian cancer.
#' The data are the same as in \code{\link{multiOmics}} object.
#' Arguments in `specificArgs` slot have been set to efficiently run a
#' topological pathway analysis, i.e., the topological method is used for PCA
#' and shrink parameter is set to TRUE.
#' This method can't be used for analyses on modules.
#'
#' @format ## `multiOmicsTopo`
#' An Omics with 4 omics:
#' \describe{
#'   \item{exp}{Matrix with 151 rows and 50 columns of RNA expression values}
#'   \item{met}{A matrix with 178 rows and 50 columns of methylation data with
#'   probes clustered}
#'   \item{mut}{A matrix with 107 rows and 50 columns of mutation counts}
#'   \item{cnv}{A matrix with matrix with 145 rows and 50 columns of copy
#'   number}
#'   ...
#' }
#'
#' @usage data('multiOmicsTopo')

"multiOmicsTopo"

#' PathwayList of pathways from Reactome
#'
#' A PathwayList with three pathways necessary for the analysis:
#' 'Activation of Matrix Metalloproteinases', 'FGFR1 mutant receptor
#' activation', and 'VEGFA-VEGFR2 Pathway'. Pathways were downloaded using
#' `graphite` package and the names of the nodes were converted into
#' Entrez IDs.
#'
#' @format ## `reactSmall`
#' A PathwayList with Reactome pathways for hsapiens
#' \describe{
#'   \item{entries}{Three Reactome pathways with their nodes}
#' }
#'
#' @usage data('reactSmall')

"reactSmall"

#' ExperimentList class object with TCGA ovarian data
#'
#' An ExperimentList class object containing data from TCGA ovarian cancer.
#' The TCGA data was manually selected and preprocessed. It contains 4 omics:
#' expression, methylation, mutation, and copy number variation.
#'
#' @format ## `ExperimentList`
#' An ExperimentList with 4 omics:
#' \describe{
#'   \item{exp}{Matrix with 101 rows and 50 columns of RNA expression values}
#'   \item{met}{A matrix with 97 rows and 50 columnsof methylation data with
#'   probes clustered}
#'   \item{mut}{A matrix with 55 rows and 50 columns of mutation counts}
#'   \item{cnv}{A matrix with matrix with 101 rows and 50 columns of copy
#'   number}
#'   ...
#' }
#'
#' @usage data('ovarianDataset')

"ovarianDataset"

#' MOSClip: Multi-Omics Survival Clip
#'
#' `MOSClip` R package implements a statistical approach able to integrate
#' multi-omic data and look for survival associated gene modules. It
#' integrates multiple omics - trascriptomics, methylomics, genomic
#' mutations, and genomic copy number variations - using various data
#' dimensionality reduction strategies and multivariate models. Exploiting
#' graph theory, pathways can be decomposed into their connected
#' components, that we call modules. The analysis can then be performed at
#' the level of entire pathways or pathway modules. `MOSClip` pathway
#' analysis serves two primary purposes: testing the survival association
#' of pathways or modules using the Cox proportional hazard model, and
#' conducting a two-class analysis with a generalized linear model.
#' Additionally, the package offers valuable graphical tools to visualize
#' and interpret the results.
#'
#' To conduct a multi-omic survival analysis on pathways or modules use:
#' - \code{\link{multiOmicsSurvivalPathwayTest}}
#' - \code{\link{multiOmicsSurvivalModuleTest}}
#'
#' To perform a two-class comparison enrichment analysis on pathways or modules
#' use:
#' - \code{\link{multiOmicsTwoClassPathwayTest}}
#' - \code{\link{multiOmicsTwoClassModuleTest}}
#'
#' @references Paolo Martini, Monica Chiogna, Enrica Calura,
#' and Chiara Romualdi. 2019. “MOSClip: Multi-Omic and Survival Pathway
#' Analysis for the Identification of Survival Associated Gene and Modules.”
#' Nucleic Acids Research 47 (14): e80. \url{https://doi.org/10.1093/nar/gkz324}
#'
#' @docType package
#' @name MOSClip

"_PACKAGE"

#' compute PCs.
#'
#' For internal use only. Performs Principal Componenent analysis.
#'
#' Three methods are implemented:
#'   * regular: a regular PCA ('prcomp')
#'   * topological: PCA using a pathway topology.
#'   * sparse: sparse PCA analysis implemented by 'elasticnet'
#'
#' @inheritParams topoCompPCs
#' @param method one of 'regular', 'topological' and 'sparse'
#' @param maxPCs the maximum number of PCs to consider
#'
#' @return a list with the following elements:
#'   \item{x}{the computed PCs}
#'   \item{sdev}{the standard deviation captured by the PCs}
#'   \item{loadings}{the loadings}
#'
#' @importFrom FactoMineR estim_ncp

computePCs <- function(
    exp, shrink = FALSE, method = c("regular", "topological", "sparse"),
    cliques = NULL, maxPCs = 3
) {
    k <- min(
        FactoMineR::estim_ncp(exp, scale = FALSE, ncp.min = 1)$ncp,
        maxPCs
    )
    switch(
        method[1], regular = compPCs(exp = exp, shrink = shrink, k = k),
        topological = topoCompPCs(
            exp = exp, shrink = shrink, cliques = cliques,
            k = k
        ),
        sparse = sparseCompPCs(exp = exp, shrink = shrink, k = k)
    )
}

#' Topological PCA
#'
#' @param exp a matrix
#' @param shrink logical, whether to shrink or not.
#' @param cliques the pathway topology summarized in a list of cliques
#' @param k the number of components to use
#'
#' @return a list with the following elements:
#'   \item{x}{the computed PCs}
#'   \item{sdev}{the standard deviation captured by the PCs}
#'   \item{loadings}{the loadings}
#'
#' @importFrom qpgraph qpIPF
#'
topoCompPCs <- function(exp, shrink, cliques, k) {
    if (is.null(cliques))
        stop("Cliques argument is needed")
    nms <- colnames(exp)
    covmat <- estimateExprCov(exp, shrink)
    covmat <- makePositiveDefinite(covmat)$m1
    cliquesIdx <- lapply(cliques, function(c) match(c, row.names(covmat)))
    if (any(
        vapply(
            cliquesIdx, function(x) {
                any(is.na(x))
            }, logical(1)
        )
    ))
        stop("Some genes in cliques are not present in expression.")
    scovmat <- qpgraph::qpIPF(covmat, cliquesIdx)
    pcCov <- base::eigen(scovmat)
    eigenvector <- pcCov$vectors[, seq_len(k),
        drop = FALSE]
    scalee <- scale(exp, scale = FALSE)
    npc <- min(dim(exp))
    scores <- scalee %*% eigenvector
    colnames(scores) <- paste0("PC", seq_len(k))
    colnames(eigenvector) <- paste0("PC", seq_len(k))
    row.names(eigenvector) <- nms
    sd <- apply(scores, 2, sd)
    return(list(x = scores, sdev = sd, loadings = eigenvector))
}

#' Sparse PCA
#'
#' @inheritParams topoCompPCs
#'
#' @return a list with the following elements:
#'   \item{x}{the computed PCs}
#'   \item{sdev}{the standard deviation captured by the PCs}
#'   \item{loadings}{the loadings}
#'
#' @importFrom elasticnet spca

sparseCompPCs <- function(exp, shrink, k) {
    nms <- colnames(exp)
    covmat <- estimateExprCov(exp, shrink)
    covmat <- makePositiveDefinite(covmat)$m1
    paraSingle <- min(
        round((NCOL(exp)/2)),
        5
    )
    pcCov <- elasticnet::spca(
        covmat, K = k, para = rep(paraSingle, k),
        type = "Gram", sparse = "varnum"
    )
    eigenvector <- pcCov$loadings[, seq_len(k), drop = FALSE]
    scalee <- scale(exp, scale = FALSE)
    npc <- min(dim(exp))
    scores <- scalee %*% eigenvector
    colnames(scores) <- paste0("PC", seq_len(k))
    colnames(eigenvector) <- paste0("PC", seq_len(k))
    row.names(eigenvector) <- nms
    sd <- apply(scores, 2, sd)
    return(list(x = scores, sdev = sd, loadings = eigenvector))
}

#' Regular PCA
#'
#' @inheritParams topoCompPCs
#'
#' @return a list with the following elements:
#'   \item{x}{the computed PCs}
#'   \item{sdev}{the standard deviation captured by the PCs}
#'   \item{loadings}{the loadings}
#'
compPCs <- function(exp, shrink, k) {
    nms <- colnames(exp)
    covmat <- estimateExprCov(exp, shrink)
    covmat <- makePositiveDefinite(covmat)$m1
    scovmat <- covmat
    pcCov <- base::eigen(scovmat)
    eigenvector <- pcCov$vectors[, seq_len(k), drop = FALSE]
    scalee <- scale(exp, scale = FALSE)
    npc <- min(dim(exp))
    scores <- scalee %*% eigenvector
    colnames(scores) <- paste0("PC", seq_len(k))
    colnames(eigenvector) <- paste0("PC", seq_len(k))
    row.names(eigenvector) <- nms
    sd <- apply(scores, 2, sd)
    return(list(x = scores, sdev = sd, loadings = eigenvector))
}

#' Compute Multi Omics Two-Class in Pathways
#'
#' Performs topological two-class analysis using an `Omics` object.
#'
#' @param omicsObj object of class `Omics`
#' @param graph a pathway as a `graphNEL` object.
#' @param classAnnot a `data.frame` with the class annotation. It is necessary
#' at least a column with the classes labels, and the row.names as the samples
#' labels
#' @param baseFormula model formula to be used for the test. It should be
#' written as 'classes ~ ', while 'classes' being the column name for the class
#' labels
#' @param autoCompleteFormula a logical value. If TRUE. It autocompletes the
#' formula used to fit generalized lienar models function  using all the
#' available covariates (omics)
#' @param useTheseGenes (optional) vector of specific genes to be used
#' @param nullModel the null model formula. It should be written the same as
#' the baseFormula, followed by ' 1'. (e.g. 'classes ~ 1')
#' @param pathName (optional) title of the pathway. If NULL, `graph@title` is
#' used as title
#' @examples
#' data("multiOmics")
#' data("reactSmall")
#'
#' genesToUse <- row.names(multiOmics[[1]])
#'
#' classAnnot <- data.frame(
#'     "treatment" = c(rep("A", 25), rep("B", 25)),
#'     row.names = colnames(multiOmics[[1]])
#' )
#'
#' MOP_twoClasses <- multiOmicsTwoClassPathwayTest(
#'     multiOmics, reactSmall[[1]], classAnnot,
#'     baseFormula = "treatment ~ ", nullModel = "treatment ~ 1",
#'     useTheseGenes = genesToUse
#' )
#'
#' @return `MultiOmicsPathway` object
#'
#' @importFrom graph nodes
#' @importFrom methods new is
#'
#' @export

multiOmicsTwoClassPathwayTest <- function(
    omicsObj, graph, classAnnot, baseFormula = "classes ~ ",
    autoCompleteFormula = TRUE, useTheseGenes = NULL, nullModel = "classes ~ 1",
    pathName = NULL) {
    baseFormula_input <- strsplit(baseFormula, " ")[[1]]
    if (!(baseFormula_input[1] %in% colnames(classAnnot))) {
        stop("Invalid formula. Class column not found in classAnnot")
    } else if (length(baseFormula_input) == 1 | baseFormula_input[2] != "~") {
        stop("Invalid formula. Formula should be written as: 'classes ~'")
    }

    nullModel_input <- strsplit(nullModel, " ")[[1]]
    if (!(nullModel_input[1] %in% colnames(classAnnot))) {
        stop("Invalid formula. Class column not found in classAnnot")
    } else if (length(nullModel_input) == 1) {
        stop("Formula is too short. Formula should be written as 'classes ~ 1")
    } else if (nullModel_input[2] != "~" | nullModel_input[3] != "1") {
        stop("Invalid formula. Formula should be written as: 'classes ~'")
    }

    if (nrow(classAnnot) != nrow(omicsObj@colData)) {
        stop("Mismatch in the number of samples")
    }
    if (is.null(pathName) && is(graph, "Pathway")) {
        pathName <- graph@title
    }

    graph <- convertPathway(graph, useTheseGenes)
    genesToUse <- graph::nodes(graph)
    if (length(genesToUse) == 0) {
        stop("There is no nodes on the graph.")
    }

    moduleView <- lapply(seq_along(omicsObj@ExperimentList@listData), 
                         function(i) {
        test <- get(omicsObj@modelInfo[i])
        specificArgs <- omicsObj@specificArgs[[i]]

        cliques <- NULL
        if (omicsObj@modelInfo[i] == "summarizeWithPca") {
            genesToUse <- intersect(
                row.names(omicsObj@ExperimentList@listData[[i]]),
                genesToUse
            )
            if (identical(genesToUse, character(0))) {
                stop("Genes not found in some experiments of the omics object")
            }
            graph <- graph::subGraph(genesToUse, graph)
            cliques <- extractCliquesFromDag(graph)
        }
        args <- list(
            data = omicsObj@ExperimentList@listData[[i]], features = genesToUse,
            cliques = cliques
        )
        if (!is.null(specificArgs)) {
            args <- c(args, specificArgs)
        }
        do.call(test, args)
    })

    moduleView <- moduleView[!vapply(moduleView, is.null, logical(1))]
    covariates <- lapply(moduleView, function(mo) {
        mo$x
    })
    covariates <- do.call(cbind, covariates)

    if (is.null(covariates)) {
        return(NULL)
    }

    if (!identical(row.names(classAnnot), row.names(covariates))) {
        if (all(row.names(classAnnot) %in% row.names(covariates))) {
            res <- resolveAndOrder(list(classAnnot = classAnnot, 
                                        covariates = covariates))
            classAnnot <- res$classAnnot
            covariates <- res$covariates
        } else {
            stop("Mismatch in covariates and annotations row names.")
        }
    }

    dataTest <- data.frame(classAnnot, covariates)

    nullModelFormula <- nullModel

    dependentVar <- all.vars(as.formula(nullModelFormula))[1]
    if (!(dependentVar %in% colnames(dataTest))) {
        stop("Data does not contain one of the model dependent variables")
    }

    twoClasses <- unique(dataTest[, dependentVar])
    if (length(twoClasses) != 2) {
        stop("Classes should be only two. ", 
             "Check your dependent variables columns")
    }

    if (!all(twoClasses == c(0, 1))) {
        dataTest[dataTest[, dependentVar] == twoClasses[1], dependentVar] <- 0
        dataTest[dataTest[, dependentVar] == twoClasses[2], dependentVar] <- 1
        dataTest[, dependentVar] <- as.numeric(dataTest[, dependentVar])
    }

    fullModelFormula <- baseFormula
    if (autoCompleteFormula) {
        fullModelFormula <- paste0(baseFormula, paste(colnames(covariates), 
                                                      collapse = "+"))
    }

    res <- glmTest(dataTest, fullModelFormula, nullModelFormula)

    new("MultiOmicsPathway",
        pvalue = res$pvalue, zlist = res$zlist, pathView = moduleView,
        analysis = "twoClass", multiOmicObj = deparse(substitute(omicsObj)), 
        title = pathName
    )
}

### ****************************fine Pathway***************************


#' Computes Multi Omics Two-Class in Pathway Modules
#'
#' Performs topological two-class analysis using an `Omics` object. It
#' decomposes graphs (pathways) into modules.
#'
#' @inheritParams multiOmicsTwoClassPathwayTest
#'
#' @return `MultiOmicsModule` object
#'
#' @examples
#' data("multiOmics")
#' data("reactSmall")
#'
#' genesToUse <- row.names(multiOmics[[1]])
#'
#' classAnnot <- data.frame(
#'     "treatment" = c(rep("A", 25), rep("B", 25)),
#'     row.names = colnames(multiOmics[[1]])
#' )
#'
#' MOM_twoclasses <- multiOmicsTwoClassModuleTest(
#'     multiOmics, reactSmall[[1]], classAnnot,
#'     baseFormula = "treatment ~ ", nullModel = "treatment ~ 1",
#'     useTheseGenes = genesToUse
#' )
#'
#' @importFrom graph nodes
#' @importFrom methods new is
#' @export

multiOmicsTwoClassModuleTest <- function(
    omicsObj, graph, classAnnot, baseFormula = "classes ~",
    autoCompleteFormula = TRUE, useTheseGenes = NULL, nullModel = "classes ~ 1",
    pathName = NULL) {
    if (is(graph, "character")) {
        stop("graph argument should be a graphNEL object, not a gene list.")
    }

    baseFormula_input <- strsplit(baseFormula, " ")[[1]]
    if (!(baseFormula_input[1] %in% colnames(classAnnot))) {
        stop("Invalid formula. Class column not found in classAnnot")
    } else if (length(baseFormula_input) == 1 | baseFormula_input[2] != "~") {
        stop("Invalid formula. Formula should be written as: 'classes ~'")
    }

    nullModel_input <- strsplit(nullModel, " ")[[1]]
    if (!(nullModel_input[1] %in% colnames(classAnnot))) {
        stop("Invalid null formula. Class column not found in classAnnot")
    } else if (length(nullModel_input) == 1) {
        stop("Null formula should be written as 'classes ~ 1")
    } else if (nullModel_input[2] != "~" | nullModel_input[3] != "1") {
        stop("Invalid null formula. Formula should be written as: 'classes ~'")
    }

    if (nrow(classAnnot) != nrow(omicsObj@colData)) {
        stop("Mismatch in the number of samples")
    }
    if (is.null(pathName) & is(graph, "Pathway")) {
        pathName <- graph@title
    }

    graph <- convertPathway(graph, useTheseGenes)
    genes <- graph::nodes(graph)
    if (length(genes) == 0) {
        stop("There is no intersection between expression feature names and ", 
             "the node names in the graph.")
    }

    cliques <- extractCliquesFromDag(graph)

    results <- lapply(cliques, MOMglmTest,
        omicsObj = omicsObj, classAnnot = classAnnot,
        baseFormula = baseFormula, autoCompleteFormula = autoCompleteFormula, 
        nullModel = nullModel
    )

    alphas <- as.numeric(vapply(results, extractPvalues, numeric(1)))
    zlists <- lapply(results, function(x) x$zlist)
    momics <- lapply(results, function(x) x$moView)
    analysis <- "twoClass"

    names(alphas) <- NULL
    new("MultiOmicsModules",
        alphas = alphas, zlists = zlists, modulesView = momics,
        modules = cliques, analysis = analysis, 
        multiOmicObj = deparse(substitute(omicsObj)),
        title = pathName
    )
}

test_that(
    "Two Class Pathway Test works", {
        genes <- paste0(
            "ENTREZID:", c(
                10000, 90427, 5366, 23368, 637,
                3002, 79792, 840, 5414, 5599, 8655,
                140735, 708
            )
        )
        dummy_react <- readRDS(test_path("fixtures", "reactBiggerDummy.rds"))
        dummy_Omics <- fake_mo(genes = genes, type = "two-classes")
        dummy_annot <- dummy_colData(type = "two-classes")

        twoCPathwayObj <- multiOmicsTwoClassPathwayTest(
            dummy_Omics, dummy_react[[1]], dummy_annot,
            baseFormula = "classes ~", nullModel = "classes ~ 1"
        )

        expect_s4_class(twoCPathwayObj, "MultiOmicsPathway")
        expect_true(
            !is.null(twoCPathwayObj@pvalue) &
                is.numeric(twoCPathwayObj@pvalue)
        )
        expect_true(
            !is.null(twoCPathwayObj@zlist) &
                is.numeric(twoCPathwayObj@zlist)
        )
        expect_true(is.list(twoCPathwayObj@pathView))
        expect_true(
            all(
                vapply(
                  twoCPathwayObj@pathView, function(x) !is.null(x),
                  logical(1)
              )
            )
        )

        test_annot <- rbind("A", dummy_annot)
        expect_error(
            multiOmicsTwoClassPathwayTest(
                dummy_Omics, dummy_react[[1]], test_annot,
                baseFormula = "classes ~", nullModel = "classes ~ 1"
            ),
            "Mismatch in the number of samples"
        )

        test_annot <- dummy_annot
        test_annot[1, ] <- "C"
        expect_error(
            multiOmicsTwoClassPathwayTest(
                dummy_Omics, dummy_react[[1]], test_annot,
                baseFormula = "classes ~", nullModel = "classes ~ 1"
            ),
            paste0(
                "Classes should be only two. ",
                "Check your dependent variables columns"
            )
        )

        test_annot <- dummy_annot
        test_order <- sample(
            row.names(test_annot),
            200, replace = FALSE
        )
        test_annot <- test_annot[test_order, , drop = FALSE]
        expect_error(
            multiOmicsTwoClassPathwayTest(
                dummy_Omics, dummy_react[[1]], test_annot,
                baseFormula = "classes ~", nullModel = "classes ~ 1"
            ),
            NA
        )

        test_annot <- dummy_annot[-1, , drop = FALSE]
        expect_error(
            multiOmicsTwoClassPathwayTest(
                dummy_Omics, dummy_react[[1]], test_annot,
                baseFormula = "classes ~", nullModel = "classes ~ 1"
            ),
            "Mismatch in the number of samples"
        )

        expect_error(
            multiOmicsTwoClassPathwayTest(
                dummy_Omics, dummy_react[[1]], dummy_annot,
                baseFormula = "classes ~", nullModel = "test ~ 1"
            ),
            "Invalid formula. Class column not found in classAnnot"
        )

        expect_error(
            multiOmicsTwoClassPathwayTest(
                dummy_Omics, dummy_react[[1]], dummy_annot,
                baseFormula = "classes ~", nullModel = "classes ~ 1",
                useTheseGenes = c("test1", "test2")
            ),
            "There is no nodes on the graph"
        )

        test_mo <- fake_mo(type = "two-classes")
        expect_error(
            multiOmicsTwoClassPathwayTest(
                test_mo, dummy_react[[1]], dummy_annot,
                baseFormula = "classes ~", nullModel = "classes ~ 1"
            ),
            "Genes not found in some experiments of the omics object"
        )
    }
)



test_that(
    "Two Class Module Test works", {
        genes <- paste0(
            "ENTREZID:", c(
                10000, 90427, 5366, 23368, 637,
                3002, 79792, 840, 5414, 5599, 8655,
                140735, 708
            )
        )
        dummy_react <- readRDS(test_path("fixtures", "reactBiggerDummy.rds"))
        dummy_Omics <- fake_mo(genes = genes, type = "two-classes")
        dummy_annot <- dummy_colData(type = "two-classes")

        twoCModuleObj <- suppressWarnings(
            multiOmicsTwoClassModuleTest(
                dummy_Omics, dummy_react[[1]], dummy_annot,
                baseFormula = "classes ~", nullModel = "classes ~ 1"
            )
        )

        expect_s4_class(twoCModuleObj, "MultiOmicsModules")
        expect_true(
            !is.null(twoCModuleObj@alphas) &
                is.numeric(twoCModuleObj@alphas)
        )
        expect_true(
            !is.null(twoCModuleObj@zlists) &
                is.list(twoCModuleObj@zlists)
        )

        graph <- convertPathway(dummy_react[[1]], NULL)
        cliques <- extractCliquesFromDag(graph)

        expect_true(is.list(twoCModuleObj@modulesView))
        expect_identical(
            length(cliques),
            length(twoCModuleObj@modulesView)
        )
        expect_true(
            all(
                vapply(
                  twoCModuleObj@modulesView, function(x) !is.null(x),
                  logical(1)
              )
            )
        )

        test_annot <- rbind("A", dummy_annot)
        expect_error(
            multiOmicsTwoClassModuleTest(
                dummy_Omics, dummy_react[[1]], test_annot,
                baseFormula = "classes ~", nullModel = "classes ~ 1"
            ),
            "Mismatch in the number of sample"
        )

        test_annot <- dummy_annot
        rownames(test_annot)[1] <- "test"
        expect_error(
            multiOmicsTwoClassModuleTest(
                dummy_Omics, dummy_react[[1]], test_annot,
                baseFormula = "classes ~", nullModel = "classes ~ 1"
            ),
            "Mismatch in covariates and annotations row names."
        )

        test_annot <- dummy_annot
        test_annot[1, ] <- "C"
        expect_error(
            multiOmicsTwoClassModuleTest(
                dummy_Omics, dummy_react[[1]], test_annot,
                baseFormula = "classes ~", nullModel = "classes ~ 1"
            ),
            paste0(
                "Classes should be only two. ",
                "Check your dependent variables columns"
            )
        )

        test_annot <- dummy_annot
        test_order <- sample(
            row.names(test_annot),
            200, replace = FALSE
        )
        test_annot <- test_annot[test_order, , drop = FALSE]
        expect_error(
            suppressWarnings(
                multiOmicsTwoClassModuleTest(
                  dummy_Omics, dummy_react[[1]],
                  test_annot, baseFormula = "classes ~",
                  nullModel = "classes ~ 1"
              )
            ),
            NA
        )

        test_annot <- dummy_annot[-1, , drop = FALSE]
        expect_error(
            multiOmicsTwoClassModuleTest(
                dummy_Omics, dummy_react[[1]], test_annot,
                baseFormula = "classes ~", nullModel = "classes ~ 1"
            ),
            "Mismatch in the number of samples"
        )

        expect_error(
            multiOmicsTwoClassModuleTest(
                dummy_Omics, dummy_react[[1]], dummy_annot,
                baseFormula = "classes ~", nullModel = "test ~ 1"
            ),
            "Invalid null formula. Class column not found in classAnnot"
        )

        expect_error(
            multiOmicsTwoClassModuleTest(
                dummy_Omics, genes, dummy_annot,
                baseFormula = "classes ~", nullModel = "classes ~ 1"
            ),
            "graph argument should be a graphNEL object, not a gene list."
        )

        expect_error(
            multiOmicsTwoClassModuleTest(
                dummy_Omics, dummy_react[[1]], dummy_annot,
                baseFormula = "classes ~", nullModel = "classes ~ 1",
                useTheseGenes = c("test1", "test2")
            ),
            paste0(
                "There is no intersection between expression feature ",
                "names and the node names in the graph."
            )
        )

        dummy_Omics@specificArgs$exp$method = "topological"
        expect_error(
            multiOmicsTwoClassModuleTest(
                dummy_Omics, dummy_react[[1]], dummy_annot,
                baseFormula = "classes ~", nullModel = "classes ~ 1"
            ),
            "Invalid method for module analysis: topological"
        )

    }
)

#' Compute Multi Omics Survival in Pathways
#'
#' Performs topological survival analysis using an `Omics` object.
#'
#' @param omicsObj Object of class `Omics`
#' @param graph a pathway in `graphNEL`, `Pathway` or geneset format
#' @param survFormula a character with the formula to compute survival
#' @param autoCompleteFormula logical. If TRUE autocomplete the `survFormula`
#' using all the available covariates
#' @param useTheseGenes vector of genes used to filter pathways
#' @param pathName title of the pathway. If NULL and graph is `Pathway`,
#' `graph@title` is used as title
#' @param robust logical, whether the robust mode should be used
#' for cox model analysis
#' @param include_from_annot logical. If TRUE compute cox model analysis
#' using additional covariates from `colData`
#'
#' @return `MultiOmicsPathway` object
#'
#' @examples
#' data(multiOmics)
#' data(reactSmall)
#'
#' genesToUse <- row.names(multiOmics[[1]])
#'
#' MOP_survival <- multiOmicsSurvivalPathwayTest(multiOmics, reactSmall[[1]],
#'     survFormula = "Surv(days, status) ~", autoCompleteFormula = TRUE,
#'     useTheseGenes = genesToUse
#' )
#'
#' @importFrom graph nodes
#' @importFrom methods new is
#' @importFrom survival Surv
#' @export

multiOmicsSurvivalPathwayTest <- function(
    omicsObj, graph, survFormula = "Surv(days, status) ~",
    autoCompleteFormula = TRUE, useTheseGenes = NULL, pathName = NULL,
    robust = FALSE, include_from_annot = FALSE) {
    if (is.null(pathName) && is(graph, "Pathway")) {
        pathName <- graph@title
    }

    graph <- convertPathway(graph, useTheseGenes)
    genesToUse <- graph::nodes(graph)
    if (length(genesToUse) == 0) {
        stop("There is no nodes on the graph.")
    }

    # cicle over the datasets (expression, methylation ...)
    pathView <- lapply(
        seq_along(omicsObj@ExperimentList@listData),
        function(i) {
            test <- get(omicsObj@modelInfo[i])
            specificArgs <- omicsObj@specificArgs[[i]]

            # Inizialize cliques to null
            cliques <- NULL
            if (omicsObj@modelInfo[i] == "summarizeWithPca") {
                # compute cliques
                genesToUse <- intersect(
                    row.names(omicsObj@ExperimentList@listData[[i]]), genesToUse
                )
                if (length(genesToUse) == 0) {
                    stop("Genes not found in graph nodes")
                }

                graph <- graph::subGraph(genesToUse, graph)
                cliques <- extractCliquesFromDag(graph)
            }
            args <- list(
                data = omicsObj@ExperimentList@listData[[i]], 
                features = genesToUse,
                cliques = cliques
            )

            if (!is.null(specificArgs)) {
                args <- c(args, specificArgs)
            }

            do.call(test, args)
        }
    )

    pathView <- pathView[!vapply(pathView, is.null, logical(1))]

    coxObj <- createCoxObj(omicsObj@colData, pathView)
    add_covs <- unlist(lapply(pathView, function(mo) {
        mo$namesCov
    }))

    if (include_from_annot) {
        add_annot_covs <- colnames(omicsObj@colData)[
            !colnames(omicsObj@colData) %in% c("days", "status")
        ]
        add_covs <- c(add_covs, add_annot_covs)
    }

    formula <- survFormula
    if (autoCompleteFormula) {
        formula <- paste0(survFormula, paste(add_covs, collapse = "+"))
    }

    if (robust) {
        scox <- survivalcoxr(coxObj, formula)
    } else {
        scox <- survivalcox(coxObj, formula)
    }

    new("MultiOmicsPathway",
        pvalue = scox$pvalue, zlist = scox$zlist, pathView = pathView,
        analysis = "survival", multiOmicObj = deparse(substitute(omicsObj)),
        title = pathName
    )
}

#' Compute Multi Omics Survival in Pathway Modules
#'
#' Performs survival analysis using an `Omics` object. The pathway (graph) used
#' is decomposed in modules (cliques) using graph theory.
#'
#' @inheritParams multiOmicsSurvivalPathwayTest
#'
#' @return `MultiOmicsModules` object
#'
#' @examples
#' data(multiOmics)
#' data(reactSmall)
#'
#' genesToUse <- row.names(multiOmics[[1]])
#'
#' MOM_survival <- multiOmicsSurvivalModuleTest(multiOmics, reactSmall[[1]],
#'     survFormula = "Surv(days, status) ~", autoCompleteFormula = TRUE,
#'     useTheseGenes = genesToUse
#' )
#'
#' @importFrom graph nodes
#' @importFrom methods new is
#' @importFrom survival Surv
#'
#' @export

multiOmicsSurvivalModuleTest <- function(
    omicsObj, graph, survFormula = "Surv(days, status) ~",
    autoCompleteFormula = TRUE, useTheseGenes = NULL, pathName = NULL,
    robust = FALSE, include_from_annot = FALSE) {
    if (is(graph, "character")) {
        stop("Module test cannot handle gene list.")
    }

    if (is.null(pathName) & is(graph, "Pathway")) {
        pathName <- graph@title
    }

    graph <- convertPathway(graph, useTheseGenes)

    genes <- graph::nodes(graph)
    if (length(genes) == 0) {
        stop(
            "There is no intersection between expression ",
            "feature names and the node names in the graph."
        )
    }

    # create the modules
    cliques <- extractCliquesFromDag(graph)

    results <- lapply(cliques, MOMSurvTest,
        omicsObj = omicsObj, survFormula = survFormula,
        autoCompleteFormula = autoCompleteFormula, robust = robust,
        include_from_annot = include_from_annot
    )

    alphas <- as.numeric(vapply(results, extractPvalues, as.numeric(1)))
    zlist <- lapply(results, function(x) x$zlist)
    momics <- lapply(results, function(x) x$moView)
    modules <- cliques

    names(alphas) <- NULL
    new("MultiOmicsModules",
        alphas = alphas, zlists = zlist, modulesView = momics,
        modules = modules, analysis = "survival",
        multiOmicObj = deparse(substitute(omicsObj)),
        title = pathName
    )
}

# Creates fake matrices
dummy_mutation_like_dataset <- function(genes = NULL, seed = 1234) {
    set.seed(seed)
    mut <- dummy_cnv_like_dataset(genes = genes)
    mut[abs(mut) <
        2] <- 0
    mut[abs(mut) >=
        2] <- 1
    colnames(mut) <- paste0("P_", seq_len(NCOL(mut)))
    if (is.null(genes)) {
        row.names(mut) <- paste0("gene_", seq_len(NROW(mut)))
    } else {
        row.names(mut) <- genes
    }
    return(mut)
}

dummy_cnv_like_dataset <- function(genes = NULL, seed = 1234) {
    set.seed(seed)
    if (!is.null(genes)) {
        num1 <- floor(length(genes)/2) -
            1
        genesSize <- c(
            num1, length(genes) -
                num1
        )
    } else {
        genesSize <- c(3, 2)
    }
    patientsRatio <- list(
        c(150, 50),
        c(75, 125)
    )

    lowValues <- sample(
        c(-1, 0, 0, 0, 1, 1),
        patientsRatio[[1]][1] * genesSize[1], replace = TRUE
    )
    highValues <- sample(
        c(-2, 0, 0, 0, 0, 2, 2),
        patientsRatio[[1]][2] * genesSize[1], replace = TRUE
    )
    lowValues2nd <- sample(
        c(-2, 0, 0, 0, 0, 0, 2),
        patientsRatio[[2]][1] * genesSize[2], replace = TRUE
    )
    highValues2nd <- sample(
        c(-1, 0, 0, 0, 0, 0, 1),
        patientsRatio[[2]][2] * genesSize[2], replace = TRUE
    )

    fake_cnv <- rbind(
        cbind(
            matrix(
                lowValues, ncol = patientsRatio[[1]][1],
                nrow = genesSize[1]
            ),
            matrix(
                highValues, ncol = patientsRatio[[1]][2],
                nrow = genesSize[1]
            )
        ),
        cbind(
            matrix(
                lowValues2nd, ncol = patientsRatio[[2]][1],
                nrow = genesSize[2]
            ),
            matrix(
                highValues2nd, ncol = patientsRatio[[2]][2],
                nrow = genesSize[2]
            )
        )
    )

    if (is.null(genes)) {
        row.names(fake_cnv) <- paste0("gene_", seq_len(NROW(fake_cnv)))
    } else {
        row.names(fake_cnv) <- genes
    }
    colnames(fake_cnv) <- paste0("P_", seq_len(NCOL(fake_cnv)))
    return(fake_cnv)
}

dummy_methylation_like_dataset <- function(genes = NULL, seed = 1234) {
    if (!is.null(genes)) {
        num1 <- floor(length(genes)/2) -
            1
        genesSize <- c(
            num1, length(genes) -
                num1
        )
    } else {
        genesSize <- c(3, 2)
    }
    patientsRatio <- list(
        c(150, 50),
        c(75, 125)
    )

    set.seed(seed)

    lowValues <- runif(patientsRatio[[1]][1] * genesSize[1], 0, 0.2)
    highValues <- runif(patientsRatio[[1]][2] * genesSize[1], 0.7, 0.99)
    lowValues2nd <- runif(patientsRatio[[2]][1] * genesSize[2], 0.6, 1)
    highValues2nd <- runif(patientsRatio[[2]][2] * genesSize[2], 0.2, 0.4)

    fake_data <- rbind(
        cbind(
            matrix(
                lowValues, ncol = patientsRatio[[1]][1],
                nrow = genesSize[1]
            ),
            matrix(
                highValues, ncol = patientsRatio[[1]][2],
                nrow = genesSize[1]
            )
        ),
        cbind(
            matrix(
                lowValues2nd, ncol = patientsRatio[[2]][1],
                nrow = genesSize[2]
            ),
            matrix(
                highValues2nd, ncol = patientsRatio[[2]][2],
                nrow = genesSize[2]
            )
        )
    )


    if (is.null(genes)) {
        row.names(fake_data) <- paste0("gene_", seq_len(NROW(fake_data)))
    } else {
        row.names(fake_data) <- genes
    }
    colnames(fake_data) <- paste0("P_", seq_len(NCOL(fake_data)))
    return(fake_data)
}

dummy_methylation_like_flat_dataset <- function(genes = NULL, seed = 1234) {
    flat_data <- matrix(
        c(
            rep(0.3, 191),
            rep(0.4, 9)
        ),
        ncol = 200, nrow = 1, dimnames = list(
            paste0("gene_", seq_len(1)),
            paste0("P_", seq_len(200))
        )
    )

    row.names(flat_data) <- paste0("gene_", seq_len(NROW(flat_data)))
    colnames(flat_data) <- paste0("P_", seq_len(NCOL(flat_data)))
    return(flat_data)
}

dummy_expression_like_dataset <- function(genes = NULL, seed = 1234) {
    set.seed(seed)
    if (!is.null(genes)) {
        num1 <- floor(length(genes)/2) -
            1
        genesSize <- c(
            num1, length(genes) -
                num1
        )
    } else {
        genesSize <- c(3, 2)
    }

    patientsRatio <- list(
        c(150, 50),
        c(75, 125)
    )

    lowValues <- rnorm(patientsRatio[[1]][1] * genesSize[1], 5, 1)
    highValues <- rnorm(patientsRatio[[1]][2] * genesSize[1], 8, 1)
    lowValues2nd <- rnorm(patientsRatio[[2]][1] * genesSize[2], 9, 1)
    highValues2nd <- rnorm(patientsRatio[[2]][2] * genesSize[2], 2, 1)

    fake_exp <- rbind(
        cbind(
            matrix(
                lowValues, ncol = patientsRatio[[1]][1],
                nrow = genesSize[1]
            ),
            matrix(
                highValues, ncol = patientsRatio[[1]][2],
                nrow = genesSize[1]
            )
        ),
        cbind(
            matrix(
                lowValues2nd, ncol = patientsRatio[[2]][1],
                nrow = genesSize[2]
            ),
            matrix(
                highValues2nd, ncol = patientsRatio[[2]][2],
                nrow = genesSize[2]
            )
        )
    )

    if (is.null(genes)) {
        row.names(fake_exp) <- paste0("gene_", seq_len(NROW(fake_exp)))
    } else {
        row.names(fake_exp) <- genes
    }
    colnames(fake_exp) <- paste0("P_", seq_len(NCOL(fake_exp)))
    return(fake_exp)
}

create_met_cluster_dict <- function(dataset) {
    dict = as.list(row.names(dataset))
    names(dict) <- row.names(dataset)
    return(dict)
}

# create fake colData
dummy_colData <- function(len = 200, type = "survival") {
    num1 <- sample(1:(len - 1), 1)
    num2 <- len - num1
    if (type == "two-classes") {
        dummy_colData <- data.frame(
            classes = c(
                rep("A", num1),
                rep("B", num2)
            )
        )
    } else if (type == "survival") {
        dummy_colData <- data.frame(
            status = sample(
                c(0, 1),
                size = len, replace = TRUE
            ),
            days = sample(5:5000, size = len, replace = TRUE)
        )
    }
    rownames(dummy_colData) <- paste0("P_", seq_len(len))
    return(dummy_colData)
}


# create fake multi-omic data
fake_mo <- function(
    genes = NULL, type = "survival", omics = c("exp", "met", "mut", "cnv"),
    modelInfo = NULL, specificArgs = NULL
) {
    exp <- dummy_expression_like_dataset(genes = genes)
    mut <- dummy_mutation_like_dataset(genes = genes)
    met <- dummy_methylation_like_dataset(genes = genes)
    cnv <- dummy_cnv_like_dataset(genes = genes)
    exp_list <- ExperimentList(exp = exp, mut = mut, met = met, cnv = cnv)
    cdata <- dummy_colData(
        len = dim(exp)[2],
        type
    )
    modelInfo = c(
        exp = "summarizeWithPca", met = "summarizeInCluster",
        mut = "summarizeToNumberOfEvents",
        cnv = "summarizeToNumberOfDirectionalEvents"
    )
    specificArgs = list(
        exp = list(name = "exp"),
        met = list(name = "met"),
        mut = list(name = "mut"),
        cnv = list(name = "cnv")
    )
    mo <- makeOmics(
        experiments = exp_list[omics], colData = cdata,
        modelInfo = modelInfo[omics], specificArgs = specificArgs[omics]
    )
    return(mo)
}

test_that(
    "makeOmics", {
        fake_exp <- dummy_expression_like_dataset()
        fake_exp2 <- fake_exp[, -1]
        new_order <- sample(colnames(fake_exp))
        fake_ord <- fake_exp[, new_order]
        new_order_dup <- sample(
            row.names(fake_exp),
            replace = TRUE
        )
        fake_dup <- fake_exp[new_order_dup, ]

        expect_message(
            makeOmics(experiments = ExperimentList(exp = fake_exp)),
            "Data and relative methods to analyze them must be equal in length."
        )
        expect_message(
            makeOmics(
                experiments = ExperimentList(exp = fake_exp, exp2 = fake_exp),
                modelInfo = c("summarizeWithPca", "test"),
                specificArgs = "test"
            ),
            "data and specificArgs must be equal in length."
        )
        expect_message(
            makeOmics(
                experiments = ExperimentList(exp = fake_exp),
                modelInfo = "test", specificArgs = "test"
            ),
            "test modelInfo not found in method. Try availableOmicMethods."
        )
        expect_message(
            makeOmics(
                experiments = ExperimentList(exp = fake_exp, exp2 = fake_exp2),
                modelInfo = c("summarizeWithPca", "summarizeWithPca"),
                specificArgs = list("pca", "pca")
            ),
            "Mismatch in sample numbers"
        )
        expect_message(
            makeOmics(
                experiments = ExperimentList(exp = fake_exp, exp2 = fake_dup),
                modelInfo = c("summarizeWithPca", "summarizeWithPca"),
                specificArgs = list("pca", "pca")
            ),
            "Duplicated row.names found in omics "
        )
        expect_message(
            mo <- makeOmics(
                experiments = ExperimentList(exp = fake_exp, exp2 = fake_ord),
                modelInfo = c("summarizeWithPca", "summarizeWithPca"),
                specificArgs = list("pca", "pca")
            ),
            "Samples order mismatch"
        )
        expect_null(mo)
        expect_s4_class(fake_mo(), "Omics")

        exp0 <- matrix(0, nrow = 5, ncol = 200)
        colnames(exp0) <- paste0("P_", seq_len(NCOL(exp0)))
        expect_error(
            makeOmics(
                experiments = ExperimentList(exp = exp0),
                modelInfo = c("summarizeWithPca"),
                specificArgs = list("pca")
            ),
            "Some experiment matrices contains only 0 or NA values: "
        )
    }
)

#' @importFrom methods new
#' @importFrom survival Surv

MOMSurvTest <- function(
    genes, omicsObj, survFormula = "Surv(days, status) ~", 
    autoCompleteFormula = TRUE,
    robust = FALSE, include_from_annot = FALSE) {
    # check if topological method has been used
    for (i in seq_along(omicsObj@ExperimentList@listData)) {
        if (omicsObj@modelInfo[i] == "summarizeWithPca") {
            if (!is.null(omicsObj@specificArgs[[i]]$method)) {
                if (omicsObj@specificArgs[[i]]$method == "topological") {
                    stop("Invalid method for module analysis: topological")
                }
            }
        }
    }

    moView <- createMOMView(omicsObj, genes)
    formula <- survFormula
    coxObj <- createCoxObj(omicsObj@colData, moView)

    add_covs <- unlist(lapply(moView, function(mo) {
        mo$namesCov
    }))

    if (include_from_annot) {
        add_annot_covs <- colnames(coxObj)[!colnames(coxObj) %in% c(
            "days",
            "status"
        )]
        add_covs <- c(add_covs, add_annot_covs)
    }

    if (autoCompleteFormula) {
        formula <- paste0(survFormula, paste(add_covs, collapse = "+"))
    }

    if (is.null(coxObj)) {
        scox <- list()
    } else {
        if (robust) {
            scox <- survivalcoxr(coxObj, formula)
        } else {
            scox <- survivalcox(coxObj, formula)
        }
    }

    scox$moView <- moView

    scox
}

setClassUnion("characterOrNULL", c("character", "NULL"))


#' Omics class initializer function
#'
#' makeOmics creates the `Omics` object necessary to perform most of the
#' analyses of this package. It contains all the omics data in the format of a
#' `ExperimentList`, the clinical data, and all the information necessary for
#' the dimensionality reduction step.
#'
#' @param experiments A \code{list} or \link{ExperimentList} of all
#' combined experiments
#' @param colData A \code{\linkS4class{DataFrame}} or \code{data.frame} of
#' characteristics for all biological units
#' @param sampleMap A \code{DataFrame} or \code{data.frame} of assay names,
#' sample identifiers, and colname samples
#' @param metadata An optional argument of 'ANY' class (usually list) for
#' content describing the experiments
#' @param drops A \code{list} of unmatched information
#' (included after subsetting)
#' @param modelInfo A list with length equal to length(data) that are modelInfo
#' to process each dataset
#' @param specificArgs a list with length equal to length(data) to set
#' additional parameters specific of the modelInfo
#'
#' @return an `Omics` class object
#'
#' @examples
#' data(ovarianDataset)
#'
#' myColData <- data.frame(
#'     status = sample(c(0, 1), 50, replace = TRUE),
#'     days = sample(c(0, 500), 50, replace = TRUE),
#'     row.names = colnames(ovarianDataset$exp)
#' )
#'
#' myOmicsObj <- makeOmics(
#'     experiments = ovarianDataset,
#'     colData = myColData,
#'     modelInfo = c(
#'         "summarizeWithPca",
#'         "summarizeInCluster",
#'         "summarizeToNumberOfEvents",
#'         "summarizeToNumberOfDirectionalEvents"
#'     ),
#'     specificArgs = list(
#'         pcaArgs = list(
#'             name = "exp", shrink = "FALSE",
#'             method = "sparse", maxPCs = 3
#'         ),
#'         clusterArgs = list(
#'             name = "met",
#'             max_cluster_number = 3
#'         ),
#'         countEvent = list(name = "mut", min_prop = 0.05),
#'         cnvAgv = list(name = "cnv", min_prop = 0.05)
#'     )
#' )
#'
#' @importFrom S4Vectors DataFrame
#'
#' @export

makeOmics <- function(experiments = ExperimentList(),
                      colData = S4Vectors::DataFrame(),
                      sampleMap = S4Vectors::DataFrame(
                          assay = factor(),
                          primary = character(),
                          colname = character()
                      ),
                      metadata = list(), drops = list(),
                      modelInfo = character(), specificArgs = list()) {
    if (missing(sampleMap)) {
        if (missing(colData)) {
            MAE <- MultiAssayExperiment(experiments)
        } else {
            MAE <- MultiAssayExperiment(experiments, colData)
        }
    } else if (missing(colData)) {
        colData <- S4Vectors::DataFrame(row.names <- unique(
            sampleMap[["primary"]]
        ))
        MAE <- MultiAssayExperiment(experiments, colData, sampleMap)
    } else {
        MAE <- MultiAssayExperiment(experiments, colData, sampleMap)
    }

    if (length(MAE@ExperimentList) != length(modelInfo)) {
        message("Data and relative methods to analyze ",
                "them must be equal in length")
        return()
    }
    if (length(MAE@ExperimentList) != length(specificArgs)) {
        message("data and specificArgs must be equal in length.")
        return()
    }

    match <- !(modelInfo %in% availableOmicMethods())
    if (any(match)) {
        message(paste(
            paste(modelInfo[match], collapse = ", "),
            "modelInfo not found in method.",
            "Try availableOmicMethods."
        ))
        return()
    }

    samplesNumber <- vapply(MAE@ExperimentList, ncol, integer(1))
    if (length(unique(samplesNumber)) != 1) {
        message("Mismatch in sample numbers")
        return()
    }

    samples <- lapply(MAE@ExperimentList, colnames)
    if (length(samples) > 1) {
        ref <- samples[[1]]
        cmps <- vapply(seq(from = 2, to = length(samples)), function(i) {
            identical(ref, samples[[i]])
        }, logical(1))
        if (!all(cmps)) {
            message("Samples order mismatch")
            return()
        }
    }
    duplo <- vapply(MAE@ExperimentList, function(data) {
        any(duplicated(row.names(data)))
    }, logical(1))
    if (any(duplo)) {
        message(paste0(
            "Duplicated row.names found in omics ",
            paste(which(duplo), collapse = ", ")
        ))
        return()
    }

    data_validation <- lapply(MAE@ExperimentList@listData, function(exp) {
        all(exp == 0 | is.na(exp))
    })

    if (any(data_validation == TRUE)) {
        stop(paste0(
            "Some experiment matrices contains only 0 or NA values: ",
            paste(names(data_validation)[
                which(data_validation == TRUE)
            ], collapse = ", ")
        ))
    }

    new("Omics",
        ExperimentList = MAE@ExperimentList, colData = MAE@colData,
        sampleMap = MAE@sampleMap, metadata = MAE@metadata,
        modelInfo = modelInfo, specificArgs = specificArgs
    )
}



#' A generic functions showing parameter associated with each omics
#' @param object an object of class `Omics`
#'
#' @return NULL. No value is returned
#'
#' @examples
#' data(multiOmics)
#'
#' showOmics(multiOmics)
#'
#' @export
setGeneric("showOmics", function(object) standardGeneric("showOmics"))

#' @export
#' @describeIn Omics shows model parameters
#' @param object an object of class `Omics`

setMethod("showOmics", signature(object = "Omics"), function(object) {
    nm <- names(assays(object))
    if (is.null(nm)) {
        nm <- seq_len(length(nm))
    }
    for (i in seq_along(nm)) {
        cat(paste0(
            "Data \"", nm[i], "\" to be processed with \"",
            object@modelInfo[[i]], "\". "
        ))
        if (is.null(object@specificArgs[[i]])) {
            cat("Default parameters\n")
        } else {
            cat("Arguments:\n")
            arguments <- vapply(
                seq_along(object@specificArgs[[i]]),
                function(argI) {
                    values <- object@specificArgs[[i]][[argI]]
                    if (is.list(values)) {
                        values <- values[seq_len(2)]
                        values <- paste(
                            paste(names(values),
                                unlist(values),
                                sep = " -> "
                            ),
                            collapse = " ,"
                        )
                        values <- paste0(values, " ...")
                    }
                    paste(names(object@specificArgs[[i]])[argI],
                        values,
                        sep = " :"
                    )
                }, character(1)
            )
            cat(paste(arguments, collapse = "\n"), "\n")
        }
    }
})

#' A generic function showing pathway's module info
#' @param object an object of class `MultiOmicsModules`
#'
#' @return NULL. No value is returned
#'
#' @examples
#' data(multiOmics)
#' data(reactSmall)
#'
#' genesToUse <- row.names(multiOmics[[1]])
#'
#' MOM_survival <- multiOmicsSurvivalModuleTest(multiOmics, reactSmall[[1]],
#'     survFormula = "Surv(days, status) ~", autoCompleteFormula = TRUE,
#'     useTheseGenes = genesToUse
#' )
#'
#' showModule(MOM_survival)
#'
#' @export
setGeneric("showModule", function(object) standardGeneric("showModule"))

#' @export
#' @describeIn MultiOmicsModules shows module info
#' @param object an object of class `MultiOmicsModules`

setMethod("showModule",
    signature = "MultiOmicsModules",
    definition = function(object) {
        sthis <- seq_len(min(length(object@alphas), 3))
        sthis <- order(object@alphas)[sthis]

        sigCliquesIdx <- which(object@alphas <= 0.05)

        if (!is.null(object@title)) {
            cat("\"", object@title, "\"\n", sep = "")
        }

        for (i in sthis) {
            cat(paste0("Module ", i, ": pvalue ", object@alphas[i], "\n"))
            covs <- names(which(object@zlists[[i]] <= 0.05))
            if (length(covs) != 0) {
                cat(
                    "The following covariates are implicated:\n",
                    paste(covs, collapse = ", "),
                    "\n"
                )
            }
            cat("Module is composed by the followings:\n")
            cat(paste(object@modules[[i]], collapse = ", "))
            cat("\n-+-\n")
        }

        if (length(sthis) < length(sigCliquesIdx)) {
            cat(paste0(
                "There are other ", length(sigCliquesIdx) - length(sthis),
                " cliques with pvalue <= 0.05"
            ))
        }

        invisible(NULL)
    }
)

#' A generic function showing pathway info
#' @param object an object of class `MultiOmicsPathway`
#'
#' @return NULL. No value is returned
#'
#' @examples
#' data(multiOmics)
#' data(reactSmall)
#'
#' genesToUse <- row.names(multiOmics[[1]])
#'
#' MOP_survival <- multiOmicsSurvivalPathwayTest(multiOmics, reactSmall[[1]],
#'     survFormula = "Surv(days, status) ~", autoCompleteFormula = TRUE,
#'     useTheseGenes = genesToUse
#' )
#'
#' showPathway(MOP_survival)
#'
#' @export
setGeneric("showPathway", function(object) standardGeneric("showPathway"))

#' @export
#' @describeIn MultiOmicsPathway shows module info
#' @param object an object of class `MultiOmicsPathway`

setMethod("showPathway",
    signature = "MultiOmicsPathway",
    definition = function(object) {
        if (!is.null(object@title)) {
            cat("\"", object@title, "\"\n", sep = "")
        }
        cat(paste0("Pathway overall pvalue: ", object@pvalue, "\n"))
        invisible(NULL)
    }
)

#' A generic function to convert pathway
#' @param graph a graphNEL object
#' @param useTheseGenes list of genes to be used
#'
#' @return NULL. No value is returned
setGeneric("convertPathway", function(graph, useTheseGenes) {
    standardGeneric("convertPathway")
})

#' @importFrom graph subGraph
#' @importFrom graphite pathwayGraph
#' @importClassesFrom graphite Pathway
setMethod(
    "convertPathway", signature("Pathway", "characterOrNULL"),
    function(graph, useTheseGenes) {
        graph <- graphite::pathwayGraph(graph)
        if (!is.null(useTheseGenes)) {
            usableGenes <- intersect(useTheseGenes, graph::nodes(graph))
            graph <- graph::subGraph(usableGenes, graph)
        }
        graph
    }
)

#' @importFrom graph subGraph
#' @importClassesFrom graph graphNEL
setMethod(
    "convertPathway", signature("graphNEL", "characterOrNULL"),
    function(graph, useTheseGenes) {
        if (!is.null(useTheseGenes)) {
            usableGenes <- intersect(useTheseGenes, graph::nodes(graph))
            graph <- graph::subGraph(usableGenes, graph)
        }
        graph
    }
)

#' @importFrom graph subGraph
setMethod(
    "convertPathway", signature("character", "characterOrNULL"),
    function(graph, useTheseGenes) {
        graph <- new("graphNEL", nodes = graph, edgeL = list())
        if (!is.null(useTheseGenes)) {
            usableGenes <- intersect(useTheseGenes, graph::nodes(graph))
            graph <- graph::subGraph(usableGenes, graph)
        }
        graph
    }
)

#' Guess the most influent features from MultiOmics Survival or Two-class
#' results.
#'
#' Given a pathway analyzed by `multiOmicsModuleSurvivalTest` or
#' `multiOmicsTwoClassModuleTest`, it retrieves for each omic the most
#' influent features.
#'
#' @param pathway `MultiOmicsModules` object from a pathway
#' @param moduleNumber the module number
#' @param loadThr the loading threshold to select genes (PCA only)
#' @param n the maximum number of genes to retrieve (cluster and binary only)
#' @param atleast the minimum number of features to select (PCA only)
#' @param min_prop_pca the minimal proportion to compute the PCA classes
#' @param min_prop_events the minimal proportion to compute the event classes
#' @param ... additional arguments passed to `get` function
#'
#' @return a list. Each item of the list corresponds to an omic that is
#' summarized with the specific 'extractSummary' functions. Each item is the
#' summary for an omic summarized using the setted method: pvalues are present
#' only for cluster method.
#'
guessInvolvement <- function(
    pathway, moduleNumber, loadThr = 0.6, n = 3, atleast = 1,
    min_prop_pca = 0.1, min_prop_events = 0.1, ...) {
    multiOmicObj <- get(pathway@multiOmicObj, ...)
    omics <- pathway@modulesView[[moduleNumber]]
    moduleCox <- createCoxObj(multiOmicObj@colData, moView = omics)
    analysis <- pathway@analysis

    lapply(
        omics, function(omic) {
            if (omic$method == "pca") {
                extractSummaryFromPCA(
                    omic, multiOmicObj, moduleCox, analysis, loadThr,
                    atleast,
                    minprop = min_prop_pca
                )
            } else if (omic$method == "cluster") {
                extractSummaryFromCluster(omic, multiOmicObj, n)
            } else if (omic$method %in% c("binary", "directedBinary")) {
                extractSummaryFromBinary(omic, multiOmicObj, n)
            } else if (omic$method %in% c("count", "directedCount")) {
                extractSummaryFromNumberOfEvents(
                    omic, multiOmicObj, moduleCox, analysis,
                    n = 3,
                    minprop = min_prop_events
                )
            } else {
                stop("Unsupported method.")
            }
        }
    )
}

#' Guess the most influent features from MultiOmics Survival or Two-class
#' results.
#'
#' Given a pathway analyzed by `multiOmicsSurvivalPathwayTest` or
#' `multiOmicsTwoClassPathwayTest`, it retrieves for each omic the most
#' influent features.
#'
#' @inheritParams guessInvolvement
#'
#' @inherit guessInvolvement return
#'
guessInvolvementPathway <- function(
    pathway, loadThr = 0.6, n = 3, atleast = 1, min_prop_pca = 0.1,
    min_prop_events = 0.1, ...) {
    multiOmicObj <- get(pathway@multiOmicObj, ...)
    omics <- pathway@pathView
    moduleCox <- createCoxObj(multiOmicObj@colData, moView = omics)
    analysis <- pathway@analysis

    lapply(
        omics, function(omic) {
            if (omic$method == "pca") {
                extractSummaryFromPCA(
                    omic, multiOmicObj, moduleCox, analysis, loadThr,
                    atleast,
                    minprop = min_prop_pca
                )
            } else if (omic$method == "cluster") {
                extractSummaryFromCluster(omic, multiOmicObj, n)
            } else if (omic$method %in% c("binary", "directedBinary")) {
                extractSummaryFromBinary(omic, multiOmicObj, n)
            } else if (omic$method %in% c("count", "directedCount")) {
                extractSummaryFromNumberOfEvents(
                    omic, multiOmicObj, moduleCox, analysis,
                    n = 3,
                    minprop = min_prop_events
                )
            } else {
                stop("Unsupported method.")
            }
        }
    )
}

#' Download Reactome Pathway Relations
#' 
#' Download Pathway Relations from Reactome. The file is retrieved from the 
#' [url](https://reactome.org/download/current/ReactomePathwaysRelation.txt)
#'
#' @param url the location of the file. Can be local. If NULL pick the package 
#' reactome file.
#' @param speciesAbbr species acronim
#'
#' @return A data frame with 2 columns: 
#'  \item{parent}{The Reactome pathway ID of the parent pathway.}
#'  \item{child}{The Reactome pathway ID of the child pathway.}
#' 
#' 
#' @importFrom utils read.table data
#'
#' @examples
#' downloadPathwayRelationFromReactome()
#' 
#' @export
downloadPathwayRelationFromReactome <- function(
    url = NULL, speciesAbbr = "HSA") {
    if (is.null(url)) {
        url <- system.file(
            "extdata", "ReactomePathwaysRelation.txt", package = "MOSClip",
            mustWork = TRUE
        )
    }
    df <- read.table(
        url, sep = "\t", header = FALSE, quote = "\"", stringsAsFactors = FALSE,
        check.names = FALSE
    )
    colnames(df) <- c("parent", "child")
    df <- df[grepl(speciesAbbr, df$parent) &
        grepl(speciesAbbr, df$child),
        , drop = FALSE]
    row.names(df) <- NULL
    df
}

#' Retrieves pathways relatives
#'
#' For internal use only. Retrieves relatives given a pathway id.
#'
#' Pathway Hierarchy is needed as igraph object.
#'
#' @param pathway a pathway id
#' @param hierarchyGraph a igraph with pathway hierarchy
#' @param ord how far you need to go backward
#' @param plot plot relatives. For checking purpose
#'
#' @return a character vector with the relatives
#'
#' @importFrom checkmate assertClass
#' @importFrom igraph V V<- as_ids make_ego_graph ego distances
#'
getPathFathers <- function(pathway, hierarchyGraph, ord = 3, plot = FALSE) {
    checkmate::assertClass(hierarchyGraph, "igraph")

    if (!(pathway %in% names(V(hierarchyGraph)))) {
        warning("Id ", pathway, " is not in the hierarchy.")
        return(pathway)
    }

    mm <- make_ego_graph(hierarchyGraph, ord, nodes = pathway, mode = "in")
    mmlist <- ego(hierarchyGraph, ord, nodes = pathway, mode = "in")

    if (plot)
        plot(mm[[1]])

    chain <- as_ids(mmlist[[1]])
    parents <- chain[-1]
    if (length(parents) == 0)
        return(chain)

    dis <- distances(mm[[1]])
    idx <- which.max(dis[pathway, ])
    return(colnames(dis)[idx])
}

#' Convert id to pathway name
#'
#' For internal use only. Retrieves name from pathway id.
#'
#' You must provide a namedVect to be used as translator.
#'
#' @param idList a list of pathway id
#' @param namedVect a named vector
#'
#' @return a character vector with the names
#'
id2name <- function(idList, namedVect) {
    stopifnot(!is.null(names(namedVect)))
    lapply(
        idList, function(x) {
            unlist(unname(namedVect[x]))
        }
    )
}

test_that(
    "generateWarn", {
        pathHierarchy <- downloadPathwayRelationFromReactome()
        pathHierarchyGraph <- igraph::graph_from_data_frame(
            d = pathHierarchy,
            directed = TRUE
        )

        
        reactome <- graphite::pathways("hsapiens", "reactome")[1:2]
        pathwayName <- names(reactome)

        omicsClasses2pathways <- list(
            exp = pathwayName,
            `cnv;exp` = "Not a pathway"
        )
        expect_warning(
            omicsClasses2fathers <- lapply(
                omicsClasses2pathways,
                annotePathwayToFather,
                graphiteDB = reactome,
                hierarchy = pathHierarchyGraph
            )
        )
    }
)

#' Reactome Pathways Relation data
#' 
#' This is a copy of the file
#' 'https://reactome.org/download/current/ReactomePathwaysRelation.txt'
#' downloaded September 2024. A brand new file can be downloaded using:
#' \link{`downloadPathwayRelationFromReactome`}
#' 
#' @format A txt file with 2 columns: 
#' \describe{
#' \item{V1} {parent}
#' \item{V2} {child}}
#' 
#' @keywords datasets
#' 
#' @source 
#' [Reactome database](https://reactome.org/download/current/ReactomePathwaysRelation.txt)
#' 
#' @name ReactomePathwaysRelation

---
title: "MOSClip vignette"
date: "`r BiocStyle::doc_date()`"
output:   
  BiocStyle::html_document:
    toc: true
    toc_depth: 3
vignette: >
  %\VignetteIndexEntry{MOSClip}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
Package: MOSClip
bibliography: ../inst/mosclip.bib
---

# Abstract {.unnumbered}
In the last years we have witnessed a dramatic change in the clinical treatment 
of patients thanks to molecular and personalized medicine. Many medical 
institutes are starting to adopt routine genome-wide screenings to complement 
and help diagnosis and treatment choices. As the number of datasets grows, we 
need to adapt and improve the methods to cope with the complexity, amount and 
multi-level structure of available information. Integrating these type of data 
remains challenging due to their dimensionality and diverse features. 
Moreover, focusing on dysregulated biological processes rather than individual 
genes can offer deeper insights into complex diseases like cancer. 
`MOSClip` is a multi-omic statistical approach based on pathway topology that 
can deal with this complexity. It integrates multiple omics - such as 
expression, methylation, mutation, or copy number variation - using various 
dimensionality reduction strategies. The analysis can be performed at the level 
of entire pathways or pathway modules, allowing for a more detailed examination 
of the dysregulated mechanisms within large biological processes. 
`MOSClip` pathway analysis serves two primary purposes: testing the survival 
association of pathways or modules using the Cox proportional hazard model, 
and conducting a two-class analysis with a generalized linear model. 
Additionally, the package offers valuable graphical tools to visualize and 
interpret the results.


```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```


# Introduction
In recent years many efforts have been dedicated on multi-omic data integration,
with several tools available for pathway analysis in a multi-omic framework;
however, their purpose is mainly limited to two-class comparison. 
`MOSClip` (Multi-Omic Survival Clip) was originally developed for survival 
pathway analysis, combining both multi-omic data integration and graphical 
model theory to keep track of gene interactions among a 
pathway [@martini_mosclip_2019]. 
With this purpose, `MOSClip` allows to test survival association of pathways or 
their connected components, that we called modules, in a multi-omic 
framework.
A second test has been implemented to perform also two-class comparison, to 
investigate pathways or modules association with a specific condition. 
Multi-omics gene measurements are tested as covariates of a Cox proportional 
hazard model or a generalized linear model, after dimensionality reduction of 
data. 
`MOSClip` is highly flexible thanks to its modular structure, allowing the use 
of one or multiple different omics, as well as different data reduction 
strategies and tests.
In brief, `MOSClip` comprises four main components: pathway topology, 
multi-omic data and survival or two-class analysis. The final goal is to find 
biological processes impacting patient's survival or patient's association with 
a specific condition.
Furthermore, several graphical tools have been implemented in `MOSClip` to 
browse, manage and provide help in the interpretation of the results.

In this vignette, we will show an example of survival analysis on four omics: 
transcriptome, methylome, genomic mutations and genomic copy number variations, 
testing if these omics can be synergically involved in pathways with survival 
or two-class prognostication power. 

# Installation
```{r, eval = FALSE}
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("MOSClip")
```

# How to use MOSClip for survival analysis 
We start by loading example data provided by `MOSClip` package to run our 
analysis. 
`reactSmall` object is a list of three interesting Reactome pathways in 
`graphite::Pathway` format that we will use in our analysis. More information
can be found on the object documentation (`?reactSmall`).
`multiOmics` object is a multi-omic dataset containing matrices, 
genes per patients, of methylation status, somatic mutations, CNVs, and 
transcripts expression levels, for 50 ovarian cancer patients from TCGA. 
Genes and patients were manually selected to generate this small dataset 
intended to illustrate the functionality of the package, allowing users to 
explore its methods and tools in a simplified context. 
Information on how the dataset was generated can be found in package 
documentation with `?multiOmics`. Moreover, additional information on how to 
pre-process datasets for a `MOSClip` analysis are available in this [GitHub 
tutorial](https://caluralab.github.io/MOSClipTutorials/) 
or in the Materials and Methods section of the paper [@martini_mosclip_2019].


```{r message=FALSE}
library(MOSClip)
library(MultiAssayExperiment)
library(kableExtra)

data("reactSmall")
data("multiOmics")
```

`multiOmics` is an `Omics` class object. This `MOSClip` specific object derives 
from a `MultiAssayExperiment` object. It contains standard slots 
`ExperimentList`, `sampleMap`, `colData`, and specific slots for `MOSClip` 
analysis: `modelInfo`, where the user should specify the dimensionality 
reduction method to process each omic dataset, and `specificArgs`, where 
additional parameters can be set for each method, as described in the help of 
each reduction function. 
An `Omics` class object can be generated with the function `makeOmics` starting 
from data matrices and additional annotations.

Available methods for dimensionality reduction can be conveniently visualized 
with `availableOmicMethods` function.

```{r}
availableOmicMethods()
```

In this vignette, we chose to use PCA for expression data, cluster analysis 
for methylation data, vote counting for mutations and CNVs (for detail see 
`MOSClip` paper [@martini_mosclip_2019]). This data transformations are easily 
applied calling `MOSClip` functions, thus, here we need only to provide the 
name of the needed function. 
Given the nature of the methylation data, we expect to have more than a CpG 
cluster associated to a gene. For this reason, `MOSClip` provides the 
possibility to include a dictionary to associate the methylation level of 
multiple CpG clusters to a single gene. Thus, in the methylation specific 
arguments you need to provide the dictionary to convert cluster names into 
genes.

## Module analysis 
We are now ready to perform the survival analysis on modules using the 
function `multiOmicsSurvivalModuleTest`. Required inputs are a multi-omic 
dataset and a pathway in `Pathway` or `graphNEL` format. Alternatively, it is 
possible to run the analysis also on gene-sets; in this case the topological 
information is lost, thus, only the function for pathway test must be used. 
In this example, we choose to test only genes that have at least expression 
data, as specified with `useTheseGenes`. This a priori filter, however, is not 
mandatory. 
Moreover, it could be useful to set a seed in order to have reproducible 
results.

```{r, warning = FALSE}
genesToConsider <- row.names(experiments(multiOmics)$exp)

moduleSurv <- lapply(reactSmall, function(g) {
  set.seed(1234)
  fcl = multiOmicsSurvivalModuleTest(multiOmics, g, 
                                     useTheseGenes = genesToConsider)
  fcl
 })
```

Once the analysis is complete, we can plot the tabular summary of the top 10 
modules selected by p-value of the Cox proportional hazard model using the 
function `multiPathwayModuleReport`.

```{r}
moduleSummary <- multiPathwayModuleReport(moduleSurv)
```

```{r, echo=FALSE}
kable(moduleSummary[1:10,-1]) %>%
  kable_styling() %>%
  scroll_box(width = "80%", height = "400px")
```


### Graphical exploration of MOSClip module results
`MOSClip` has plenty of functions to visually explore the results. 
In the following paragraphs we will show some examples.

We can visualize the table of module test results for a specific pathway, e.g.,
_Activation of Matrix Metalloproteinases_.

```{r fig.height=6, fig.weight=6}
plotModuleReport(moduleSurv[["Activation of Matrix Metalloproteinases"]], 
                 MOcolors = c(exp = "red", met = "green", 
                              cnv = "yellow", mut = "blue"))
```

As you can see, among others, the module number 4 of this pathway is 
significant, and, in particular, covariates expPC2, met2k2 and cnvPOS are 
driving this significance.

We can have a look at the pathway graph and the module position in the pathway 
using `plotModuleInGraph`.

```{r, message=FALSE}
plotModuleInGraph(moduleSurv[["Activation of Matrix Metalloproteinases"]], 
                  pathList = reactSmall, 
                  moduleNumber = 4)
```

Then, we can check at the differences in survival using Kaplan-Meier curves 
dividing patients in groups with different omics patterns. Here we consider 
only covariates expPC2 and met2k.

```{r, fig.height=6, fig.width=7}
plotModuleKM(moduleSurv[["Activation of Matrix Metalloproteinases"]], 
             moduleNumber = 4, 
             formula = "Surv(days, status) ~ expPC2 + met2k", 
             paletteNames = "Paired", risk.table = TRUE, inYears = TRUE)
```

We can explore the most important genes of the pathway and their original 
profiles across the omics using an heatmap plot of the original values. 
The most important genes are selected as described in 
Martini et al. [@martini_mosclip_2019].

```{r, message=FALSE, results='hide', fig.keep='all', fig.height=7, fig.width=7}
additionalA <- colData(multiOmics)
additionalA$status[additionalA$status == 1] <- "event"
additionalA$status[additionalA$status == 0] <- "no_event"
additionalA$PFS <- as.factor(additionalA$status)
additionalA$status <- NULL
additionalA$years <- round(additionalA$days/365.24, 0)
additionalA$days <- NULL

plotModuleHeat(moduleSurv[["Activation of Matrix Metalloproteinases"]], 
               moduleNumber = 4, 
               paletteNames = c(exp = "red", met = "green", 
                                cnv = "yellow", mut = "blue"),
               additionalAnnotations = additionalA, 
               additionalPaletteNames = list(PFS = "violet", years = "teal"), 
               sortBy = c("expPC2", "met2k", "PFS", "years"), 
               withSampleNames = FALSE)
```

In second instance, we can ask if two or more omics are significant in the same 
module simultaneously and if this omic interaction is more frequent than those 
expected by chance. To perform this test we use the `runSupertest` function.
A circle plot is returned with the frequency of all significant omic 
combinations and their significance levels.

```{r, fig.height=9, fig.width=10}
runSupertest(moduleSummary, pvalueThr = 0.05, zscoreThr = 0.05, 
             excludeColumns = c("pathway", "module"))
```


## Pathway analysis
In pathway test the pathway topology (the in and out connections of the pathway 
genes) can be exploited to guide the data reduction step. To do that, we 
suggest to use the topological PCA instead of the sparse PCA changing the 
settings in the omics object.

Then, we are ready to run the analysis using the function 
`multiOmicsSurvivalPathwayTest`.

```{r warning=FALSE}
data("multiOmicsTopo")

pathwaySurv <- lapply(reactSmall, function(g) {
  set.seed(1234)
  fcl = multiOmicsSurvivalPathwayTest(multiOmicsTopo, g, 
                                      useTheseGenes = genesToConsider)
  })
```

### Graphical exploration of MOSClip pathway results
We can plot a report of the first 10 pathways, sorted by pvalue of the Cox 
proportional hazard model.

```{r fig.width=6, fig.height=4}
plotMultiPathwayReport(pathwaySurv, 
                       MOcolors = c(exp = "red", mut = "blue", 
                                    cnv = "yellow", met = "green"))
```

Finally, we can look at the predictive genes using a heatmap with patient 
additional annotations. 

```{r, message=FALSE, results='hide', fig.keep='all', fig.height=7, fig.width=7}
plotPathwayHeat(pathwaySurv[["Activation of Matrix Metalloproteinases"]], 
                sortBy = c("expPC1", "cnvPOS", "PFS"), 
                paletteNames = c(exp = "red", met = "green",
                                 mut = "blue", cnv = "yellow"), 
                additionalAnnotations = additionalA, 
                additionalPaletteNames = list(PFS = "violet", years = "teal"), 
                withSampleNames = FALSE)
```

Then, we can also check for differences in survival using Kaplan-Meier curves 
dividing patients in groups with different omics patterns (e.g. patients with 
different methylation pattern and high and low levels of PC2 in expression).

```{r, fig.height=9, fig.width=10}
plotPathwayKM(pathwaySurv[["Activation of Matrix Metalloproteinases"]], 
              formula = "Surv(days, status) ~ expPC1 + cnvPOS", 
              paletteNames = "Paired")
```

# Additional functionalities {.unnumbered}
`MOSClip` gives the possibility to prioritize most important and 
stable pathway or module results, running a resampling procedure that can be 
found on the 
[extended tutorial on GitHub](https://caluralab.github.io/MOSClipTutorials/). 

More tutorials are also available on how to perform a two-class analysis with 
`MOSClip`, as well as examples of more plots that were not shown in this 
vignette.

# Session Information {.unnumbered}
```{r}
sessionInfo()
```

# References {.unnumbered}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/houseClip-handle-graphite-pathways.R
\name{mapPathwaysIDfromGraphite}
\alias{mapPathwaysIDfromGraphite}
\title{Map Pathways ID from Graphite}
\usage{
mapPathwaysIDfromGraphite(pathways, pathwayNames = NULL)
}
\arguments{
\item{pathways}{a PathwayList object}

\item{pathwayNames}{in not NULL, a subset of pathway to extract}
}
\value{
a data frame, id and pathway name
}
\description{
For internal use only. Retrieve pathway id and names from Pathways object.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CreateTabulaReport.R
\name{multiPathwayReport}
\alias{multiPathwayReport}
\title{Summarize pathways' info from a list of MultiOmicsPathway objects (MOP)}
\usage{
multiPathwayReport(multiPathwayList, priority_to = NULL)
}
\arguments{
\item{multiPathwayList}{a list of \code{MultiOmicsPathway} objects resulting from
a multi-omics pathway test.}

\item{priority_to}{a vector with the covariates (omic name) that should go
first.}
}
\value{
a data.frame, pathways in rows, overall pvalue of the coxph,
followed by covariates pvalues, in columns.
}
\description{
Given the list of MOPs, it creates the table.
}
\examples{
data(multiOmics)
data(reactSmall)

genesToUse <- row.names(multiOmics[[1]])

MOP_list <- lapply(reactSmall, function(g) {
    fcl <- multiOmicsSurvivalPathwayTest(multiOmics, g,
        survFormula = "Surv(days, status) ~",
        autoCompleteFormula = TRUE,
        useTheseGenes = genesToUse
    )
    fcl
})

pathwaysSummary <- multiPathwayReport(MOP_list)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/AllMethods.R
\docType{class}
\name{MultiOmicsPathway-class}
\alias{MultiOmicsPathway-class}
\alias{showPathway,MultiOmicsPathway-method}
\title{Multi Omics Pathway.}
\usage{
\S4method{showPathway}{MultiOmicsPathway}(object)
}
\arguments{
\item{object}{an object of class \code{MultiOmicsPathway}}
}
\description{
This class organize the results of the Multi-Omics Pathway Survival Test
analysis.
}
\section{Methods (by generic)}{
\itemize{
\item \code{showPathway(MultiOmicsPathway)}: shows module info

}}
\section{Slots}{

\describe{
\item{\code{pvalue}}{a numeric vector of the pvalues of the pathways.}

\item{\code{zlist}}{a numeric vector with the zs of all the covariates.}

\item{\code{pathView}}{a list of pathway information: for each omic,
the name of the omic, the genes used, the method, the name of the
covariates analyzed and other specific information based on the omic.}

\item{\code{title}}{the name of the pathway.}

\item{\code{analysis}}{the type of analysis done: survival or two-class.}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extractSummary.R
\name{extractSummaryFromPCA}
\alias{extractSummaryFromPCA}
\title{Extract Summary PCA from MultiOmics Objects}
\usage{
extractSummaryFromPCA(
  omic,
  multiOmicObj,
  moduleCox,
  analysis,
  loadThr = 0.6,
  atleast = 1,
  minprop = 0.1
)
}
\arguments{
\item{omic}{a summarized omic}

\item{multiOmicObj}{\code{Omics} object}

\item{moduleCox}{the coxObj of the interesting module}

\item{analysis}{two-class or survival type}

\item{loadThr}{the thr value to select the most influent features according
to the loading}

\item{atleast}{the minimum number of gene to retrieve}

\item{minprop}{the minimal proportion of cutp}
}
\value{
summary for omic summarized using pca
\item{sigModule}{the original data for significant features}
\item{discrete}{the discrete version of the significant covariates converted
(when needed) into the discrete version}
\item{subset}{data.frame(row.names=names(topGenes), covariate)}
\item{covsConsidered}{the name of the considered omic}
}
\description{
Given an omic summarized by 'summarizeWithPca' extract the most important
features.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MultiOmicsMethod.R
\name{summarizeInCluster}
\alias{summarizeInCluster}
\title{Summarize Using Cluster Analysis}
\usage{
summarizeInCluster(
  data,
  features,
  name = "clu",
  dictionary = NULL,
  max_cluster_number = 3,
  cliques = NULL
)
}
\arguments{
\item{data}{a data matrix}

\item{features}{a vector with the features to analyze}

\item{name}{prefix of the covariates}

\item{dictionary}{translate features (genes) into sets
(row.names of the data)}

\item{max_cluster_number}{the maximum number of cluster to evaluate}

\item{cliques}{the features organized in cliques. Only use for topology}
}
\value{
a list with summary of the omic:
\item{x}{summary of the omic for each sample}
\item{usedGenes}{genes list of genes used to calculate the summary}
\item{namesCov}{names of the covariates}
\item{cls}{the genes in clusters}
\item{method}{method used for the analysis}
\item{omicName}{name of the omic}
}
\description{
Given a matrix it summarize in classes
}
\details{
The user can define a maximum of classes. The function
guess the optimal number of clusters using NbClust methods.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{multiOmicsTopo}
\alias{multiOmicsTopo}
\title{Omics class object with TCGA ovarian data for topological analysis}
\format{
\subsection{\code{multiOmicsTopo}}{

An Omics with 4 omics:
\describe{
\item{exp}{Matrix with 151 rows and 50 columns of RNA expression values}
\item{met}{A matrix with 178 rows and 50 columns of methylation data with
probes clustered}
\item{mut}{A matrix with 107 rows and 50 columns of mutation counts}
\item{cnv}{A matrix with matrix with 145 rows and 50 columns of copy
number}
...
}
}
}
\usage{
data('multiOmicsTopo')
}
\description{
An \code{Omics} class object containing data from TCGA ovarian cancer.
The data are the same as in \code{\link{multiOmics}} object.
Arguments in \code{specificArgs} slot have been set to efficiently run a
topological pathway analysis, i.e., the topological method is used for PCA
and shrink parameter is set to TRUE.
This method can't be used for analyses on modules.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PlottingMO.R
\name{plotMultiPathwayReport}
\alias{plotMultiPathwayReport}
\title{Summarize and plot pathways' info from a list of \code{MultiOmicsPathway} (MOP)}
\usage{
plotMultiPathwayReport(
  multiPathwayList,
  top = 25,
  MOcolors = NULL,
  priority_to = NULL,
  fontsize = 6,
  ...
)
}
\arguments{
\item{multiPathwayList}{a \code{list} of \code{MultiOmicsPathway} class objects}

\item{top}{numeric value. Plot only the top number of pathways}

\item{MOcolors}{character vector with the omic colors.
The colors should be among the colors in \code{\link{showMOSpalette}}}

\item{priority_to}{a vector with the covariates (omic names) that should go
first}

\item{fontsize}{the font size to be used. Default is 12.}

\item{\dots}{additional argument to be passed to pheatmap}
}
\value{
a Heatmap list object from ComplexHeatmap package of the results
contained in the \code{MultiOmicsPathway} object provided
}
\description{
Given the list of MOPs, it plots a table of its results.
}
\examples{
data(multiOmics)
data(reactSmall)

genesToUse <- row.names(multiOmics[[1]])

MOP_list <- lapply(reactSmall, function(g) {
    fcl <- multiOmicsSurvivalPathwayTest(multiOmics, g,
        survFormula = "Surv(days, status) ~",
        autoCompleteFormula = TRUE,
        useTheseGenes = genesToUse
    )
    fcl
})

plotMultiPathwayReport(MOP_list,
    MOcolors = c(
        exp = "red", met = "green", mut = "blue",
        cnv = "yellow"
    ),
    fontsize = 12
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MultiOmicsSurvivalTest.R
\name{multiOmicsSurvivalPathwayTest}
\alias{multiOmicsSurvivalPathwayTest}
\title{Compute Multi Omics Survival in Pathways}
\usage{
multiOmicsSurvivalPathwayTest(
  omicsObj,
  graph,
  survFormula = "Surv(days, status) ~",
  autoCompleteFormula = TRUE,
  useTheseGenes = NULL,
  pathName = NULL,
  robust = FALSE,
  include_from_annot = FALSE
)
}
\arguments{
\item{omicsObj}{Object of class \code{Omics}}

\item{graph}{a pathway in \code{graphNEL}, \code{Pathway} or geneset format}

\item{survFormula}{a character with the formula to compute survival}

\item{autoCompleteFormula}{logical. If TRUE autocomplete the \code{survFormula}
using all the available covariates}

\item{useTheseGenes}{vector of genes used to filter pathways}

\item{pathName}{title of the pathway. If NULL and graph is \code{Pathway},
\code{graph@title} is used as title}

\item{robust}{logical, whether the robust mode should be used
for cox model analysis}

\item{include_from_annot}{logical. If TRUE compute cox model analysis
using additional covariates from \code{colData}}
}
\value{
\code{MultiOmicsPathway} object
}
\description{
Performs topological survival analysis using an \code{Omics} object.
}
\examples{
data(multiOmics)
data(reactSmall)

genesToUse <- row.names(multiOmics[[1]])

MOP_survival <- multiOmicsSurvivalPathwayTest(multiOmics, reactSmall[[1]],
    survFormula = "Surv(days, status) ~", autoCompleteFormula = TRUE,
    useTheseGenes = genesToUse
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{ovarianDataset}
\alias{ovarianDataset}
\title{ExperimentList class object with TCGA ovarian data}
\format{
\subsection{\code{ExperimentList}}{

An ExperimentList with 4 omics:
\describe{
\item{exp}{Matrix with 101 rows and 50 columns of RNA expression values}
\item{met}{A matrix with 97 rows and 50 columnsof methylation data with
probes clustered}
\item{mut}{A matrix with 55 rows and 50 columns of mutation counts}
\item{cnv}{A matrix with matrix with 101 rows and 50 columns of copy
number}
...
}
}
}
\usage{
data('ovarianDataset')
}
\description{
An ExperimentList class object containing data from TCGA ovarian cancer.
The TCGA data was manually selected and preprocessed. It contains 4 omics:
expression, methylation, mutation, and copy number variation.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/supertest&frequencyplot.R
\name{annotePathwayToFather}
\alias{annotePathwayToFather}
\title{Find Pathway Fathers}
\usage{
annotePathwayToFather(pathways, graphiteDB, hierarchy)
}
\arguments{
\item{pathways}{vector of pathway names}

\item{graphiteDB}{graphite DB object (e.g. an object containing all reactome
pathways)}

\item{hierarchy}{a graph object with the pathway hierarchy}
}
\value{
a vector of the pathway fathers' names
}
\description{
Given the hierarchy of the pathways, this formula finds the fathers of the
respective pathway (e.g. pathway: 'PI3K Cascade'; father:
'Signaling Pathways'). This function is necessary for calculating the
contribution of different omics to survival prediction in different
biological processes, grouping the pathways by hierarchy.
}
\examples{
data(multiOmics)
data(reactSmall)

genesToUse <- row.names(multiOmics[[1]])

MOM_list <- lapply(reactSmall[1:2], function(g) {
    fcl <- multiOmicsSurvivalModuleTest(multiOmics, g,
        survFormula = "Surv(days, status) ~",
        autoCompleteFormula = TRUE,
        useTheseGenes = genesToUse
    )
    fcl
})

moduleSummary <- multiPathwayModuleReport(MOM_list)

pathHierarchy <- downloadPathwayRelationFromReactome()
pathHierarchyGraph <- igraph::graph.data.frame(
    d = pathHierarchy,
    directed = TRUE
)

omicsClasses2pathways <- computeOmicsIntersections(
    moduleSummary,
    pvalueThr = 1, zscoreThr = 1,
    excludeColumns = c("pathway", "module")
)

omicsClasses2pathways <- lapply(
    omicsClasses2pathways,
    stripModulesFromPathways
)

# This step requires to download the whole reactome graph, which usually
# takes a lot of time.
# reactome <- graphite::pathways('hsapiens', 'reactome')
# reactome <- graphite::convertIdentifiers(reactome, 'entrez')
# omicsClasses2fathers <- lapply(omicsClasses2pathways, 
#                                annotePathwayToFather, 
#                                graphiteDB = reactome,
#                                hierarchy = pathHierarchyGraph)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Utils.R
\name{createCoxObj}
\alias{createCoxObj}
\title{Create Cox Object}
\usage{
createCoxObj(colData, moView)
}
\arguments{
\item{colData}{colData from multiOmic object}

\item{moView}{modulesView or pathView from multiOmicsModules or
multiOmicsPathway object}
}
\value{
data.frame, samples in the rows, covariates in the columns
}
\description{
Create the coxObj from the covariates used in the test
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MultiOmicsMethod.R
\name{summarizeToNumberOfDirectionalEvents}
\alias{summarizeToNumberOfDirectionalEvents}
\title{Summarize With Directed Sum}
\usage{
summarizeToNumberOfDirectionalEvents(
  data,
  features,
  name = "dCount",
  eventThr = 2,
  min_prop = 0.1,
  cliques = NULL
)
}
\arguments{
\item{data}{a data matrix}

\item{features}{a vector with the features to analyze}

\item{name}{prefix of the covariates}

\item{eventThr}{the absolute value to threshold an event}

\item{min_prop}{minimal proportion in classes}

\item{cliques}{the features organized in cliques. Only use for topology}
}
\value{
a list with summary of the omic:
\item{x}{summary of the omic for each sample}
\item{usedGenes}{genes list of genes used to calculate the summary}
\item{namesCov}{names of the covariates}
\item{method}{method used for the analysis}
\item{omicName}{name of the omic}
\item{evenThr}{threshold fot event counting}
\item{min_prop}{minimum proportion of samples to exclude to check the
variability of values}
}
\description{
Given a matrix it summarize the positive and negative in two vectors,
with counts of the events
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/houseClip-pathway-relations.R
\name{downloadPathwayRelationFromReactome}
\alias{downloadPathwayRelationFromReactome}
\title{Download Reactome Pathway Relations}
\usage{
downloadPathwayRelationFromReactome(url = NULL, speciesAbbr = "HSA")
}
\arguments{
\item{url}{the location of the file. Can be local. If NULL pick the package
reactome file.}

\item{speciesAbbr}{species acronim}
}
\value{
A data frame with 2 columns:
\item{parent}{The Reactome pathway ID of the parent pathway.}
\item{child}{The Reactome pathway ID of the child pathway.}
}
\description{
Download Pathway Relations from Reactome. The file is retrieved from the
\href{https://reactome.org/download/current/ReactomePathwaysRelation.txt}{url}
}
\examples{
downloadPathwayRelationFromReactome()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllMethods.R
\name{showOmics}
\alias{showOmics}
\title{A generic functions showing parameter associated with each omics}
\usage{
showOmics(object)
}
\arguments{
\item{object}{an object of class \code{Omics}}
}
\value{
NULL. No value is returned
}
\description{
A generic functions showing parameter associated with each omics
}
\examples{
data(multiOmics)

showOmics(multiOmics)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MultiOmicsMethod.R
\name{availableOmicMethods}
\alias{availableOmicMethods}
\title{Get available Omics Summarizing Methods}
\usage{
availableOmicMethods()
}
\value{
character vector with the implemented methods.
}
\description{
Gives a vector of the available methods to summarize omics.
}
\examples{
availableOmicMethods()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/houseClip-pca-functions.R
\name{computePCs}
\alias{computePCs}
\title{compute PCs.}
\usage{
computePCs(
  exp,
  shrink = FALSE,
  method = c("regular", "topological", "sparse"),
  cliques = NULL,
  maxPCs = 3
)
}
\arguments{
\item{exp}{a matrix}

\item{shrink}{logical, whether to shrink or not.}

\item{method}{one of 'regular', 'topological' and 'sparse'}

\item{cliques}{the pathway topology summarized in a list of cliques}

\item{maxPCs}{the maximum number of PCs to consider}
}
\value{
a list with the following elements:
\item{x}{the computed PCs}
\item{sdev}{the standard deviation captured by the PCs}
\item{loadings}{the loadings}
}
\description{
For internal use only. Performs Principal Componenent analysis.
}
\details{
Three methods are implemented:
\itemize{
\item regular: a regular PCA ('prcomp')
\item topological: PCA using a pathway topology.
\item sparse: sparse PCA analysis implemented by 'elasticnet'
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MultiOmicsMethod.R
\name{summarizeWithPca}
\alias{summarizeWithPca}
\title{Summarize Using PCA}
\usage{
summarizeWithPca(
  data,
  features,
  name = "pca",
  shrink = FALSE,
  method = "regular",
  cliques = NULL,
  maxPCs = 3,
  loadThr = 0.6
)
}
\arguments{
\item{data}{a data matrix}

\item{features}{a vector with the features to analyze}

\item{name}{prefix of the covariates}

\item{shrink}{shirnk or not the covariance matrix.}

\item{method}{either 'regular', 'sparse' or 'topological'}

\item{cliques}{the features organized in cliques. Only use for topology.}

\item{maxPCs}{maximum number of pcs to consider}

\item{loadThr}{loading threshold}
}
\value{
a list with summary of the omic:
\item{x}{summary of the omic for each sample (principal components)}
\item{sdev}{standard deviation of the principal components}
\item{loadings}{loadings of PCA}
\item{usedGenes}{genes list of genes used to calculate the summary}
\item{namesCov}{names of the covariates}
\item{method}{method used for the analysis}
\item{omicName}{name of the omic}
}
\description{
Given a matrix it summarize to principal components.
The user can specify the number of principal components. Default 3.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/houseClip-graph-processing-functions.R
\name{extractCliquesFromDag}
\alias{extractCliquesFromDag}
\alias{mmmoralize}
\title{Extract the maximal cliques}
\usage{
extractCliquesFromDag(dag, root = NULL)

mmmoralize(graph)
}
\arguments{
\item{dag}{a Directed Aciclic Graph}

\item{root}{a node to use as root}

\item{graph}{a graphNEL object}
}
\value{
list of nodes cliques
}
\description{
For internal use only. Extract the cliques.

For internal use only. Force Moralization
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{reactSmall}
\alias{reactSmall}
\title{PathwayList of pathways from Reactome}
\format{
\subsection{\code{reactSmall}}{

A PathwayList with Reactome pathways for hsapiens
\describe{
\item{entries}{Three Reactome pathways with their nodes}
}
}
}
\usage{
data('reactSmall')
}
\description{
A PathwayList with three pathways necessary for the analysis:
'Activation of Matrix Metalloproteinases', 'FGFR1 mutant receptor
activation', and 'VEGFA-VEGFR2 Pathway'. Pathways were downloaded using
\code{graphite} package and the names of the nodes were converted into
Entrez IDs.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/guessInvolvement.R
\name{guessInvolvementPathway}
\alias{guessInvolvementPathway}
\title{Guess the most influent features from MultiOmics Survival or Two-class
results.}
\usage{
guessInvolvementPathway(
  pathway,
  loadThr = 0.6,
  n = 3,
  atleast = 1,
  min_prop_pca = 0.1,
  min_prop_events = 0.1,
  ...
)
}
\arguments{
\item{pathway}{\code{MultiOmicsModules} object from a pathway}

\item{loadThr}{the loading threshold to select genes (PCA only)}

\item{n}{the maximum number of genes to retrieve (cluster and binary only)}

\item{atleast}{the minimum number of features to select (PCA only)}

\item{min_prop_pca}{the minimal proportion to compute the PCA classes}

\item{min_prop_events}{the minimal proportion to compute the event classes}

\item{...}{additional arguments passed to \code{get} function}
}
\value{
a list. Each item of the list corresponds to an omic that is
summarized with the specific 'extractSummary' functions. Each item is the
summary for an omic summarized using the setted method: pvalues are present
only for cluster method.
}
\description{
Given a pathway analyzed by \code{multiOmicsSurvivalPathwayTest} or
\code{multiOmicsTwoClassPathwayTest}, it retrieves for each omic the most
influent features.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/houseClip-pca-functions.R
\name{topoCompPCs}
\alias{topoCompPCs}
\title{Topological PCA}
\usage{
topoCompPCs(exp, shrink, cliques, k)
}
\arguments{
\item{exp}{a matrix}

\item{shrink}{logical, whether to shrink or not.}

\item{cliques}{the pathway topology summarized in a list of cliques}

\item{k}{the number of components to use}
}
\value{
a list with the following elements:
\item{x}{the computed PCs}
\item{sdev}{the standard deviation captured by the PCs}
\item{loadings}{the loadings}
}
\description{
Topological PCA
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/AllMethods.R
\docType{class}
\name{MultiOmicsModules-class}
\alias{MultiOmicsModules-class}
\alias{showModule,MultiOmicsModules-method}
\title{Multi Omics Modules.}
\usage{
\S4method{showModule}{MultiOmicsModules}(object)
}
\arguments{
\item{object}{an object of class \code{MultiOmicsModules}}
}
\description{
This class organizes the results of the Multi Omics Module Test analysis, in
which corresponds to one pathway decomposed into modules.
}
\section{Methods (by generic)}{
\itemize{
\item \code{showModule(MultiOmicsModules)}: shows module info

}}
\section{Slots}{

\describe{
\item{\code{alphas}}{a numeric vector of the pvalues of all the modules.}

\item{\code{zlists}}{a list of numeric vectors with the zs of the covariates
for each module.}

\item{\code{modulesView}}{a list of module information: for each omic,
the name of the omic, the genes used, the method, the name of the
covariates analyzed and other specific information based on the omic.}

\item{\code{modules}}{a list with the genes that belong to the module.}

\item{\code{title}}{the name of the pathway.}

\item{\code{analysis}}{the type of analysis done: survival or two-class.}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CreateTabulaReport.R
\name{multiPathwayModuleReport}
\alias{multiPathwayModuleReport}
\title{Provides a Table of the Modules Test Results}
\usage{
multiPathwayModuleReport(multiPathwayModuleList, priority_to = NULL)
}
\arguments{
\item{multiPathwayModuleList}{a list of \code{MultiOmicsModules} objects
resulting from a multi-omics module test.}

\item{priority_to}{a vector with the covariates (the omics names)
that should appear first in the dataframe columns}
}
\value{
a data.frame class object. Rows correspond to the modules, and the
columns to the overall and covariates pvalues of the test.
}
\description{
Summarizes the results of a multi omics module test given a list of
MultiOmicsModules objects
}
\examples{
data(multiOmics)
data(reactSmall)

genesToUse <- row.names(multiOmics[[1]])

MOM_list <- lapply(reactSmall[1:2], function(g) {
    fcl <- multiOmicsSurvivalModuleTest(multiOmics, g,
        survFormula = "Surv(days, status) ~",
        autoCompleteFormula = TRUE,
        useTheseGenes = genesToUse
    )
    fcl
})

moduleSummary <- multiPathwayModuleReport(MOM_list)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extractSummary.R
\name{extractSummaryFromNumberOfEvents}
\alias{extractSummaryFromNumberOfEvents}
\title{Extract Summary Binary from MultiOmics Objects}
\usage{
extractSummaryFromNumberOfEvents(
  omic,
  multiOmicObj,
  moduleCox,
  analysis,
  n = 3,
  minprop = 0.1,
  labels = c("few", "many")
)
}
\arguments{
\item{omic}{a summarized omic}

\item{multiOmicObj}{\code{Omics} object}

\item{moduleCox}{the coxObj of the interesting module}

\item{analysis}{two-class or survival type}

\item{n}{maximum number of features to retrieve}

\item{minprop}{the minimal proportion of cutp}

\item{labels}{the category labels}
}
\value{
Meant for internal use only. The summary for omic summarized using
counting of events.
\item{sigModule}{the original data for significant features}
\item{discrete}{the discrete version of the significant covariates converted
(when needed) into the discrete version}
\item{subset}{data.frame(row.names=names(topGenes), covariates=covariate)}
\item{covsConsidered}{the name of the considered omic}
}
\description{
Given an omic summarized by 'summarizeToNumberOfEvents' extract the most
important features.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/supertest&frequencyplot.R
\name{computeOmicsIntersections}
\alias{computeOmicsIntersections}
\title{Compute Omics Intersections}
\usage{
computeOmicsIntersections(
  multiPathwayReportData,
  pvalueThr = 0.05,
  zscoreThr = 0.05,
  resampligThr = NULL,
  excludeColumns = NULL
)
}
\arguments{
\item{multiPathwayReportData}{data.frame, the output of the
\code{\link{multiPathwayReport}} or \code{\link{multiPathwayModuleReport}}
functions.}

\item{pvalueThr}{numeric value. Overall pvalue cut-off to be used}

\item{zscoreThr}{numeric value. Covariates coefficient cut-off to be used.}

\item{resampligThr}{numeric value. Filters the modules according to the
number of success in the resampling procedure, takes only the modules above
this threshold.}

\item{excludeColumns}{a vector of characters listing the columns of
\code{multiPathwayReportData} object to be excluded by the analysis.
In the case \code{multiPathwayReportData} derives from
\code{\link{multiPathwayModuleReport}}
you should set \code{excludeColumns = c('pathway','module')}.}
}
\value{
a list of pathway modules present for every intersection of omics
present
}
\description{
Finds the modules that have any intersection among the available omics
}
\examples{
df <- data.frame(
    pvalue = c(0.06, 0.04, 0.04, 0.03, 0.02),
    cnv = c(0.07, 0.03, 0.02, 0.04, 0.01),
    mut = c(0.08, 0.02, 0.01, 0.04, 0.04),
    row.names = c(
        "PathwayA", "PathwayB", "PathwayC",
        "PathwayD", "PathwayE"
    )
)

omicsClasses2Pathways <- computeOmicsIntersections(df,
    pvalueThr = 0.1,
    zscoreThr = 0.1
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/houseClip-graph-processing-functions.R
\name{removeSelfLoops}
\alias{removeSelfLoops}
\title{Remove self loops from a graphNEL}
\usage{
removeSelfLoops(graph)
}
\arguments{
\item{graph}{a graphNEL object}
}
\value{
a graphNEL object

#' @rdname  graph-processing
}
\description{
Remove the self loops that a present in the graph graphNEL object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/survClip-backbone.R
\name{survivalcoxr}
\alias{survivalcoxr}
\alias{coxrsummary}
\title{Cox Robust Model Analysis}
\usage{
survivalcoxr(coxObj, formula)

coxrsummary(x)
}
\arguments{
\item{coxObj}{data.frame: patients x covariates}

\item{formula}{formula to use}

\item{x}{a coxr.obj}
}
\value{
A list with
\item{pvalue}{pvalue of the model}
\item{zlist}{pvalues of single covariates}
\item{coxObj}{the original coxObj passed to the function}

a list with wald test and robust and partial coefficients
}
\description{
Cox Robust Analysis
}
\details{
For internal use only
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Utils.R
\name{showMOSpalette}
\alias{showMOSpalette}
\title{Shows the MOSClip palette.}
\usage{
showMOSpalette()
}
\value{
NULL. No value is returned
}
\description{
This function shows the MOSClip palette.
Each omic should be coupled to a color panel, this match will be preserved
in plots.
}
\examples{
showMOSpalette()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllMethods.R
\name{showPathway}
\alias{showPathway}
\title{A generic function showing pathway info}
\usage{
showPathway(object)
}
\arguments{
\item{object}{an object of class \code{MultiOmicsPathway}}
}
\value{
NULL. No value is returned
}
\description{
A generic function showing pathway info
}
\examples{
data(multiOmics)
data(reactSmall)

genesToUse <- row.names(multiOmics[[1]])

MOP_survival <- multiOmicsSurvivalPathwayTest(multiOmics, reactSmall[[1]],
    survFormula = "Surv(days, status) ~", autoCompleteFormula = TRUE,
    useTheseGenes = genesToUse
)

showPathway(MOP_survival)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{multiOmics}
\alias{multiOmics}
\title{Omics class object with TCGA ovarian data}
\format{
\subsection{\code{multiOmics}}{

An Omics with 4 omics:
\describe{
\item{exp}{Matrix with 151 rows and 50 columns of RNA expression values}
\item{met}{A matrix with 178 rows and 50 columns of methylation data with
probes clustered}
\item{mut}{A matrix with 107 rows and 50 columns of mutation counts}
\item{cnv}{A matrix with matrix with 145 rows and 50 columns of copy
number}
...
}
}
}
\usage{
data('multiOmics')
}
\description{
An \code{Omics} class object containing data from TCGA ovarian cancer. The TCGA
data was manually selected and preprocessed. It contains 4 omics: expression,
methylation, mutation, and copy number variation. Additionally, it contains
specific arguments to perform the dimensionality reduction.
The datasets were downloaded from TCGA using \code{TCGABiolink} R package,
selecting only patients with primary solid tumors.
Expression matrix was processed first, converting gene identifiers into
Entrez IDs. The profiles of genes present more than once were averaged.
Genes with at least 100 counts in at least one patients were selected,
to avoid data sparsity.
Mutation matrix was filtered, keeping only genes with expression data
available. We chose to consider only missense and nonsense mutations and
mutation impact was also considered following Mutect2 pipeline.
CNV values were transformed into numeric values.
Methylation data were processed with Methyl Mix R package. Patients that had
both normal and primary tumors samples were selected. With the help of a
dictionary array probes were connected to CpG clusters, and finally CpG
clusters were mapped to genes (Entrez ID).
Survival annotation curated by Liu et al. (2018) was used to extract PFS
information.
Only patients with matched data across the four omics were considered.
After the selection of patients and genes, we performed expression
normalization and log2 of the counts+1 transformation. This will ensure us
to work with expression data approximately close to a normal distribution,
the most suitable distribution for the subsequent \code{MOSClip} tests.
Genes and samples were manually selected to create this small example
dataset for demonstration purposes.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/houseClip-pca-functions.R
\name{sparseCompPCs}
\alias{sparseCompPCs}
\title{Sparse PCA}
\usage{
sparseCompPCs(exp, shrink, k)
}
\arguments{
\item{exp}{a matrix}

\item{shrink}{logical, whether to shrink or not.}

\item{k}{the number of components to use}
}
\value{
a list with the following elements:
\item{x}{the computed PCs}
\item{sdev}{the standard deviation captured by the PCs}
\item{loadings}{the loadings}
}
\description{
Sparse PCA
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/houseClip-pca-covariance.R
\name{estimateExprCov}
\alias{estimateExprCov}
\title{Estimate Single Covariance Matrix}
\usage{
estimateExprCov(expr, shrink)
}
\arguments{
\item{expr}{a numeric matrix}

\item{shrink}{logical wheter to shrink the matrix}
}
\value{
a covariance matrix
}
\description{
For internal use only. Estimate Covariance from one matrix
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PlottingMO.R
\name{plotPathwayKM}
\alias{plotPathwayKM}
\title{Plot Kaplan-Meier survival curves of a specific pathway}
\usage{
plotPathwayKM(
  pathway,
  formula = "Surv(days, status) ~ PC1",
  fileName = NULL,
  paletteNames = NULL,
  h = 9,
  w = 7,
  risk.table = TRUE,
  pval = TRUE,
  size = 1,
  inYears = FALSE,
  discr_prop_pca = 0.15,
  discr_prop_events = 0.05,
  additional_discrete = NULL,
  additional_continuous = NULL,
  ...
)
}
\arguments{
\item{pathway}{\code{MultiOmicsPathway} class object}

\item{formula}{a formula to compute the plot}

\item{fileName}{optional filenames to save the plot}

\item{paletteNames}{a palette containing three colors}

\item{h}{the height of the plot}

\item{w}{the width of the plot}

\item{risk.table}{logical value. If TRUE, shows the \code{risk.table}. Default
is TRUE.}

\item{pval}{logical value. Shows p-value of the curves}

\item{size}{line width of the KM curves}

\item{inYears}{logical value. If TRUE, converts days to years}

\item{discr_prop_pca}{the minimal proportion to compute the PCA classes}

\item{discr_prop_events}{the minimal proportion to compute the event classes}

\item{additional_discrete}{names of the additional discrete variables to
include}

\item{additional_continuous}{names of the additional continuous variables to
include}

\item{...}{additional arguments passed to \code{guessInvolvementPathway} and
\code{get} function (internal use)}
}
\value{
a ggsurvplot class object
}
\description{
Given a \code{MultiOmicsPathway} class object, it plots Kaplan-Meier curves,
in which the strata corresponds to the chosen omics
}
\examples{
data(multiOmics)
data(reactSmall)

genesToUse <- row.names(multiOmics[[1]])

# Creating the MultiOmicsPathway object
MOP_survival <- multiOmicsSurvivalPathwayTest(multiOmics, reactSmall[[1]],
    survFormula = "Surv(days, status) ~", autoCompleteFormula = TRUE,
    useTheseGenes = genesToUse
)

plotPathwayKM(MOP_survival,
    formula = "Surv(days, status) ~ mut + expPC2",
    paletteNames = "Paired", inYears = TRUE
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/houseClip-pathway-relations.R
\name{id2name}
\alias{id2name}
\title{Convert id to pathway name}
\usage{
id2name(idList, namedVect)
}
\arguments{
\item{idList}{a list of pathway id}

\item{namedVect}{a named vector}
}
\value{
a character vector with the names
}
\description{
For internal use only. Retrieves name from pathway id.
}
\details{
You must provide a namedVect to be used as translator.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllMethods.R
\name{showModule}
\alias{showModule}
\title{A generic function showing pathway's module info}
\usage{
showModule(object)
}
\arguments{
\item{object}{an object of class \code{MultiOmicsModules}}
}
\value{
NULL. No value is returned
}
\description{
A generic function showing pathway's module info
}
\examples{
data(multiOmics)
data(reactSmall)

genesToUse <- row.names(multiOmics[[1]])

MOM_survival <- multiOmicsSurvivalModuleTest(multiOmics, reactSmall[[1]],
    survFormula = "Surv(days, status) ~", autoCompleteFormula = TRUE,
    useTheseGenes = genesToUse
)

showModule(MOM_survival)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PlottingMO.R
\name{plotModuleReport}
\alias{plotModuleReport}
\title{Plot a table of a \code{MultiOmicsModules} (MOM) object}
\usage{
plotModuleReport(
  modulesObj,
  MOcolors = NULL,
  priority_to = NULL,
  fontsize = 12,
  ...
)
}
\arguments{
\item{modulesObj}{\code{MultiOmicsModules} class object}

\item{MOcolors}{character vector with the omic colors.
The colors should be among the colors in \code{\link{showMOSpalette}}}

\item{priority_to}{a vector with the covariates (omic names) that should go
first}

\item{fontsize}{Size of the font to be used in the plot}

\item{...}{additional argument to be passed to pheatmap}
}
\value{
a Heatmap list object from ComplexHeatmap package of the results
contained in the \code{MultiOmicsModules} object provided
}
\description{
Given a \code{MultiOmicsModules} object, it plots its results in a
tabular fashion
}
\examples{
data(multiOmics)
data(reactSmall)

genesToUse <- row.names(multiOmics[[1]])

MOM_survival <- multiOmicsSurvivalModuleTest(multiOmics, reactSmall[[1]],
    survFormula = "Surv(days, status) ~", autoCompleteFormula = TRUE,
    useTheseGenes = genesToUse
)

plotModuleReport(MOM_survival,
    MOcolors = c(
        exp = "red", met = "green", mut = "blue",
        cnv = "yellow"
    )
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/supertest&frequencyplot.R
\name{pvalueSummary}
\alias{pvalueSummary}
\title{Compute pvalue Summary}
\usage{
pvalueSummary(multiPathwayReportData, excludeColumns = NULL, as.list = FALSE)
}
\arguments{
\item{multiPathwayReportData}{data.frame, the output of the
\code{\link{multiPathwayReport}} or \code{\link{multiPathwayModuleReport}}
functions.}

\item{excludeColumns}{a vector of characters listing the columns of
\code{multiPathwayReportData} object to be excluded by the analysis.
In the case \code{multiPathwayReportData} derives from
\code{\link{multiPathwayModuleReport}}
you should set \code{excludeColumns = c('pathway','module')}.}

\item{as.list}{return a list rather than a data.frame}
}
\value{
a list
}
\description{
Compute pvalue Summary
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/supertest&frequencyplot.R
\name{stripModulesFromPathways}
\alias{stripModulesFromPathways}
\title{Remove Module Number From Pathway Name}
\usage{
stripModulesFromPathways(pathways)
}
\arguments{
\item{pathways}{vector of pathway names}
}
\value{
list of pathway names without the module number
}
\description{
Function to remove the suffix corresponding to the module number of the
pathway name. Necessary step for \code{\link{annotePathwayToFather}} and
\code{\link{plotFrequencies}}
}
\examples{
pathwaysModules <- list(
    "Intrinsic Pathway for Apoptosis.1",
    "Intrinsic Pathway for Apoptosis.2",
    "Opioid Signalling.1", "Opioid Signalling.2"
)

resPathwayNames <- stripModulesFromPathways(pathwaysModules)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/supertest&frequencyplot.R
\name{summarizeOmicsResByMinPvalue}
\alias{summarizeOmicsResByMinPvalue}
\title{Summarize Omics Covaraites By Min Pvalue}
\usage{
summarizeOmicsResByMinPvalue(col, mat)
}
\arguments{
\item{col}{columns to extract from the line}

\item{mat}{the matrix to be summarized (were to extract lines and 'col')}
}
\value{
a summarized version of the matrix.
}
\description{
For internal use only. for each line extrac 'col' and get the minimum.
}
\examples{
# summarizeOmicsResByMinPvalue(2:3, mat=matrix(c(1,2,4,1,2,5), nrow=2))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/resamplingFunctions.R
\name{selectStablePathwaysModules}
\alias{selectStablePathwaysModules}
\alias{getPathwaysModulesSuccess}
\alias{addResamplingCounts}
\title{Select stable pathway modules}
\usage{
selectStablePathwaysModules(perms, moduleSummary, success = 90, col = "pvalue")

getPathwaysModulesSuccess(perms, moduleSummary, col = "pvalue", thr = 0.05)

addResamplingCounts(moduleSummary, resamplingCounts)
}
\arguments{
\item{perms}{a list. Result of resampling function}

\item{moduleSummary}{summary of modules or pathways obtained from
\code{multiPathwayModuleReport} or \code{multiPathwayReport}}

\item{success}{number of success to consider the pathway or module stable}

\item{col}{the name of the column in the summary to be used to evaluate
resampling success}

\item{thr}{the threshold for significance}

\item{resamplingCounts}{the counts of success obtained with
\code{getPathwaysModulesSuccess}}
}
\value{
the subset of stable modules

the counts of success for each pathway or module

a module or pathway summary with resampling counts column appended
}
\description{
Select stable pathway modules

Count the resampling success

Add resampling counts to module summary
}
\examples{
data("multiOmics")
data("reactSmall")

perms <- resamplingPathwaySurvival(multiOmics, reactSmall, nperm = 5)
res <- lapply(reactSmall, function(g) {
    multiOmicsSurvivalPathwayTest(multiOmics, g,
        useTheseGenes = row.names(multiOmics[[1]])
    )
})
pathSummary <- multiPathwayReport(res)
getPathwaysModulesSuccess(perms, pathSummary)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/houseClip-pca-covariance.R
\name{makePositiveDefinite}
\alias{makePositiveDefinite}
\title{Make positive and definite covariance matrix}
\usage{
makePositiveDefinite(m1, m2 = NULL, m3 = NULL, threshold = 0.1)
}
\arguments{
\item{m1}{matrix 1}

\item{m2}{matrix 2}

\item{m3}{matrix 3}

\item{threshold}{threshold of difference}
}
\value{
list with
\item{m1}{the matrix m1 positive and definite}
\item{m2}{the matrix m2 positive and definite}
\item{m3}{the matrix m3 positive and definite}
\item{correction}{the magneturde of the correction}
\item{value}{the value}
}
\description{
Make positive and definite covariance matrix
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PlottingMO.R
\name{plotModuleHeat}
\alias{plotModuleHeat}
\title{Plot a Heatmap of a Module by Omics}
\usage{
plotModuleHeat(
  moduleobj,
  moduleNumber,
  sortBy = NULL,
  paletteNames = NULL,
  additionalAnnotations = NULL,
  additionalPaletteNames = NULL,
  withSampleNames = TRUE,
  fontsize_row = 10,
  fontsize_col = 1,
  nrowsHeatmaps = 3,
  orgDbi = "org.Hs.eg.db",
  discr_prop_pca = 0.15,
  discr_prop_events = 0.05,
  ...
)
}
\arguments{
\item{moduleobj}{\code{MultiOmicsModule} class object}

\item{moduleNumber}{module number of interest}

\item{sortBy}{a covariate (omic) to sort by}

\item{paletteNames}{a palette containing three colors}

\item{additionalAnnotations}{optional additional sample annotations}

\item{additionalPaletteNames}{optional additional colors for annotations}

\item{withSampleNames}{show sample names}

\item{fontsize_row}{font size for row labels}

\item{fontsize_col}{font size for column labels}

\item{nrowsHeatmaps}{magnification respect to annotation of sample
(annotations take 1 row)}

\item{orgDbi}{a Dbi organism to be used. Default is \code{org.Hs.eg.db}}

\item{discr_prop_pca}{the minimal proportion to compute the PCA classes}

\item{discr_prop_events}{the minimal proportion to compute the event classes}

\item{...}{additional arguments passed to \code{guessInvolvement} function}
}
\value{
A heatmap of a pathway module (results of the module test)
}
\description{
It creates a heatmap of the most involved genes of each omic of a specific
module from a \code{MultiOmicsModule} object.
}
\examples{
data(multiOmics)
data(reactSmall)

survAnnot <- data.frame(
    status = multiOmics$status,
    days = multiOmics$days,
    row.names = colnames(multiOmics[[1]])
)

genesToUse <- row.names(multiOmics[[1]])

MOM_survival <- multiOmicsSurvivalModuleTest(multiOmics, reactSmall[[1]],
    survFormula = "Surv(days, status) ~", autoCompleteFormula = TRUE,
    useTheseGenes = genesToUse
)

plotModuleHeat(MOM_survival, 1,
    sortBy = c("mut", "expPC1", "status", "days"),
    additionalAnnotations = survAnnot,
    additionalPaletteNames = list(status = "teal", days = "violet"),
    withSampleNames = F
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{package}
\name{MOSClip}
\alias{MOSClip-package}
\alias{MOSClip}
\title{MOSClip: Multi-Omics Survival Clip}
\description{
\code{MOSClip} R package implements a statistical approach able to integrate
multi-omic data and look for survival associated gene modules. It
integrates multiple omics - trascriptomics, methylomics, genomic
mutations, and genomic copy number variations - using various data
dimensionality reduction strategies and multivariate models. Exploiting
graph theory, pathways can be decomposed into their connected
components, that we call modules. The analysis can then be performed at
the level of entire pathways or pathway modules. \code{MOSClip} pathway
analysis serves two primary purposes: testing the survival association
of pathways or modules using the Cox proportional hazard model, and
conducting a two-class analysis with a generalized linear model.
Additionally, the package offers valuable graphical tools to visualize
and interpret the results.
}
\details{
To conduct a multi-omic survival analysis on pathways or modules use:
\itemize{
\item \code{\link{multiOmicsSurvivalPathwayTest}}
\item \code{\link{multiOmicsSurvivalModuleTest}}
}

To perform a two-class comparison enrichment analysis on pathways or modules
use:
\itemize{
\item \code{\link{multiOmicsTwoClassPathwayTest}}
\item \code{\link{multiOmicsTwoClassModuleTest}}
}
}
\references{
Paolo Martini, Monica Chiogna, Enrica Calura,
and Chiara Romualdi. 2019. “MOSClip: Multi-Omic and Survival Pathway
Analysis for the Identification of Survival Associated Gene and Modules.”
Nucleic Acids Research 47 (14): e80. \url{https://doi.org/10.1093/nar/gkz324}
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/CaluraLab/MOSClip/}
  \item Report bugs at \url{https://github.com/CaluraLab/MOSClip/issues}
}

}
\author{
\strong{Maintainer}: Paolo Martini \email{paolo.martini@unibs.it} (\href{https://orcid.org/0000-0002-0146-1031}{ORCID})

Authors:
\itemize{
  \item Anna Bortolato \email{anna.bortolato@unipd.it} (\href{https://orcid.org/0009-0009-9327-6084}{ORCID})
  \item Anna Tanada \email{annacarolinaemi.delimatanada@phd.unipd.it} (\href{https://orcid.org/0000-0003-3224-0538}{ORCID})
  \item Enrica Calura \email{enrica.calura@unipd.it} (\href{https://orcid.org/0000-0001-8463-2432}{ORCID})
  \item Stefania Pirrotta \email{stefania.pirrotta@phd.unipd.it} (\href{https://orcid.org/0009-0004-0030-217X}{ORCID})
  \item Federico Agostinis \email{federico.agostinis@outlook.com}
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MOMGlmTest.R
\name{glmTest}
\alias{glmTest}
\title{Two-classes glm test.}
\usage{
glmTest(data, fullModelFormula, nullModelFormula)
}
\arguments{
\item{data}{data}

\item{fullModelFormula}{complete model}

\item{nullModelFormula}{null model formula}
}
\value{
Two-classes glm test results
}
\description{
Two-classes glm test.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PlottingMO.R
\name{plotModuleKM}
\alias{plotModuleKM}
\title{Plot Kaplan-Meier survival curves of a specific module}
\usage{
plotModuleKM(
  MOM,
  moduleNumber,
  formula = "Surv(days, status) ~ PC1",
  fileName = NULL,
  paletteNames = NULL,
  h = 9,
  w = 7,
  risk.table = TRUE,
  pval = TRUE,
  size = 1,
  inYears = FALSE,
  discr_prop_pca = 0.15,
  discr_prop_events = 0.05,
  additional_discrete = NULL,
  additional_continuous = NULL,
  ...
)
}
\arguments{
\item{MOM}{a \code{MultiOmicsModule} class object}

\item{moduleNumber}{numeric value. The module number of interest}

\item{formula}{a formula for the survival analysis. It should be written as
'Surv(days, status) ~ omic'. To plot more than one omic, write them
separated by a '+' character after the separator (~)}

\item{fileName}{optional filenames to save the plot}

\item{paletteNames}{a palette name to be used}

\item{h}{the height of the plot}

\item{w}{the width of the plot}

\item{risk.table}{logical value. If TRUE, shows the \code{risk.table}. Default
is TRUE.}

\item{pval}{logical value. If TRUE, shows the p-value of the curves. Default
is TRUE.}

\item{size}{line width of the KM curves}

\item{inYears}{set time in years}

\item{discr_prop_pca}{the minimal proportion to compute the PCA classes}

\item{discr_prop_events}{the minimal proportion to compute the event classes}

\item{additional_discrete}{names of the additional discrete variables to
include}

\item{additional_continuous}{names of the additional continous variables to
include}

\item{...}{additional arguments passed to \code{guessInvolvement} and \code{get}
function}
}
\value{
a ggsurvplot class object
}
\description{
Given a \code{MultiOmicsModule} class object and a specific module number, it
plots Kaplan-Meier curves, in which the strata corresponds to the omics
}
\examples{
data(multiOmics)
data(reactSmall)

genesToUse <- row.names(multiOmics[[1]])

MOM_survival <- multiOmicsSurvivalModuleTest(multiOmics, reactSmall[[1]],
    survFormula = "Surv(days, status) ~", autoCompleteFormula = TRUE,
    useTheseGenes = genesToUse
)

plotModuleKM(MOM_survival, 1,
    formula = "Surv(days, status) ~ mut + expPC2",
    paletteNames = "Paired", inYears = TRUE
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllMethods.R
\name{convertPathway}
\alias{convertPathway}
\title{A generic function to convert pathway}
\usage{
convertPathway(graph, useTheseGenes)
}
\arguments{
\item{graph}{a graphNEL object}

\item{useTheseGenes}{list of genes to be used}
}
\value{
NULL. No value is returned
}
\description{
A generic function to convert pathway
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Utils.R
\name{createDataModule}
\alias{createDataModule}
\title{Create Data Module}
\usage{
createDataModule(omic, multiOmicObj)
}
\arguments{
\item{omic}{modulesView or pathView object}

\item{multiOmicObj}{object of class 'Omics'}
}
\value{
matrix, genes in the rows, samples in the columns
}
\description{
Extract sub-matrix for the genes of a module or pathway from data matrix of
a specific omic
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PlottingMO.R
\name{plotModuleInGraph}
\alias{plotModuleInGraph}
\title{Plot a Directed Graph of the MultiOmicsModules Object}
\usage{
plotModuleInGraph(
  modulesobj,
  pathList,
  moduleNumber,
  orgDbi = "org.Hs.eg.db",
  paletteNames = NULL,
  legendLabels = NULL,
  fileName = NULL,
  discr_prop_pca = 0.15,
  discr_prop_events = 0.05,
  pathTitle = NULL,
  ...
)
}
\arguments{
\item{modulesobj}{a \code{MultiOmicsModule} class object}

\item{pathList}{a \code{PathwayList} from \code{graphite} package that contains the
pathways to be used}

\item{moduleNumber}{a module number}

\item{orgDbi}{if needed, indicates an organism Dbi to translate the vectors}

\item{paletteNames}{named vector of MOSpalettes, names replace makeLegend
arguments}

\item{legendLabels}{set up your favourite names for the omics}

\item{fileName}{optional filenames to save the plot}

\item{discr_prop_pca}{the minimal proportion to compute the PCA classes}

\item{discr_prop_events}{the minimal proportion to compute the event classes}

\item{pathTitle}{title of the graph, to be searched in \code{pathList}}

\item{...}{additional arguments passed to \code{guessInvolvement} function}
}
\value{
a MOSClip plot in form of a list class object
}
\description{
From a \code{MultiOmicsModules} object, it plots the position of a given module
in the pathway. The omics are also represented in the graph.
}
\examples{
data(multiOmics)
data(reactSmall)

genesToUse <- row.names(multiOmics[[1]])

MOM_survival <- multiOmicsSurvivalModuleTest(multiOmics, reactSmall[[1]],
    survFormula = "Surv(days, status) ~", autoCompleteFormula = TRUE,
    useTheseGenes = genesToUse
)

plotModuleInGraph(MOM_survival, reactSmall,
    moduleNumber = 1,
    paletteNames = c(exp = "red", met = "green", 
                     mut = "blue", cnv = "yellow")
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/resamplingFunctions.R
\name{resamplingModulesSurvival}
\alias{resamplingModulesSurvival}
\alias{resamplingPathwaySurvival}
\title{Resampling function for survival analysis on modules}
\usage{
resamplingModulesSurvival(
  fullMultiOmics,
  pathdb,
  nperm = 100,
  pathwaySubset = NULL,
  nPatients = 3,
  genesToConsider = NULL
)

resamplingPathwaySurvival(
  fullMultiOmics,
  pathdb,
  nperm = 100,
  pathwaySubset = NULL,
  nPatients = 3,
  genesToConsider = NULL
)
}
\arguments{
\item{fullMultiOmics}{a multiOmic object}

\item{pathdb}{pathway database}

\item{nperm}{number of permutations}

\item{pathwaySubset}{a list of pathways to resample}

\item{nPatients}{number of patients to remove for resampling}

\item{genesToConsider}{vector of genes used to filter pathways; if NULL,
genes found in the first experiment of the multiOmic object are used}
}
\value{
list of the resampling tables of results

list of the resampling tables of results
}
\description{
Resampling function for survival analysis on modules

Resampling function for pathways (survival analysis)
}
\examples{
data(multiOmics)
data(reactSmall)

perms <- resamplingModulesSurvival(
    fullMultiOmics = multiOmics, reactSmall,
    nperm = 10,
    pathwaySubset =
        "FGFR1 mutant receptor activation"
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/supertest&frequencyplot.R
\name{minOrNA}
\alias{minOrNA}
\title{Minimum or NA}
\usage{
minOrNA(x)
}
\arguments{
\item{x}{a numeric}
}
\value{
a numeric. The minimum or NA
}
\description{
For internal use only. Get back minimum or NA.
}
\examples{
# minOrNA(c(1,5,0.1,NA))
# minOrNA(c(NA,NA,NA))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/supertest&frequencyplot.R
\name{runSupertest}
\alias{runSupertest}
\title{Performs a Exact test - analysis of omics intersection}
\usage{
runSupertest(
  multiPathwayReportData,
  pvalueThr = 0.05,
  zscoreThr = 0.05,
  resampligThr = NULL,
  plot = c("circular", "landscape", "noplot"),
  sort.by = c("set", "size", "degree", "p-value"),
  excludeColumns = NULL,
  color.on = "#f6bb42",
  color.off = "#D3D3D3"
)
}
\arguments{
\item{multiPathwayReportData}{data.frame, the output of the
\code{\link{multiPathwayReport}} or \code{\link{multiPathwayModuleReport}}
functions.}

\item{pvalueThr}{numeric value. Overall pvalue cut-off to be used}

\item{zscoreThr}{numeric value. Covariates coefficient cut-off to be used.}

\item{resampligThr}{numeric value. Filters the modules according to the
number of success in the resampling procedure, takes only the modules above
this threshold.}

\item{plot}{character indicating the layout for plotting. It is one of
\code{circular}, \code{landscape} or \code{noplot}. By default,
plot='circular', if plot='noplot' no plot will be provided.}

\item{sort.by}{character indicating how to sort the
intersections in the plot. It is one of 'set' (by omics), 'size'
(by intersection size), 'degree' (by number of intersected omics),
and 'p-value'.}

\item{excludeColumns}{a vector of characters listing the columns of
\code{multiPathwayReportData} object to be excluded by the analysis.
In the case \code{multiPathwayReportData} derives from
\code{\link{multiPathwayModuleReport}}
you should set \code{excludeColumns = c('pathway','module')}.}

\item{color.on}{color that represent the active omics in the sector}

\item{color.off}{color that represent the omics mnot considered in the
sector}
}
\value{
a data.frame containing all the numeric information of the plot
included the pathways shared by different omics.
}
\description{
This function performs a exact test implementing a theorical framework using
the SuperExactTest package. It calculates the statistical distributions of
multi omics set intersections. It can be used with both a MultiOmicsModules
or MultiOmicsPathway class objects.
}
\details{
This function calculates intersection sizes between multiple set of
pathways or modules and performs statistical test of the intersections using
the total amout of analyzed pathways or modules as background. The super
exact test of this function was described in Wang et al 2015.
}
\examples{
df <- data.frame(
    pvalue = c(0.06, 0.04, 0.04, 0.03, 0.02),
    cnv = c(0.07, 0.03, 0.02, 0.04, 0.01),
    mut = c(0.08, 0.02, 0.01, 0.04, 0.04),
    row.names = c(
        "PathwayA", "PathwayB", "PathwayC",
        "PathwayD", "PathwayE"
    )
)

runSupertest(df, pvalueThr = 0.05, zscoreThr = 0.05)

}
\references{
Minghui Wang, Yongzhong Zhao, and Bin Zhang (2015).
Efficient Test and Visualization of Multi-Set Intersections.
Scientific Reports 5: 16923.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/supertest&frequencyplot.R
\name{plotFrequencies}
\alias{plotFrequencies}
\title{Plot Frequencies of Pathway Fathers for Omics intersection}
\usage{
plotFrequencies(
  frequencies,
  manualColors = NULL,
  minSize = 4,
  maxSize = 20,
  width = 20,
  relMagnificationOfLegend = 0.5,
  lineSize = 1
)
}
\arguments{
\item{frequencies}{a data.frame created from 'computeFreqs'}

\item{manualColors}{optional vector of colors to be used}

\item{minSize}{the minimal font size. Maximal frequencies will be added for
each class}

\item{maxSize}{the maximal font size dimension, all values above are clipped}

\item{width}{the number of character to wrap the labels}

\item{relMagnificationOfLegend}{the relative magnification of the text of the
legend}

\item{lineSize}{the thickness of the lines}
}
\value{
a circular plot of the frequencies of pathway fathers
}
\description{
Plots the frequencies of the pathway fathers by every omics intersection
from a data.frame of the frequencies returned with the function
\code{\link{computeFreqs}}.
}
\examples{
df <- data.frame(
    category = c("PathwayA", "PathwayB", "PathwayC", "PathwayD"),
    frequencies = c(1, 2, 1, 3),
    class = rep("Mut", 4), stringsAsFactors = FALSE
)
plotFrequencies(df)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extractSummary.R
\name{extractSummaryFromBinary}
\alias{extractSummaryFromBinary}
\title{Extract Summary Binary from MultiOmics Objects}
\usage{
extractSummaryFromBinary(omic, multiOmicObj, n = 3)
}
\arguments{
\item{omic}{a summarized omic}

\item{multiOmicObj}{\code{Omics} object}

\item{n}{maximum number of features to retrieve}
}
\value{
Meant for internal use only. The summary for omic summarized
using binary events.
\item{sigModule}{the original data for significant features}
\item{discrete}{the discrete version of the significant covariates converted
(when needed) into the discrete version}
\item{subset}{data.frame(row.names=names(topGenes), cov=sum binary events)}
\item{covsConsidered}{the name of the considered omic}
}
\description{
Given an omic summarized by 'summarizeToBinaryEvents' extract the most
important features.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/resamplingFunctions.R
\name{checkOrder}
\alias{checkOrder}
\alias{resolveAndOrder}
\alias{mergeCol}
\alias{filterExpr}
\alias{filterMultiOmicsForSamples}
\alias{preparePerms}
\title{Check if all the list object have the same order of pathway module}
\usage{
checkOrder(li)

resolveAndOrder(li)

mergeCol(li, col = "PC1", resolve = FALSE)

filterExpr(exp, samples)

filterMultiOmicsForSamples(MO, samples)

preparePerms(fullMultiOmics, nperm = 100, nPatients = 3)
}
\arguments{
\item{li}{a list of summaries}

\item{col}{the column to merge}

\item{resolve}{weather to resolve the issues}

\item{exp}{a matrix}

\item{samples}{the vector of samples to select}

\item{MO}{a multiOmic object}

\item{fullMultiOmics}{a multiOmic object}

\item{nperm}{number of permutations}

\item{nPatients}{number of patients to remove for resampling}
}
\value{
a matrix

a filtered matrix

a filtered MultiOmics objects

list of sampled patients for each permutation
}
\description{
For internal use only

For internal use only

For internal use only

For internal use only

For internal use only

Prepare subset of patients for permutations
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/survClip-backbone.R
\name{survivalcox}
\alias{survivalcox}
\title{Cox Model Analysis}
\usage{
survivalcox(coxObj, formula)
}
\arguments{
\item{coxObj}{data.frame: patients x covariates}

\item{formula}{formula to use}
}
\value{
A list with
\item{pvalue}{pvalue of the model}
\item{zlist}{pvalues of single covariates}
\item{coxObj}{the original coxObj passed to the function}
}
\description{
Cox Analysis
}
\details{
For internal use only
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/multiOmicsGlmTest.R
\name{multiOmicsTwoClassPathwayTest}
\alias{multiOmicsTwoClassPathwayTest}
\title{Compute Multi Omics Two-Class in Pathways}
\usage{
multiOmicsTwoClassPathwayTest(
  omicsObj,
  graph,
  classAnnot,
  baseFormula = "classes ~ ",
  autoCompleteFormula = TRUE,
  useTheseGenes = NULL,
  nullModel = "classes ~ 1",
  pathName = NULL
)
}
\arguments{
\item{omicsObj}{object of class \code{Omics}}

\item{graph}{a pathway as a \code{graphNEL} object.}

\item{classAnnot}{a \code{data.frame} with the class annotation. It is necessary
at least a column with the classes labels, and the row.names as the samples
labels}

\item{baseFormula}{model formula to be used for the test. It should be
written as 'classes ~ ', while 'classes' being the column name for the class
labels}

\item{autoCompleteFormula}{a logical value. If TRUE. It autocompletes the
formula used to fit generalized lienar models function  using all the
available covariates (omics)}

\item{useTheseGenes}{(optional) vector of specific genes to be used}

\item{nullModel}{the null model formula. It should be written the same as
the baseFormula, followed by ' 1'. (e.g. 'classes ~ 1')}

\item{pathName}{(optional) title of the pathway. If NULL, \code{graph@title} is
used as title}
}
\value{
\code{MultiOmicsPathway} object
}
\description{
Performs topological two-class analysis using an \code{Omics} object.
}
\examples{
data("multiOmics")
data("reactSmall")

genesToUse <- row.names(multiOmics[[1]])

classAnnot <- data.frame(
    "treatment" = c(rep("A", 25), rep("B", 25)),
    row.names = colnames(multiOmics[[1]])
)

MOP_twoClasses <- multiOmicsTwoClassPathwayTest(
    multiOmics, reactSmall[[1]], classAnnot,
    baseFormula = "treatment ~ ", nullModel = "treatment ~ 1",
    useTheseGenes = genesToUse
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/supertest&frequencyplot.R
\name{computeFreqs}
\alias{computeFreqs}
\title{Compute Frequencies in a Named List}
\usage{
computeFreqs(elementsIntersections)
}
\arguments{
\item{elementsIntersections}{a named list}
}
\value{
a data.frame of the frequencies
}
\description{
Compute frequencies in a named list. This function is necessary for
\code{\link{plotFrequencies}}, in which it will calculate the frequency of
each pathway father for every omics intersection.
}
\examples{
omicsIntersection <- list(
    "exp;met" = c("PathwayA", "PathwayB", "PathwayC"),
    "exp;mut" = c("PathwayA", "PathwayC"),
    "cnv;mut" = c("PathwayB")
)
freqDf <- computeFreqs(omicsIntersection)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllMethods.R
\name{makeOmics}
\alias{makeOmics}
\title{Omics class initializer function}
\usage{
makeOmics(
  experiments = ExperimentList(),
  colData = S4Vectors::DataFrame(),
  sampleMap = S4Vectors::DataFrame(assay = factor(), primary = character(), colname =
    character()),
  metadata = list(),
  drops = list(),
  modelInfo = character(),
  specificArgs = list()
)
}
\arguments{
\item{experiments}{A \code{list} or \link{ExperimentList} of all
combined experiments}

\item{colData}{A \code{\linkS4class{DataFrame}} or \code{data.frame} of
characteristics for all biological units}

\item{sampleMap}{A \code{DataFrame} or \code{data.frame} of assay names,
sample identifiers, and colname samples}

\item{metadata}{An optional argument of 'ANY' class (usually list) for
content describing the experiments}

\item{drops}{A \code{list} of unmatched information
(included after subsetting)}

\item{modelInfo}{A list with length equal to length(data) that are modelInfo
to process each dataset}

\item{specificArgs}{a list with length equal to length(data) to set
additional parameters specific of the modelInfo}
}
\value{
an \code{Omics} class object
}
\description{
makeOmics creates the \code{Omics} object necessary to perform most of the
analyses of this package. It contains all the omics data in the format of a
\code{ExperimentList}, the clinical data, and all the information necessary for
the dimensionality reduction step.
}
\examples{
data(ovarianDataset)

myColData <- data.frame(
    status = sample(c(0, 1), 50, replace = TRUE),
    days = sample(c(0, 500), 50, replace = TRUE),
    row.names = colnames(ovarianDataset$exp)
)

myOmicsObj <- makeOmics(
    experiments = ovarianDataset,
    colData = myColData,
    modelInfo = c(
        "summarizeWithPca",
        "summarizeInCluster",
        "summarizeToNumberOfEvents",
        "summarizeToNumberOfDirectionalEvents"
    ),
    specificArgs = list(
        pcaArgs = list(
            name = "exp", shrink = "FALSE",
            method = "sparse", maxPCs = 3
        ),
        clusterArgs = list(
            name = "met",
            max_cluster_number = 3
        ),
        countEvent = list(name = "mut", min_prop = 0.05),
        cnvAgv = list(name = "cnv", min_prop = 0.05)
    )
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/houseClip-pathway-relations.R
\name{getPathFathers}
\alias{getPathFathers}
\title{Retrieves pathways relatives}
\usage{
getPathFathers(pathway, hierarchyGraph, ord = 3, plot = FALSE)
}
\arguments{
\item{pathway}{a pathway id}

\item{hierarchyGraph}{a igraph with pathway hierarchy}

\item{ord}{how far you need to go backward}

\item{plot}{plot relatives. For checking purpose}
}
\value{
a character vector with the relatives
}
\description{
For internal use only. Retrieves relatives given a pathway id.
}
\details{
Pathway Hierarchy is needed as igraph object.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PlottingMO.R
\name{plotPathwayHeat}
\alias{plotPathwayHeat}
\title{Plot heatmaps of the pathway by omics}
\usage{
plotPathwayHeat(
  pathway,
  sortBy = NULL,
  paletteNames = NULL,
  additionalAnnotations = NULL,
  additionalPaletteNames = NULL,
  discr_prop_pca = 0.15,
  discr_prop_events = 0.05,
  withSampleNames = TRUE,
  nrowsHeatmaps = 3,
  orgDbi = "org.Hs.eg.db",
  ...
)
}
\arguments{
\item{pathway}{\code{MultiOmicsPathway} class object}

\item{sortBy}{one or more covariates to sort the samples}

\item{paletteNames}{name of the colors for each omic}

\item{additionalAnnotations}{optional additional sample annotations
(e.g. survival annotation)}

\item{additionalPaletteNames}{colors for additional annotations. The colors
available are the ones in \code{\link{showMOSpalette}}}

\item{discr_prop_pca}{the minimal proportion to compute the PCA classes}

\item{discr_prop_events}{the minimal proportion to compute the event classes}

\item{withSampleNames}{show the sample names in the plot}

\item{nrowsHeatmaps}{magnification respect to annotation of sample
(annotations take 1 row)}

\item{orgDbi}{a Dbi organism to be used. Default is \code{org.Hs.eg.db}}

\item{...}{additional arguments passed to \code{guessInvolvementPathway} function
(internal use)}
}
\value{
An object of class \code{ggplot} plotted with ComplexHeatMap package.
}
\description{
Given the pathway, it creates the heatmaps of the mostly involved genes for
each omic.
}
\examples{
data(multiOmics)
data(reactSmall)

genesToUse <- row.names(multiOmics[[1]])

survAnnot <- data.frame(
    status = multiOmics$status,
    days = multiOmics$days,
    row.names = colnames(multiOmics[[1]])
)

# Creating the MultiOmicsPathway object
MOP_survival <- multiOmicsSurvivalPathwayTest(multiOmics, reactSmall[[1]],
    survFormula = "Surv(days, status) ~", autoCompleteFormula = TRUE,
    useTheseGenes = genesToUse
)

# Plotting
plotPathwayHeat(MOP_survival,
    sortBy = c("expPC2", "mut", "status", "days"),
    paletteNames = c(exp = "red", met = "green", 
                     mut = "blue", cnv = "yellow"),
    additionalAnnotations = survAnnot,
    additionalPaletteNames = list(status = "teal", days = "violet"),
    nrowsHeatmaps = 2, withSampleNames = F
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Utils.R
\name{createMOMView}
\alias{createMOMView}
\title{Create the list of covariates that are going to be tested}
\usage{
createMOMView(omicsObj, genes)
}
\arguments{
\item{omicsObj}{\code{Omics} class object}

\item{genes}{genes of the clique}
}
\value{
list with
1 reduced representation of the omics
2 sdev
3 loadings or eigenvector
4 usedGenes
5 method
6 namesCov
7 omicName
}
\description{
Create the list of covariates that are going to be tested
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R, R/AllMethods.R
\docType{class}
\name{Omics-class}
\alias{Omics-class}
\alias{Omics}
\alias{showOmics,Omics-method}
\title{Omics.}
\usage{
\S4method{showOmics}{Omics}(object)
}
\arguments{
\item{object}{an object of class \code{Omics}}
}
\description{
This class is the storage for the different omic datasets that we need to
analyze. It is based on \code{MultiAssayExperiment}.
}
\section{Methods (by generic)}{
\itemize{
\item \code{showOmics(Omics)}: shows model parameters

}}
\section{Slots}{

\describe{
\item{\code{modelInfo}}{a list with length equal to length(data) that are modelInfo
to process each dataset.}

\item{\code{specificArgs}}{a list with length equal to length(data) to set
additional parameters specific of the modelInfo.}
}}
